/*
SQLyog Ultimate v12.4.3 (64 bit)
MySQL - 10.1.21-MariaDB : Database - hrmis_v2
*********************************************************************
*/

/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`hrmis_v2` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `hrmis_v2`;

/*Table structure for table `attd_object_group` */

DROP TABLE IF EXISTS `attd_object_group`;

CREATE TABLE `attd_object_group` (
  `group_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `ref_code` varchar(40) NOT NULL,
  `description` varchar(120) DEFAULT NULL,
  `start_date` date NOT NULL,
  `end_date` date DEFAULT NULL,
  PRIMARY KEY (`group_id`),
  KEY `fk_objgrp_grp_idx` (`ref_code`),
  CONSTRAINT `fk_objgrp_grp` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_object_group_member` */

DROP TABLE IF EXISTS `attd_object_group_member`;

CREATE TABLE `attd_object_group_member` (
  `group_member_id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `ref_code` varchar(40) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `start_date` date NOT NULL,
  `end_date` date DEFAULT NULL,
  `last_update_dtm` datetime NOT NULL,
  `update_by` int(11) NOT NULL,
  PRIMARY KEY (`group_member_id`),
  KEY `fk_objgrpm_grp_idx` (`group_id`),
  KEY `fk_objgrpm_ref_idx` (`ref_code`),
  CONSTRAINT `fk_objgrpm_grp` FOREIGN KEY (`group_id`) REFERENCES `attd_object_group` (`group_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_objgrpm_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_object_group_timetable` */

DROP TABLE IF EXISTS `attd_object_group_timetable`;

CREATE TABLE `attd_object_group_timetable` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `object_group_id` int(11) NOT NULL,
  `timetable_id` int(11) NOT NULL,
  `start_date` date NOT NULL,
  `end_date` date NOT NULL,
  `applied_status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0=init/not applied; 1=applied; ',
  `applied_on` datetime DEFAULT NULL,
  `applied_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ogtt_og_idx` (`object_group_id`),
  KEY `fk_ogtt_tt_idx` (`timetable_id`),
  CONSTRAINT `fk_ogtt_og` FOREIGN KEY (`object_group_id`) REFERENCES `attd_object_group` (`group_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_ogtt_tt` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_reference` */

DROP TABLE IF EXISTS `attd_reference`;

CREATE TABLE `attd_reference` (
  `reference_id` smallint(4) NOT NULL AUTO_INCREMENT,
  `code` varchar(40) NOT NULL,
  `description` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`reference_id`),
  UNIQUE KEY `code_UNIQUE` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request` */

DROP TABLE IF EXISTS `attd_request`;

CREATE TABLE `attd_request` (
  `request_id` int(11) NOT NULL AUTO_INCREMENT,
  `ref_code` varchar(40) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `start_dtm` datetime NOT NULL,
  `end_dtm` datetime DEFAULT NULL,
  `request_type` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = attendance; 2 = overtime',
  `request_dtm` datetime NOT NULL,
  `status_id` tinyint(4) NOT NULL DEFAULT '1',
  `request_message` tinytext NOT NULL,
  PRIMARY KEY (`request_id`),
  KEY `fk_attdreq_ref_idx` (`ref_code`),
  KEY `fk_attdreq_status_idx` (`status_id`),
  CONSTRAINT `fk_attdreq_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
  CONSTRAINT `fk_attdreq_status` FOREIGN KEY (`status_id`) REFERENCES `attd_request_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request_approval` */

DROP TABLE IF EXISTS `attd_request_approval`;

CREATE TABLE `attd_request_approval` (
  `approval_id` int(11) NOT NULL AUTO_INCREMENT,
  `request_id` int(11) NOT NULL,
  `ref_code` varchar(40) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `status_id` tinyint(4) NOT NULL DEFAULT '1',
  `approval_dtm` datetime NOT NULL,
  `reason` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`approval_id`),
  KEY `fk_reqappr_req_idx` (`request_id`),
  KEY `fk_reqappr_ref_idx` (`ref_code`),
  KEY `fk_reqappr_status_idx` (`status_id`),
  CONSTRAINT `fk_reqappr_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
  CONSTRAINT `fk_reqappr_req` FOREIGN KEY (`request_id`) REFERENCES `attd_request` (`request_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_reqappr_status` FOREIGN KEY (`status_id`) REFERENCES `attd_request_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request_setting` */

DROP TABLE IF EXISTS `attd_request_setting`;

CREATE TABLE `attd_request_setting` (
  `setting_id` smallint(6) NOT NULL AUTO_INCREMENT,
  `num_to_approve` tinyint(2) NOT NULL DEFAULT '1' COMMENT 'max number of persons to request',
  `min_approved` tinyint(2) NOT NULL DEFAULT '1' COMMENT 'minimal person to approve tobe approved;\n0 = all',
  `min_rejected` tinyint(2) DEFAULT '0' COMMENT 'minimal person to approve tobe rejected\n0 = all',
  `start_date` date NOT NULL,
  `end_date` date DEFAULT NULL,
  PRIMARY KEY (`setting_id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request_setting_approval_type` */

DROP TABLE IF EXISTS `attd_request_setting_approval_type`;

CREATE TABLE `attd_request_setting_approval_type` (
  `approval_type_id` tinyint(4) NOT NULL,
  `name` varchar(40) NOT NULL,
  `description` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`approval_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request_setting_detail` */

DROP TABLE IF EXISTS `attd_request_setting_detail`;

CREATE TABLE `attd_request_setting_detail` (
  `detail_id` int(11) NOT NULL AUTO_INCREMENT,
  `setting_id` smallint(6) NOT NULL,
  `seq` tinyint(4) DEFAULT NULL,
  `approval_type_id` tinyint(4) NOT NULL,
  `type_value` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`detail_id`),
  KEY `fk_attdreqset_set_idx` (`setting_id`),
  KEY `fk_attdreqset_apprtype_idx` (`approval_type_id`),
  CONSTRAINT `fk_attdreqset_apprtype` FOREIGN KEY (`approval_type_id`) REFERENCES `attd_request_setting_approval_type` (`approval_type_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_attdreqset_set` FOREIGN KEY (`setting_id`) REFERENCES `attd_request_setting` (`setting_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_request_status` */

DROP TABLE IF EXISTS `attd_request_status`;

CREATE TABLE `attd_request_status` (
  `status_id` tinyint(4) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  PRIMARY KEY (`status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_source_type` */

DROP TABLE IF EXISTS `attd_source_type`;

CREATE TABLE `attd_source_type` (
  `id` tinyint(4) NOT NULL AUTO_INCREMENT,
  `source_type_code` varchar(20) NOT NULL,
  `description` varchar(80) DEFAULT NULL,
  `start_date` date NOT NULL,
  `end_date` date DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `source_type_code_UNIQUE` (`source_type_code`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_timetable` */

DROP TABLE IF EXISTS `attd_timetable`;

CREATE TABLE `attd_timetable` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(64) DEFAULT NULL,
  `name` varchar(64) NOT NULL,
  `on_duty_time` time NOT NULL,
  `off_duty_time` time NOT NULL,
  `in_beginning_time` time NOT NULL,
  `in_ending_time` time NOT NULL,
  `out_beginning_time` time NOT NULL,
  `out_ending_time` time NOT NULL,
  `late_time` varchar(4) DEFAULT '0',
  `leave_early_time` varchar(4) DEFAULT '0',
  `overtime_start_time` time NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `u_code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*Table structure for table `attd_timetable_object` */

DROP TABLE IF EXISTS `attd_timetable_object`;

CREATE TABLE `attd_timetable_object` (
  `object_id` int(11) NOT NULL AUTO_INCREMENT,
  `timetable_id` int(11) NOT NULL,
  `ref_code` varchar(40) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `start_date` date NOT NULL,
  `end_date` date DEFAULT NULL,
  `last_update` datetime NOT NULL,
  `update_by` int(11) NOT NULL,
  PRIMARY KEY (`object_id`),
  KEY `fk_ttobj_tt_idx` (`timetable_id`),
  KEY `fk_ttobj_ref_idx` (`ref_code`),
  CONSTRAINT `fk_ttobj_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
  CONSTRAINT `fk_ttobj_tt` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=53 DEFAULT CHARSET=latin1;

/*Table structure for table `attendance` */

DROP TABLE IF EXISTS `attendance`;

CREATE TABLE `attendance` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = workday attendance; 2 = holiday attendance',
  `start_dtm` datetime NOT NULL,
  `start_description` varchar(120) DEFAULT NULL,
  `end_dtm` datetime DEFAULT NULL,
  `end_description` varchar(120) DEFAULT NULL,
  `ref_code` varchar(40) NOT NULL,
  `ref_id` int(11) NOT NULL,
  `source_type_code` varchar(10) NOT NULL,
  `source_reference` varchar(40) NOT NULL,
  `source_dtm` datetime NOT NULL,
  `overtime_start_dtm` datetime DEFAULT NULL,
  `overtime_end_dtm` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_attd_srctype_idx` (`source_type_code`),
  KEY `idx_attd_ref` (`ref_code`,`ref_id`),
  KEY `fk_attd_ref_idx` (`ref_code`),
  CONSTRAINT `fk_attd_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
  CONSTRAINT `fk_attd_srctype` FOREIGN KEY (`source_type_code`) REFERENCES `attd_source_type` (`source_type_code`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
