<?php
namespace Neuron\Sample\Attendance;   //namespace

use Zend\Mvc\ModuleRouteListener;
use Zend\Mvc\MvcEvent;
use \Zend\I18n\Translator\TranslatorInterface;

class Module {

    public function onBootstrap(MvcEvent $e) {

        $eventManager = $e->getApplication()->getEventManager();
        $moduleRouteListener = new ModuleRouteListener();
        $moduleRouteListener->attach($eventManager);

        // $translator = $e->getApplication()->getServiceManager()->get('translator');
        // $translator->setLocale(\Locale::acceptFromHttp($_SERVER['HTTP_ACCEPT_LANGUAGE']))
        //     ->setFallbackLocale('id_ID');

    }

    public function getConfig() {

        /* load global config */
        if (file_exists(__DIR__ . '/config/autoload/global.php')) {
            $global = include(__DIR__ . '/config/autoload/global.php');
        } else {
            $global = array();
        }
        /* return config */
        if (is_array($global)) {
            return array_merge_recursive($global, include(__DIR__ . '/config/module.config.php'));
        } else {
            return include(__DIR__ . '/config/module.config.php');
        }
    }

    public function getAutoloaderConfig() {

        /* Definisikan autoloader untuk controller spesifik aplikasi dan model aplikasi */
        return array(
            'Zend\Loader\StandardAutoloader' => array(
                'namespaces' => array(
                    __NAMESPACE__ . '\Controller' => __DIR__ . '/controller',
                    __NAMESPACE__ => __DIR__ . '/model',
                ),
            ),
        );
    }

}

/* end Module class */