<?php
return array(

    /* konfigurasi service manager, belum digunakan */
    'service_manager' => array(
        'abstract_factories' => array(
            'Zend\Cache\Service\StorageCacheAbstractServiceFactory',
            'Zend\Log\LoggerAbstractServiceFactory',
        ),
        'aliases' => array(
            'translator' => 'MvcTranslator',
        ),
    ),

    /* konfigurasi translator bahasa */
    'translator' => array(
        'locale' => 'en_US', // default
        'translation_file_patterns' => array(
            array(
                'type' => 'gettext',
                'base_dir' => __DIR__ . '/../language', /* lokasi file-file bahasa */
                'pattern' => '%s.mo',
            ),
        ),
    ),

    /* konfigurasi view manager */
    'view_manager' => array(
        'display_not_found_reason' => true,
        'display_exceptions' => true,
        'doctype' => 'HTML5',
        'not_found_template' => 'error/404',
        'exception_template' => 'error/index',
        'template_map' => array(
            'error/404' => __DIR__ . '/../../view/error/404.phtml',
            'error/index' => __DIR__ . '/../../view/error/index.phtml',
        ),
        'template_path_stack' => array(
            __DIR__ . '/../../view',
        ),
    ),

    /* PHP config -- bisa digunakan untuk konfigurasi php.ini ini_set() */
    'php' => array(
        'display_errors' => true,
        'error_reporting' => E_ALL,
    ),

    /* konfigurasi aplikasi */
    'application' => array(
        'config' => 'neuron',
    ),

    /* konfigurasi spesifik aplikasi */
    'neuron' => array(
        /* db config */
        'databases' => array(

            // 'primary' => array(
            //     'driver' => 'Pdo',
            //     'host' => '103.16.198.40',
            //     'username' => 'hrmis',
            //     'password' => 'Neuron$Hrmis2016',
            //     'schema' => 'doorv2_dev',
            //     'schemas' => array(
            //          '\\' => 'doorv2_dev'
            //      ),
            // ),
            // 'primary' => array(
            //     'driver' => 'Pdo',
            //     'host' => 'localhost',
            //     'username' => 'root',
            //     'password' => '',
            //     'schema' => 'db_agung',
            //     'schemas' => array(
            //         '\\' => 'db_agung'
            //     ),
            // ),
            
            'secondary' => array(
                'driver' => 'Oci8',
                'host' => 'public.neuron.id',
                'port' => 1521,
                'username' => 'neuron',
                'password' => 'neuron',
                'schema' => 'neuron',
                'schemas' => array(
                    '\\' => 'neuron',
                ),
            ),
        ), //db

        /* table mapping */
        'tables' => array(
            'config' => 'zlib_config',
            'users' => 'act_users',
            'user_status'=>'act_user_statuses',

            'access_grant_types' => 'acc_access_grant_types',
            'access_grants' => 'acc_access_grants',
            'access_object_types' => 'acc_access_object_types',
            'access_objects' => 'acc_access_objects',
            'access_permissions' => 'acc_access_permissions',
            'access_roles' => 'acc_access_roles',
            'sessions' => 'acc_sessions',


            'attendance'=>'attendance',
            // 'attd_timetable_object'=>'attd_timetable_object',
            // 'attd_timetable'=>'attd_timetable',
            'attd_source_type'=>'attd_source_type',
            'attd_request_status'=>'attd_request_status',
            'attd_request_setting_detail'=>'attd_request_setting_detail',
            'attd_request_setting_approval_type'=>'attd_request_setting_approval_type',
            'attd_request_setting'=>'attd_request_setting',
            'attd_request_approval'=>'attd_request_approval',
            'attd_request_type'=>'attd_request_type',
            'attd_request'=>'attd_request',
            'attd_reference'=>'attd_reference',
            'attd_object_group_timetable'=>'attd_object_group_timetable',
            'attd_object_group_member'=>'attd_object_group_member',
            'attd_object_group'=>'attd_object_group',

            //enhance timetable
            'attd_timetable'=>'attd_timetable',
            'attd_timetable_object'=>'attd_timetable_object',
            'attd_timetable_object_chshift' => 'attd_timetable_object_chshift',
            'attd_timetable_shift' => 'attd_timetable_shift',
            'attd_timetable_shiftmisc' => 'attd_timetable_shiftmisc',
            'attd_object_group_timetable' => 'attd_object_group_timetable',
            

            ## Employee

            'user_status'=>'naf_user_statuses',
            'person' => 'employee',
            'person_type' => 'employee_type',
            'person_status' => 'employee_status',
            'person_detail' => 'emp_detail',
            'person_family' => 'emp_family',
            'person_experiences' => 'emp_experiences',
            'person_education' => 'emp_education',
            'person_medical' => 'emp_medical_history',
            'person_parameters' => 'emp_parameters',
            'person_user_map' => 'emp_user_map',
            'person_map' => 'emp_user_map',
            'contact' => 'contact',
            'contact_type' => 'contact_type',
            'contact_reference' => 'contact_reference',
            'contact_detail' => 'contact_detail',
            'contact_relation' => 'contact_relation',
            'contact_relation_type' => 'contact_relation_type',
            'address' => 'address',
            'city' => 'addr_city',
            'country' => 'addr_country',
            'province' => 'addr_province',
            'provinceCity' => 'addr_province_cities',
            'org_position'      => 'org_position',
            'organization'      => 'organization',
            'org_has_position'  => 'org_has_position',
            'employee_jobs' => 'emp_jobs',
            'employee_job_type' => 'emp_job_type',

            ## notification
            'notification_profiles' => 'not_profiles',
            'notification_profile_types' => 'not_profile_types',
            'notification_templates' => 'not_templates',
            'notification_contents' => 'not_content',
            'notification_template_types' => 'not_template_types',
            'notification_stacks' => 'not_stack',
            'notification_stack_status' => 'not_stack_status',
            'notification_inbox_cache' => 'not_inbox_cache',
            'notification_inbox' => 'not_inbox',
            'notification_inbox_status' => 'not_inbox_status',
            'notification_topics' => 'not_topics',
            'notification_topic_member' => 'not_topic_members',
            'notification_action' => 'not_action',
            'notification_action_type' => 'not_action_type',
        ),

        'attendance' => array(
            'api_url' => array(
                'mapper' => "api/map/load-by-user-id",
                'emp_detail' => "employee/api/empDetail",
                'person_contact' => "api/contact/personContact",
                'emp_all' => "employee/api/empAll",
            ),
            'start_date' => 26,
            'checkin_recomendation' => true, //default Neuron
            'geolocation'=>false,
        ),
        'session'=> array(
            'regenerate' => false,
            'strict' => false,
            'gc_maxlifetime' => 43200,
            'cookie_lifetime' => 2592000,
            'remember' => 2592000
        ),
        'user' => array(
            'commands' => array(
                /* sample command icon
                array(
                    'url' => '/actor/form/test',
                    'icon' => 'fa-circle',
                ),
                */
            ),
            'languages' => array(
                'id' => 'Bahasa',
                'en' => 'English',
            ),
            'authentications' => array(
                1 => 'Database',
                2 => 'LDAP',
                3 => 'Token',
            ),
            'facebook' => array(
                'id' => '234448563876370',
                'secret' => '24e20fe570391c88f50d315885048342',
            ),
            'google' => array(
                'web' => array(
                    'client_id' => '763713885521-3i82ogutctr9siir02l0ip9e2ijqm2hh.apps.googleusercontent.com',
                    'project_id' => 'neuron-library',
                    'auth_uri' => 'https://accounts.google.com/o/oauth2/auth',
                    'token_uri' => 'https://www.googleapis.com/oauth2/v3/token',
                    'auth_provider_x509_cert_url' => 'https://www.googleapis.com/oauth2/v1/certs',
                    'client_secret' => 'wLyYR1YS1wolr3J25f58JMDM',
                    'redirect_uris' => array(
                        'http://localhost/git/actor/sample/public/index/google-verify'
                    )
                )
            ),
            'activation' => 'none',
            'unique' => 'code, email',
            'password' => array(
                'autogenerate' => false,
                'hash' => 'password_hash', // jenis hash
                'encrypted' => false, // sudah diencrypt dari depan atau belum
                'stored' => 0,   // jumlah password terakhir yang disimpan
                'age_min' => 0,  // umur minimum password dalam hari
                'age_max' => 999999, // umur maksimum password dalam hari
                'length' => 6,   // minimum panjang password dalam karakter
                'complex' => false,
                /*             |uppercase      |lowercase       |digit      |special char                |nousername| regex utama       |len */
                'format' => '/^(?=[^A-Z]*[A-Z])(?=[^a-z]*[a-z])(?=[^\d]*\d)(?=[^!@#$%^&*()]*[!@#$%^&*()])|nousername|[a-zA-Z\d!@#$%^&*()]{0,}$/',
                'format_info' => 'Password harus mengandung minimal masing-masing 1 karakter uppercase, lowercase, angka, simbol dan tidak boleh mengandung code user',
            ),
            'attempts' => 0,
        ),
        'notification' => array(
            'statuses' => array(
                '1' => 'Received',
                '2' => 'Read',
                '3' => 'Deleted',
            ),
            'using_sms' => false,
            'using_fcm' => true,
            'using_email' => false,
            'fcm' => array(
                'version' => '5.4.2',
                'apiKey' => 'AIzaSyD18XNLtyIwDBKK0q83GysjDFGJ0dqQTIQ',
                'authDomain' => 'doorv2.firebaseapp.com',
                'databaseURL' => 'https://doorv2.firebaseio.com',
                'projectId' => 'doorv2',
                'storageBucket' => 'doorv2.appspot.com',
                'messagingSenderId' => '655280494817',
                'publicVapidKey' => 'AAAAmJHC2OE:APA91bF_Y4IuXRrf0a4mQ6DL8kbpOeGF1TbiSyBD-HKej4_Pcn5UlN6LyXriDAUOriPOOppR2LVrAaJQSIMjeVM-cQQiRwStkHGGqptANuKN6S7uF_YQqOO6oRCzPJQQ1VlLYRQR2tTY',
                'authKey' => 'AIzaSyBM9RqX11aEO7YomNoeLH5A18Rm0t_7Twg',
            ),
        ),
        'actor' => array(
            'formlayout' => 'neuron/actor/layout/form',
            'restlayout' => 'neuron/actor/layout/rest',
            'viewprefix' => 'neuron/actor/form',
            /* user mgmt config */
            'user' => array(
                'commands' => array(
                    /* sample command icon
                    array(
                        'url' => '/actor/form/test',
                        'icon' => 'fa-circle',
                    ),
                    */
                ),
                'languages' => array(
                    'id' => 'Bahasa',
                    'en' => 'English',
                ),
                'authentications' => array(
                    1 => 'Database',
                    2 => 'LDAP',
                    3 => 'Token',
                ),
                'facebook' => array(
                    'id' => '234448563876370',
                    'secret' => '24e20fe570391c88f50d315885048342',
                ),
                'google' => array(
                    'web' => array(
                        'client_id' => '763713885521-3i82ogutctr9siir02l0ip9e2ijqm2hh.apps.googleusercontent.com',
                        'project_id' => 'neuron-library',
                        'auth_uri' => 'https://accounts.google.com/o/oauth2/auth',
                        'token_uri' => 'https://www.googleapis.com/oauth2/v3/token',
                        'auth_provider_x509_cert_url' => 'https://www.googleapis.com/oauth2/v1/certs',
                        'client_secret' => 'wLyYR1YS1wolr3J25f58JMDM',
                        'redirect_uris' => array(
                            'http://localhost/git/actor/sample/public/index/google-verify'
                        )
                    )
                ),
                'activation' => 'none',
                'unique' => 'code, email',
                'password' => array(
                    'autogenerate' => false,
                    'hash' => 'password_hash', // jenis hash
                    'encrypted' => false, // sudah diencrypt dari depan atau belum
                    'stored' => 0,   // jumlah password terakhir yang disimpan
                    'age_min' => 0,  // umur minimum password dalam hari
                    'age_max' => 999999, // umur maksimum password dalam hari
                    'length' => 6,   // minimum panjang password dalam karakter
                    'complex' => false,
                    /*             |uppercase      |lowercase       |digit      |special char                |nousername| regex utama       |len */
                    'format' => '/^(?=[^A-Z]*[A-Z])(?=[^a-z]*[a-z])(?=[^\d]*\d)(?=[^!@#$%^&*()]*[!@#$%^&*()])|nousername|[a-zA-Z\d!@#$%^&*()]{0,}$/',
                    'format_info' => 'Password harus mengandung minimal masing-masing 1 karakter uppercase, lowercase, angka, simbol dan tidak boleh mengandung code user',
                ),
                'attempts' => 0,
            ),
        ),
        'employee' => array(
            'session'=> array(
                'regenerate' => false,
                'strict' => false,
                'gc_maxlifetime' => 43200,
                'cookie_lifetime' => 2592000,
                'remember' => 2592000
            ),
        ),
    ),
);