<?php
namespace Neuron\Attendance;

use Neuron\Generic\Entity\Map;

class AttdRequestType extends \Neuron\Generic\Entity\Mapper {
    
    protected $_storage;

    public function __construct(\Neuron\Attendance\AttdRequestType\Storage\Skeleton $storage, $data = array()) {

        $this->_storage = $storage;

        parent::__construct(
            $data, 
            array(
                new Map('type_id'),
                new Map('type_name'),
                new Map('setting_id'),
            ),
            parent::CASE_INSENSITIVE
        );
    }

    public function listdata($params) {

        $data = $this->_storage->listdata($params,$this);

        $preparedResult = array(
            'draw' => $params['draw'],
            'recordsTotal' => $data['dataCount'],
            'recordsFiltered' => $data['dataFilterCount'],
            'data' => $data['dataAll']
        );

        $result = new \Neuron\Generic\Result();
        $result->data = $preparedResult;

        return $result;
    }
	
    public function load($code) {
        if ($data = $this->_storage->load($code)) {
            // $this->push($data);

            // push ini untuk mengesign ke diri sendiri

            $return = array(
                    'guid' => 0,
                    'code' => 200,
                    'info' => 'Data Found',
                    'data' => $data
                );

            return $return;
        }

        return array(
                    'guid' => 0,
                    'code' => 203,
                    'info' => 'Data Not Found',
                    'data' => null
                );
    }

    public function save($update = false) {
        if ($id = $this->_storage->save($this, $update)) {
            $this->type_id = $id;
            return true;
        }
        return false;
    }

    public function delete($id) {
        return $this->_storage->remove($id);
    }

    public function searchType($params) {
        return $this->_storage->searchType($params);
    }

    public function OverviewLeaveList() {
        return $this->_storage->OverviewLeaveList();
    }
    
}