<?php

namespace Neuron\Attendance\AttdRequestType\Storage;
use Zend\Db\Sql\Where;
use Zend\Db\Sql\Predicate\Expression;

class Mysql extends \Neuron\Db\Storage implements Skeleton {

	public function listdata($params = null,$attdRequestType) {
		$searchable = false;
		$select = $this->select()->from(array('art' => $this->_tables['attd_request_type']));
		$select->join(array('ars' => $this->_tables['attd_request_setting']), 'art.setting_id = ars.setting_id', array('setting_name','num_to_approve','min_approved','min_rejected'), \Zend\Db\Sql\Select::JOIN_LEFT);
		// $select->where(['(art.end_date is null or art.end_date = "0000-00-00" or art.end_date > now())']);

		if(isset($params['draw'])) {
			$i = $params['order'][0]['column'];
			$dir = $params['order'][0]['dir'];
			$select->order(array($params['columns'][$i]['data'] . " " . $dir));
	
			$offset = ($params->start/$params->length) * $params->length;
			$select->limit(intval($params->length));
			$select->offset(intval($offset));

			// search
			if($params['search']['value']){
				$searchable = true;
				$nest = $select->where->nest();
				foreach ($params['columns'] as $col) {
					if($col['data'] != null) {
						
						if($col['searchable'] === "true") {
							$nest->like(new Expression('LOWER('.$col['name'].')'),new Expression('\'%'.$params['search']['value'].'%\''));
							$nest->or;
						}
						
					}
				}

				$nest->unnest();
			}
        }
        
        // echo str_replace('"','',$select->getSqlString())."<br />"; exit;
		$data = $this->fetchAll($select);

		$dataAll = [];

		if($data) {
			foreach($data as $row) {
				array_push($dataAll, $row);
			}
		}

		$selectC = $this->select()->from(array('lt' => $this->_tables['attd_request_type']));
		$selectC->columns(array('total_count' => new \Zend\Db\Sql\Expression('COUNT(*)')));
		// $selectC->where(['(art.end_date is null or art.end_date = "0000-00-00" or art.end_date > now())']);
		$dataCount = $this->fetchRow($selectC);
		$total = ($dataCount['total_count'] > 0) ? $dataCount['total_count']:0;

		$filtered = $total;
		if($searchable){
			$selectF = $this->select()->from(['lt' => $this->_tables['attd_request_type']]);
			$selectF->columns(['total_count' => new \Zend\Db\Sql\Expression('COUNT(*)')]);
			$selectF->where(['(art.end_date is null or art.end_date = "0000-00-00" or art.end_date > now())']);
			if(!empty($params['search']['value'])) {
				$nest = $select->where->nest();
				foreach ($params['columns'] as $col) {
					if($col['data'] != null) {
						
						if($col['searchable'] === "true") {
							$nest->like(new Expression('LOWER('.$col['name'].')'),new Expression('\'%'.$params['search']['value'].'%\''));
							$nest->or;
						}
						
					}
				}

				$nest->unnest();
			}

			$dataFiltered = $this->fetchRow($selectF);
			$filtered = ($dataFiltered['total_count'] > 0) ? $dataFiltered['total_count']:0;
		}

		return array(
			'dataAll' => $dataAll,
			'dataCount' => $total,
			'dataFilterCount' => $filtered
		);
	}

	public function load($code) {
		$select = $this->select()
			->from(array('art' => $this->_tables['attd_request_type']))
			->join(array('ars' => $this->_tables['attd_request_setting']), 'art.setting_id = ars.setting_id', array('setting_name','num_to_approve','min_approved','min_rejected'), \Zend\Db\Sql\Select::JOIN_LEFT)
			->where(array('art.type_id' => $code));
		$result = $this->fetchRow($select);
		return $result;
	}

	public function searchType($params) {
		$select = $this->select()->from(array('art' => $this->_tables['attd_request_type']));
		$select->join(array('ars' => $this->_tables['attd_request_setting']), 'art.setting_id = ars.setting_id', array('setting_name','num_to_approve','min_approved','min_rejected'), \Zend\Db\Sql\Select::JOIN_LEFT);
		
		if(isset($params['type_id']) && $params['type_id'] != "") {
			$select->where(array('art.type_id' => $params['type_id']));
		}

		$result = $this->fetchRow($select);
		return $result;
	}

	public function save(\Neuron\Attendance\AttdRequestType $model, $update = false) {
		if ($update) {
			$update = $this->update()
				->table($this->_tables['attd_request_type'])
				->set($this->__($model->pull()))
				->where($this->__(array('type_id' => $model->type_id)));

				// echo str_replace('"','',$update->getSqlString())."<br />"; exit;
			if ($this->execute($update)) {
				return $model->type_id;
			}
		}
		else {
			$insert = $this->insert()
				->into($this->_tables['attd_request_type'])
				->values($this->__($model->pull()));
			// echo str_replace('"','',$insert->getSqlString())."<br />"; exit;
			$save = $this->execute($insert);

			if ($save) {
				$model->type_id = $save;
				return $model->type_id;
			}
		}

		return false;
	}

	public function remove($type_id) {
		$delete = $this->update()
				->table($this->_tables['attd_request_type'])
				->set($this->__(array('is_deleted' => 1 )))
				->where($this->__(array('type_id' => $type_id)));

		return $this->execute($delete);
	}

	public function OverviewLeaveList() {
		$select = $this->select()
			->from(array('lt' => $this->_tables['attd_request_type']));

		$data = $this->fetchAll($select);

		$dataAll = [];

		if($data) {
			foreach($data as $row) {
				array_push($dataAll, $row);
			}
		}

		return array(
			'dataAll' => $dataAll
		);
	}
}