<?php

namespace Neuron\Attendance\Attendance\Reference\Storage;

class Mysql extends \Neuron\Db\Storage implements Skeleton {

	public function getTotalRows() {
		try {

			$select = $this->select()
						->columns(array('total' => $this->expression('FOUND_ROWS()')));
														 
			return $this->fetchValue($select);  

		} catch (\Exception $ex) {
			return false;
		}              
	}  

	public function listReference($page = 1, $rowCount = 10) {
		try {
			$offset = ($page-1) * $rowCount;

			$select = $this->select()
						->quantifier($this->expression('SQL_CALC_FOUND_ROWS'))
						->from(array('ar' => $this->_tables['attd_reference']))
						->limit(intval($rowCount))
						->offset(intval($offset));
			
			// echo str_replace('"','',$select->getSqlString())."<br />";                
			return $this->fetchAll($select);  

		} catch (\Exception $ex) {
			return false;
		}       
	}
	
}