<?php
/* Neuron Attendance engine config */
return array(

    /* Konfigurasi translator Attendance */
    'translator' => array(
        'translation_file_patterns' => array(
            array(
                'type' => 'phparray',
                'base_dir' => __DIR__ . '/Resource/Language',  //lokasi file terjemahan
                'pattern' => '%s.php',           //file en_US.php, id_ID.php, dst
                'text_domain' => 'default', //text domain
            ),
        ),
    ),
    
    /* Konfigurasi routing controller Attendance */
    'router' => array(
        'routes' => array(
            /* Konfigurasi routing modul Attendance */
            'attendance' => array(
                'type' => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                    'route' => '/attendance',
                    'defaults' => array(
                        '__NAMESPACE__' => 'Neuron\Attendance\Controller', /* Set default routing fallback */
                        'controller' => 'Index',
                        'action' => 'index',
                    ),
                ),
                'may_terminate' => true,
                'child_routes' => array(
                    'default' => array(
                        'type' => 'Segment',
                        'options' => array(
                            'route' => '/[:controller[/:action]]', /* Set konfigurasi auto routing, selain default */
                            'constraints' => array(
                                'controller' => '[a-zA-Z][a-zA-Z0-9_-]*',
                                'action' => '[a-zA-Z][a-zA-Z0-9_-]*',
                            ),
                            'defaults' => array(
                            ),
                        ),
                    ),
                ),
            ),
            'widget_attendance' => array(
                'type' => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                    'route' => '/widget_attendance',
                    'defaults' => array(
                        '__NAMESPACE__' => 'Neuron\Attendance\Controller\Widget', /* Set default routing fallback */
                        'controller' => 'Attendance',
                        'action' => 'index',
                    ),
                ),
                'may_terminate' => true,
                'child_routes' => array(
                    'default' => array(
                        'type' => 'Segment',
                        'options' => array(
                            'route' => '/[:controller[/:action]]', /* Set konfigurasi auto routing, selain default */
                            'constraints' => array(
                                'controller' => '[a-zA-Z][a-zA-Z0-9_-]*',
                                'action' => '[a-zA-Z][a-zA-Z0-9_-]*',
                            ),
                            'defaults' => array(
                            ),
                        ),
                    ),
                ),
            ),
            'api_attendance' => array(
                'type' => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                    'route' => '/api_attendance',
                    'defaults' => array(
                        '__NAMESPACE__' => 'Neuron\Attendance\Controller\Api', /* Set default routing fallback */
                        'controller' => 'Attendance',
                        'action' => 'index',
                    ),
                ),
                'may_terminate' => true,
                'child_routes' => array(
                    'default' => array(
                        'type' => 'Segment',
                        'options' => array(
                            'route' => '/[:controller[/:action]]', /* Set konfigurasi auto routing, selain default */
                            'constraints' => array(
                                'controller' => '[a-zA-Z][a-zA-Z0-9_-]*',
                                'action' => '[a-zA-Z][a-zA-Z0-9_-]*',
                            ),
                            'defaults' => array(),
                        ),
                    ),
                ),
            ),
        ),
    ),

    /* Mapping namespace controller ke class controller engine CRM */
    'controllers' => array(
        'invokables' => array(
            /* controllers for Attendance */
            'Neuron\Attendance\Controller\Index' => 'Neuron\Attendance\Controller\Index',
            'Neuron\Attendance\Controller\Form' => 'Neuron\Attendance\Controller\Form',
            'Neuron\Attendance\Controller\Attendance' => 'Neuron\Attendance\Controller\Attendance',
            'Neuron\Attendance\Controller\Request' => 'Neuron\Attendance\Controller\Request',
            'Neuron\Attendance\Controller\Timetable' => 'Neuron\Attendance\Controller\Timetable',
            'Neuron\Attendance\Controller\Reporting' => 'Neuron\Attendance\Controller\Reporting',
            'Neuron\Attendance\Controller\ObjectTimetable' => 'Neuron\Attendance\Controller\ObjectTimetable',
            'Neuron\Attendance\Controller\Shift' => 'Neuron\Attendance\Controller\Shift',
            'Neuron\Attendance\Controller\Group' => 'Neuron\Attendance\Controller\Group',
            'Neuron\Attendance\Controller\GroupMember' => 'Neuron\Attendance\Controller\GroupMember',
            'Neuron\Attendance\Controller\Member' => 'Neuron\Attendance\Controller\Member',
            'Neuron\Attendance\Controller\Widget' => 'Neuron\Attendance\Controller\Widget',
            'Neuron\Attendance\Controller\Approval' => 'Neuron\Attendance\Controller\Approval',
            'Neuron\Attendance\Controller\Setting' => 'Neuron\Attendance\Controller\Setting',

            /* Widget Controller Only */
            'Neuron\Attendance\Controller\Widget\Attendance' => 'Neuron\Attendance\Controller\Widget\Attendance',
            'Neuron\Attendance\Controller\Widget\Attendancedetail' => 'Neuron\Attendance\Controller\Widget\Attendanceetail',

            //widget request
            'Neuron\Attendance\Controller\Widget\Myrequest' => 'Neuron\Attendance\Controller\Widget\Myrequest',
            'Neuron\Attendance\Controller\Widget\Myapproval' => 'Neuron\Attendance\Controller\Widget\Myapproval',

            //widgetDashboard
            'Neuron\Attendance\Controller\Widget\Wdashboard' => 'Neuron\Attendance\Controller\Widget\Wdashboard',

            ## FP Machine
            'Neuron\Attendance\Controller\fp-machines' => 'Neuron\Attendance\Controller\FpMachine',
            'Neuron\Attendance\Controller\Brand' => 'Neuron\Attendance\Controller\Brand',

            //api
            'Neuron\Attendance\Controller\Api\Controller' => 'Neuron\Attendance\Controller\Api\Controller',
            'Neuron\Attendance\Controller\Api\User' => 'Neuron\Attendance\Controller\Api\User',
            'Neuron\Attendance\Controller\Api\Attendance' => 'Neuron\Attendance\Controller\Api\Attendance',
            'Neuron\Attendance\Controller\Api\Timetable' => 'Neuron\Attendance\Controller\Api\Timetable',
            'Neuron\Attendance\Controller\Api\Request' => 'Neuron\Attendance\Controller\Api\Request',
            'Neuron\Attendance\Controller\Api\Approval' => 'Neuron\Attendance\Controller\Api\Approval',
            'Neuron\Attendance\Controller\Api\Toapproval' => 'Neuron\Attendance\Controller\Api\Toapproval',

            // Testing
            'Neuron\Attendance\Controller\Test'         => 'Neuron\Attendance\Controller\Test',
            
            # v2 standarized
            'Neuron\Attendance\Controller\Obj'          => 'Neuron\Attendance\Controller\v2\Obj',

            #v2.1
            'Neuron\Attendance\Controller\Dashboard'          => 'Neuron\Attendance\Controller\Dashboard',
            'Neuron\Attendance\Controller\ReportingHr'          => 'Neuron\Attendance\Controller\ReportingHr'



        ),
    ),

    /* Mapping action name ke file view, setiap action dan view harus didaftarkan disini */
    'view_manager' => array(
        'template_map' => array(
            'neuron/attendance/layout/form' => __DIR__ . '/View/Form.phtml',
            'neuron/attendance/layout/plain' => __DIR__ . '/View/Plain.phtml',
            'neuron/attendance/layout/blank' => __DIR__ . '/View/Blank.phtml',
            'neuron/attendance/form/form-request' => __DIR__.'/View/Form/FormRequest.phtml',
            'neuron/attendance/form/request' => __DIR__.'/View/Form/Request.phtml',
            'neuron/attendance/form/detail-request' => __DIR__.'/View/Form/DetailRequest.phtml',
            
            'neuron/attendance/form/manage' => __DIR__ . '/View/Form/Manage.phtml',
            'neuron/attendance/form/list' => __DIR__ . '/View/Attendance/List.phtml',
            'neuron/attendance/attendance/list' => __DIR__ . '/View/Attendance/List.phtml',
            'neuron/attendance/attendance/crud' => __DIR__ . '/View/Attendance/Crud.phtml',
            'neuron/attendance/attendance/setbyadmin' => __DIR__ . '/View/Attendance/SetByAdmin.phtml',
            'neuron/attendance/attendance/today-status' => __DIR__.'/View/Attendance/today-status.phtml',
            'neuron/attendance/object/crud-group' => __DIR__ . '/View/Object/CrudGroup.phtml',
            'neuron/attendance/object/crud-object' => __DIR__ . '/View/Object/CrudObject.phtml',
            'neuron/attendance/object/list' => __DIR__ . '/View/Object/List.phtml',
            'neuron/attendance/object/select-employee' => __DIR__ . '/View/Object/SelectEmployee.phtml',

            'neuron/attendance/request/crud' => __DIR__ . '/View/Request/Crud.phtml',
            'neuron/attendance/widget/list' => __DIR__ . '/View/Request/List.phtml',
            'neuron/attendance/request/setting' => __DIR__ . '/View/Request/Setting.phtml',
            'neuron/attendance/widget/form-request' => __DIR__ . '/View/Request/FormRequest.phtml',

            'neuron/attendance/request/manage' => __DIR__ . '/View/Form/Request.phtml',
            'neuron/attendance/widget/approval' => __DIR__ . '/View/Request/Approval.phtml',
            'neuron/attendance/request/form-approval' => __DIR__ . '/View/Request/FormApproval.phtml',
            'neuron/attendance/request/setting/list'  => __DIR__ . '/View/Request/Setting/List.phtml',
            'neuron/attendance/widget/form-setting' =>  __DIR__ . '/View/Request/Setting/Crud.phtml',
            'neuron/attendance/widget/mapping-type' =>  __DIR__ . '/View/Request/Setting/MappingType.phtml',
            
            'neuron/attendance/timetable/manage' => __DIR__ . '/View/Timetable/Manage.phtml',
            'neuron/attendance/timetable/crud' => __DIR__ . '/View/Timetable/Crud.phtml',
            'neuron/attendance/timetable/crud/step-1' => __DIR__ . '/View/Timetable/Partial/CRUD/TimetableStep1.phtml',
            'neuron/attendance/timetable/crud/step-2' => __DIR__ . '/View/Timetable/Partial/CRUD/TimetableStep2.phtml',
            'neuron/attendance/timetable/crud/step-3' => __DIR__ . '/View/Timetable/Partial/CRUD/TimetableStep3.phtml',
            'neuron/attendance/timetable/form' => __DIR__ . '/View/Timetable/Form.phtml',
            'neuron/attendance/timetable/manage-shift' => __DIR__ . '/View/Timetable/ManageShift.phtml',

            'neuron/attendance/timetable/form-shift' => __DIR__ . '/View/Timetable/FormShift.phtml',
            'neuron/attendance/timetable/form-duplicate' => __DIR__ . '/View/Timetable/FormDuplicate.phtml',
            'neuron/attendance/timetable/shift-misc' => __DIR__ . '/View/Timetable/shiftMisc.phtml',
            'neuron/attendance/timetable/manage-monthly' => __DIR__ . '/View/Timetable/ManageMonthly.phtml',
            'neuron/attendance/timetable/changeshift' => __DIR__ . '/View/Timetable/chshift.phtml',
            // 'neuron/attendance/timetable/form-upload' => __DIR__ . '/View/Timetable/Upload.phtml',
            'neuron/attendance/timetable/manage-object' => __DIR__ . '/View/Timetable/manageObject.phtml',

            'neuron/attendance/reporting/manage' => __DIR__ . '/View/Reporting/Manage.phtml',
            'neuron/attendance/reporting/detail' => __DIR__ . '/View/Reporting/Detail.phtml',
            'neuron/attendance/reporting/more' => __DIR__ . '/View/Reporting/More.phtml',
            'neuron/attendance/reporting/reporting-chart' => __DIR__ . '/View/Reporting/ReportingChart.phtml',
            'neuron/attendance/reporting/monthly' => __DIR__ . '/View/Reporting/Monthly.phtml',

            // widget view
            'neuron/attendance/widget/form' => __DIR__ . '/View/Attendance/Widget/Form.phtml',
            'neuron/attendance/widget/crud' => __DIR__ . '/View/Attendance/Widget/Crud.phtml',

            'neuron/attendance/widget/attendance' => __DIR__ . '/View/Attendance/Widget/Attendance.phtml',
            'neuron/attendance/widget/widget-detail-request' => __DIR__.'/View/Request/WDetailRequest.phtml',
            'neuron/attendance/widget/form-approval' => __DIR__.'/View/Request/FormApproval.phtml',

            'neuron/attendance/index/starting-guide'    => __DIR__.'/View/Index/starting-guide.phtml',
			'neuron/attendance/widget/detail-attendance' => __DIR__ . '/View/Form/DetailAttendance.phtml',
            
            //widgetDashboardComponent
            'neuron/attendance/index/dashboard-widget' => __DIR__ . '/View/Index/DashboardWidget.phtml',
            'neuron/attendance/widget/dashboard/widget-overtime' => __DIR__ . '/View/Index/Widget/ChartOvertime.phtml',

            // Upload Form
            'neuron/attendance/form/form-upload' => __DIR__ . '/View/Timetable/dndUpload.phtml',
            'neuron/attendance/form/upload-range' => __DIR__ . '/View/Timetable/uploadRange.phtml',
            'neuron/attendance/timetable/timetable-list' => __DIR__ . '/View/Timetable/timetableList.phtml',
            'neuron/attendance/object/list-group' => __DIR__ . '/View/Object/ListGroup.phtml',
            'neuron/attendance/form/form-detail-request'    => __DIR__.'/View/Form/form-detail-request.phtml',

            'neuron/attendance/form/manage-group' => __DIR__ . '/View/Form/manageGroup.phtml',
            'neuron/attendance/form/manage-group-member' => __DIR__ . '/View/Form/manageGroupMember.phtml',
            'neuron/attendance/attendance/widget-attendance' => __DIR__.'/View/Attendance/wAttendance.phtml',

            'neuron/attendance/attendance/widget-approve' => __DIR__.'/View/Form/modal-approval.phtml',

            'neuron/attendance/timeshift/crud' =>__DIR__.'/View/Timeshift/Crud.phtml',
            'neuron/attendance/form/widget-reporting'   => __DIR__.'/View/Widget/attendance-reporting-widget.phtml',

            'neuron/attendance/form/form-approval'   => __DIR__.'/View/Form/form-approval.phtml',
            'neuron/attendance/form/form-create-setting' => __DIR__.'/View/Form/form-create-setting.phtml',

            'neuron/attendance/form/modal-approval' => __DIR__.'/View/Form/modal-approval.phtml',

         


            ## New Widget
            'neuron/attendance/widget/attendance'   => __DIR__.'/View/Widget/attendance-reporting-widget.phtml',
            'neuron/attendance/widget/dashboard-widget' => __DIR__ . '/View/Index/DashboardWidget.phtml',
            'neuron/attendance/widget/widget-overtime' => __DIR__ . '/View/Index/Widget/ChartOvertime.phtml',
            'neuron/attendance/widget/today-status' => __DIR__ . '/View/Index/Widget/today-status.phtml',

            ## Publict List Employee versi attendance
            'neuron/attendance/form/listEmployee'   => __DIR__.'/View/Form/listEmployee.phtml',
            'neuron/attendance/form/listOrganization'   => __DIR__.'/View/Form/listOrganization.phtml',
            'neuron/attendance/form/overview'   => __DIR__.'/View/Form/Overview.phtml',
            'neuron/attendance/form/today-status' => __DIR__.'/View/Form/today-status.phtml',

            'neuron/attendance/test/index'      => __DIR__.'/View/Test/index.phtml',

            ##v2.1
            'neuron/attendance/v2_1/attendance/summary' => __DIR__.'/View/V2_1/Attendance/summary.phtml',
            'neuron/attendance/v2_1/attendance/summary-detail' => __DIR__.'/View/V2_1/Attendance/summaryDetail.phtml',
            'neuron/attendance/v2_1/attendance/form' => __DIR__.'/View/V2_1/Attendance/form.phtml',
            'neuron/attendance/v2_1/attendance/partial/form-types' => __DIR__.'/View/V2_1/Attendance/Partial/form-types.phtml',

            ##v2.1 - reporting HR
            'neuron/attendance/v2_1/reporting/summary' => __DIR__.'/View/V2_1/Reporting/summary.phtml',
            'neuron/attendance/v2_1/reporting/summary-detail-hr' => __DIR__.'/View/V2_1/Reporting/summaryDetail.phtml',

            'neuron/attendance/employee/modal-timetable'    => __DIR__.'/View/Employee/modal-timetable.phtml',
            'neuron/attendance/profile/summary-attendance'  => __DIR__.'/View/Attendance/Widget/summary-attendance.phtml',

            ##2.1 upload shift
            'neuron/attendance/timetable/upload-shift'  => __DIR__.'/View/Timetable/uploadShift.phtml',
            'neuron/attendance/timetable/new-upload-shift'  => __DIR__.'/View/Timetable/new-uploadShift.phtml',
            
        ),
        'template_path_stack' => array(
            __DIR__ . '/View',
        ),
        'template_name' => array(
            'Neuron\Attendance' => 'layout/bare', /* nama layout untuk module neuron core */
        ),
    ),

    /* put internal lib config here -- will be integrated to NAF on install */
    'internal' => array(

        /* table mapping */
        'tables' => array(
            'attendance'=>'attendance',
            'attd_source_type'=>'attd_source_type',
            'attd_request_status'=>'attd_request_status',

            'attd_request_setting_detail'=>'attd_request_setting_detail',
            'attd_request_setting_approval_type'=>'attd_request_setting_approval_type',
            'attd_request_setting'=>'attd_request_setting',
            'attd_request_type'=>'attd_request_type',
            'attd_request_approval'=>'attd_request_approval',
            'attd_request'=>'attd_request',

            'attd_reference'=>'attd_reference',
            'attd_object_group_timetable'=>'attd_object_group_timetable',
            'attd_object_group_member'=>'attd_object_group_member',
            'attd_object_group'=>'attd_object_group',
            
            //enhance timetable
            'attd_timetable'=>'attd_timetable',
            'attd_timetable_object'=>'attd_timetable_object',
            'attd_timetable_object_chshift' => 'attd_timetable_object_chshift',
            'attd_timetable_shift' => 'attd_timetable_shift',
            'attd_timetable_shiftmisc' => 'attd_timetable_shiftmisc',
            'attd_object_group_timetable' => 'attd_object_group_timetable',
            
            'attd_employee'     => 'employee',
            'attd_evidence'     => 'attd_evidence',
            'attd_details'     => 'attd_details',

            //upload shift
            'attd_upload_shift'     => 'attd_upload_shift',
            'attd_upload_shift_detail'     => 'attd_upload_shift_detail',

        ),
        'attendance'=>array(

            'api_url' => array(
                'mapper' => "api/map/load-by-user-id",
                'emp_detail' => "employee/api/empDetail",
                'emp_all' => "employee/api/empAll",
            ),

            'start_date' => 26,
            'checkin_recomendation' => true,

            'geolocation'=> array(
                'is_active'         => true,
                'min_distance'      => 100,
            ),

            'session' => array(
                'name' => 'testattendance',
                'mode' => 'default', //default, db, or cache
          
                'regenerate' => false,
                'strict' => false,
                'gc_maxlifetime' => 43200,
                'cookie_lifetime' => 2592000,
                'remember' => 2592000
            ),
            'widgets' => array(
                array(
                    'id' => 'widget-attd',
                    'name' => 'Attendance Reporting',
                    'endpoint' => '/attendance/widget/attendance',
                ),
                array(
                    'id' => 'widget-attd-overtime',
                    'name' => 'Overtime',
                    'endpoint' => '/attendance/widget/widget-overtime',
                ),
                array(
                    'id' => 'widget-attd-today-status',
                    'name' => 'Today Status',
                    'endpoint' => '/attendance/widget/today-status',
                ),
            ),
        ),
        'starting_guide' => array(
            'attendance' => '/attendance/index/starting-guide'
        ),
		/* icons map */
        'icons' => array(
            'mnu_attd' => 'fa-door-open',
            'mnu_attd_manage' => 'fa-list',
            'mnu_attd_request' => 'fa-clipboard-list',
            'mnu_attd_set_by_admin' => 'fa-edit',
            'mnu_attd_timeshift_manage' => 'fa-calendar-alt',
            'mnu_attd_timeshift_change_shift' => 'fa-exchange-alt',
            'mnu_attd_my_report' => 'fa-chart-pie',
            'mnu_attd_setting' => 'fa-cogs',
            'mnu_attd_emp_report' => 'fa-chart-bar',
            'mnu_attd_dashboard_summary' => 'fas fa-list menu-icon',
            'mnu_attd_dashboard_summary_hr' => 'fas fa-list menu-icon',
        ),
    ),
);
