<?php
namespace Neuron\Attendance\Controller;

use Neuron\Attendance\Request\Approval as ApprovalModel;
use Neuron\Attendance\Request\Approvals;

class Approval extends Controller{
	
	public function loadListAction(){
		$post 	= $this->getRequest()->getPost();
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		$mode 	= ApprovalModel\Storage::LIST_ALL;
		
		if(isset($post['draw'])){
			$datatable 	= true;
		}else{
			$datatable = false;
		}
		
		if(isset($post['request_id']) && !empty($post['request_id'])){
			$mode 	= ApprovalModel\Storage::LISTBY_REQUEST_ID;
		}
		
		if(isset($post['ref_id']) && !empty($post['ref_id'])){
			$mode 	= ApprovalModel\Storage::LISTBY_REF_ID;
			if(isset($post['status_id'])){
				$mode = ApprovalModel\Storage::LISTBY_REF_ID_STATUS_ID;
			};
		}
		
		$approvals 		= new Approvals(ApprovalModel\Storage::factory($this->getDb(),$this->getConfig()));
		$result 		= $approvals->load(null,$mode,$post);
		
		if($datatable){
			$res 		= array(
				'draw' 	=> $post['draw'],
				'recordsTotal' 	=> $result->data['countTotal'],
				'recordsFiltered' => $result->data['countTotal'],
				'data' 	=> $result->data['rows']
			);
			// echo json_encode($res);
			
			$logparam['subject'] = 'API ATTENDANCE APPROVAL LOADLISTACTION';
			$logparam['identity'] = '';
			$logparam['user'] = '';
			$logparam['description'] = 'Log proses api attendance approval loadListAction';
			$logparam['request'] = json_encode($requestPost);
			$logparam['response'] = json_encode($res);

			$this->writeLogAction($logparam);
			
			return $this->getOutput(json_encode($res));
		}else{	
		
			$responseResult = array(
				'code' => $result->code,
				'info' => $result->info,
				'data' => $result->data
			); 

			$logparam['subject'] = 'API ATTENDANCE APPROVAL CHANGEPASSWORDACTION';
			$logparam['identity'] = '';
			$logparam['user'] = '';
			$logparam['description'] = 'Log proses api attendance Approval changePasswordAction';
			$logparam['request'] = json_encode($requestPost);
			$logparam['response'] = json_encode($responseResult);

			$this->writeLogAction($logparam);
		
			return $this->getREST()->getResponse($result);
		}

	}

	public function loadAction(){
		$result 	= new \Neuron\Generic\Result;
		$post 	= $this->getRequest()->getPost();
		$this->getSession()->get();
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		if(!isset($post['approval_id'])){
			$result->code 	= 401;
			$result->info 	= "invalid approval id";
			
			$responseResult = array(
				'code' => $result->code,
				'info' => $result->info,
				'data' => $result->data
			); 

			$logparam['subject'] = 'API ATTENDANCE USER LOADACTION';
			$logparam['identity'] = '';
			$logparam['user'] = '';
			$logparam['description'] = 'Log proses api attendance user loadAction';
			$logparam['request'] = json_encode($requestPost);
			$logparam['response'] = json_encode($responseResult);

			$this->writeLogAction($logparam);
			
			return $this->getREST()->getResponse($result);
		}

		$approval_id 	= $post['approval_id'];
		$assigned_to_id 	= $post['assigned_to_id'];
		
		if($approval_id) {
			$entity = new \Neuron\Approval\Entity(\Neuron\Order\Entity\Storage::factory($this->getDb(), $this->getConfig()));
			$param['order_id'] = $approval_id;

			/* load and return */
			$param['flow'] = 'list';
			$result = $entity->loadEx($param, 3);
			$data = $result->data;
			$data['approval_order_flow_status_id'] = 0;
			if(isset($data['flow'])){
				$newFlow = [];
				foreach ($data['flow'] as $flow) {

					if($flow['assigned_to_id'] == $assigned_to_id){
						$data['approval_order_flow_status_id'] = $flow['order_flow_status_id'];
						$data['remark_out'] = $flow['remark_out'];
						$data['status_flow_name'] = $this->translate($flow['status_name']);
					}
					$flow['status_name'] = $this->translate($flow['status_name']);
					$newFlow[] = $flow;
				}
				$data['flow'] = $newFlow;
			}
		}

		
		$result->data = $data;
		$responseResult = array(
			'code' => $result->code,
			'info' => $result->info,
			'data' => $result->data
		); 

		$logparam['subject'] = 'API ATTENDANCE APPROVAL LOADACTION';
		$logparam['identity'] = '';
		$logparam['user'] = '';
		$logparam['description'] = 'Log proses api attendance Approval loadAction';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($responseResult);

		$this->writeLogAction($logparam);
		
		return $this->getREST()->getResponse($result);

	}
}
