<?php
namespace Neuron\Attendance\Controller;

use Neuron\Attendance\Module;
use Neuron\Composite\User;
use Neuron\Attendance\Request\Type;
use Neuron\Attendance\Request\Types;
use Neuron\Attendance\Request\Setting;
use Neuron\Attendance\Request\Status;
use Neuron\Attendance\Request\Statuses;
use Neuron\Notification\Inbox as InboxModel;

class Form extends Controller {

	protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/attendance/layout/form';
		$prefix = 'neuron/attendance/form';

		/* libraries */
		// $this->using('jquery', null, false)
		// 	->using('bootstrap', null)
		// 	->using('font-awesome', null, true, false);
		
		/* libraries */;
        $this->using('font-awesome', 10, 'https://use.fontawesome.com/releases/v5.8.1/css/all.css');

        $this->using('select2', 22, array(
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
             /* ini load sesuai bahasa dari session */
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
             /**/
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
            'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
        ));

		if(! class_exists('Neuron\Application\Framework\Entity')) {
	        $this->using(
		            'bootstrap-4',
		            null,
		            array(
		                'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
		                'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
		                'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
		                'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
		            )
		        )
		        ->using('toast',null)
		        ->using('bootbox',null);
		}

        $this->using('toast');
	    $this->using('generic');
		$this->using('fontawesome', null);
		
		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}
	public function manageAction() {

		$this->usingjs('bootbox', 21);
        $this->using('p-loading', 22);
        $this->using('bootstrap-select', 23);
        $this->using('generic', 24);

        $this->using('datatable', 20, array(
            'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
            'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
            'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
        ));

        $this->using('air-datepicker',28);
        $this->using('moment',29);
        $this->using('jquery.validate',30);

		$sessmgt = $this->getSession()->get();
        $sess = (isset($sessmgt['ref_id'])) ? true : false;
        $title = $this->translate("Attendance");

        $layout = $this->layout();
		// $layout->setVariables(['previous' => '<a href="'.$this->getPublicURL().'/index/my-request">Leave</a>']);
		$layout->setVariables(['current' => 'Manage Attendance']);

		return $this->getView('list', get_defined_vars());
	}
	//REFERENCE CONFIG LOGIN SIMULATOR
	public function RefSetAction() {
		$session = $this->getSession();

		$user_id = $this->params()->fromPost('user_id');

	    $result = false;
	    
	    $GetMapperPerson = $this->GetMapPerson($user_id);
	    if($GetMapperPerson != null) {
	    	$session->put(null, $GetMapperPerson);

	    	$storage = User\Storage::factory($this->getDb(), $this->getConfig());
	        $user = new User($storage);
	        $user->load($user_id);
	        // $grants = $user->grants->load();
	        // $roles = $user->roles->load($grants->data)->data;

	        // $session->put(null, ['roles' => $roles]);

			$sessmgt = $session->get();

			$sess = (count($sessmgt) > 0) ? true : false;

			if($sess) {
				$result = true;
			}

	    }
	    $roles = array(
	    	'roles' => array(
	    		'list' => array(
	    			0 => array(
	    				'access_role_id' => 1
	    			)
	    		)
	    	)
	    );
	    $session->put(null,$roles);
	    $session->put(null, ['lang' => 'en'] );

		$response = $this->getResponse();
		$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
		$response->setContent(json_encode($result));
		return $response;
	}
	public function RefSetLangAction() {
		$lang = $this->params()->fromPost('lang');

		$session = $this->getSession();
		$session->put(null, ['lang' => $lang]);

		$sessmgt = $session->get();

		$response = $this->getResponse();
		$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
		$response->setContent(json_encode(true));
		return $response;
	}
	public function ClearSessionAction() {
		$session = $this->getSession();
		$session->stop();

		$sessmgt = $session->get();
		$sess = (isset($sessmgt['ref_id'])) ? true : false;

		$result = false;
		if(!$sess) {
			$result = true;
		}

		$response = $this->getResponse();
		$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
		$response->setContent(json_encode($result));
		return $response;
	}
	public function uploadAction(){
	    $this->using('jquery.bootgrid',20,true);
	    return $this->getView('form-upload');
	}
	public function uploadRangeAction(){
	    $this->using('jquery.bootgrid',20);
	    $this->using('datatable',21);
		return $this->getView('upload-range');
	}
	public function groupAction(){
		$this->using('p-loading',20);
	    $this->using('moment', 23, array(
			'https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js'
		));
	    $this->using('generic',23);
		$this->using('air-datepicker', 24, array(
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/datepicker.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/css/datepicker.min.css',
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/i18n/datepicker.en.min.js'
		));
		$this->using('bootbox',21,  array(
			'https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js'
		));
	    $this->using('jquery.validate', 31, array(
			'https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/jquery.validate.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/additional-methods.min.js'
		));
	    
	    $this->using('datatable', 20, array(
	        'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
	        'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
	        'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		
		$query 	= $this->getRequest()->getQuery();
		$timetable_id = $query['timetable_id'];
		$layout = $this->layout();
		$layout->setVariables(['current' => $this->translate('Manage group')]);
		$layout->setVariables([
			'previous' => '<a href="'.$this->getPublicURL(). '/attendance/timetable/add-object?timetable_id='.$timetable_id.'">'.$this->translate("Manage object").'</a>']
		);
		$title = $this->translate('Timeshift Group');
		return $this->getView('manage-group',get_defined_vars());
	}
	public function requestActionOld(){
		$query 		= $this->getRequest()->getQuery();
		if(isset($query['notif_id'])){
			$storage = InboxModel\Storage::factory($this->getDb(), $this->getConfig(),3,$this->getSession()->owner());
			$inbox = new InboxModel($storage);
			$inbox->read($query['notif_id']);
		}
		$sessmgt = $this->getSession()->get();
		$this->using('moment',19);
		$this->using('datatable', 20, array(
            'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
            'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
            'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
        ));
        $this->using('air-datepicker',21);
        $this->using('select2', 22, array(
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
		     /* ini load sesuai bahasa dari session */
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
		     /**/
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
		    'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->using('bootbox', 23);


        $types 		= new Types(Type\Storage::factory($this->getDb(),$this->getConfig()));
        $types 		= $types->load();

        $status 	= new Statuses(Status\Storage::factory($this->getDb(),$this->getConfig()));
        $status 	= $status->load();

		$usrRefId 	= isset($sessmgt["ref_id"]) ? $sessmgt['ref_id'] : null;
		
		$usrJobId = null;
		$usrOrgId = null;


		$config = $this->getConfig();
		$checkin_recomendation = $config['attendance']['checkin_recomendation'];

		$layout = $this->layout();
		$layout->setVariables(['current' => $this->translate('Manage Request')]);

		$this->using('jquery.validate',29);
		return $this->getView('request',get_defined_vars());
	}
	public function newRequestAction(){
		$sessmgt = $this->getSession()->get();

		$usrRefId 	= isset($sessmgt["ref_id"]) ? $sessmgt['ref_id'] : null;

		$config = $this->getConfig();
		$checkin_recomendation = $config['attendance']['checkin_recomendation'];

		$types 		= new Types(Type\Storage::factory($this->getDb(),$this->getConfig()));
		$types 		= $types->load();

		$usrJobId = null;
		$usrOrgId = null;

		$status 	= new Statuses(Status\Storage::factory($this->getDb(),$this->getConfig()));
		$status 	= $status->load();

		$this->using('moment',19);
		$this->using('air-datepicker',20);
		$this->using('jquery.validate',21);

		$this->using('datatable', 22, array(
		    'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
		    'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
		    'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		$this->using('bootbox',23);

		$layout = $this->layout();
		$layout->setVariables(['previous' => '<a href="'.$this->getPublicURL().'/attendance/form/request">'.$this->translate("Request").'</a>']);
		$layout->setVariables(['current' => $this->translate('New Request')]);

		return $this->getView('form-request',get_defined_vars());
	}
	public function testSettingAction(){
		$types  = new Setting\Types(Setting\Type\Storage::factory($this->getDb(), $this->getConfig()));
		$types  = $types->load()->data['rows'];
		
		return $this->getView('form-create-setting',get_defined_vars());
	}
	public function todayAction(){
        return $this->getView('today-status');
	}



	public function requestAction(){
		$query 		= $this->getRequest()->getQuery();
		if(isset($query['notif_id'])){
			$storage = InboxModel\Storage::factory($this->getDb(), $this->getConfig(),3,$this->getSession()->owner());
			$inbox = new InboxModel($storage);
			$inbox->read($query['notif_id']);
		}
		$sessmgt = $this->getSession()->get();
		$this->using('moment',19);
		$this->using('datatable', 20, array(
            'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
            'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
            'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
        ));
        $this->using('air-datepicker',21);
        $this->using('select2', 22, array(
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
		     /* ini load sesuai bahasa dari session */
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
		     /**/
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
		    'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->using('bootbox', 23);

		$this->using('generic',24);
        $this->usingjs('jquery.validate',25);
		$this->using('toast', 26);
		$this->using('ploading', 27, array(
			'https://rawgit.com/joseshiru/p-loading/master/src/css/p-loading.css',
            'https://rawgit.com/joseshiru/p-loading/master/src/js/p-loading.js',
        ));


        $types 		= new Types(Type\Storage::factory($this->getDb(),$this->getConfig()));
        $types 		= $types->load();

        $status 	= new Statuses(Status\Storage::factory($this->getDb(),$this->getConfig()));
        $status 	= $status->load();

		$usrRefId 	= isset($sessmgt["ref_id"]) ? $sessmgt['ref_id'] : null;
		
		$usrJobId = null;
		$usrOrgId = null;


		$config = $this->getConfig();
		$checkin_recomendation = $config['attendance']['checkin_recomendation'];

		$layout = $this->layout();
		$layout->setVariables(['current' => $this->translate('Manage Request')]);

		$this->using('jquery.validate',29);
		return $this->getView('request',get_defined_vars());
	}
}