<?php
namespace Neuron\Attendance\Controller;

use Neuron\Attendance\Timetable\Group\Members;
use Neuron\Attendance\Timetable\Group\Member;

class GroupMember extends Controller{
	public function loadListAction(){
		$post 		= $this->getREST()->getParameters();
		if(!$post){
			$post 	= $this->getRequest()->getPost();
		}
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		$members 	= new Members(Member\Storage::factory($this->getDb(),$this->getConfig()));
		$mode 		= Member\Storage::LIST_ALL;
		$id 		= null;

		if(isset($post['group_id'])){
			$mode 	= Member\Storage::LISTBY_GROUPID;
			$id 	= $post['group_id'];
		}

		$result 	= $members->load($id,$mode,$post);

		if(isset($post['draw'])){
			if($result->code != 0){
				$res 	= array(
					'recordsTotal' => 0,
					'recordsFiltered' => 0,
					'data' => array(),
					'draw' => $post['draw']
				);
			} else {
				$res = array(
					'recordsTotal' => $result->data['countTotal'],
					'recordsFiltered' => $result->data['countTotal'],
					'data' => $result->data['list'],
					'draw' => $post['draw']
				);
			}
			
			$logparam['subject'] = 'ATTENDANCE GROUP SAVEMEMBERTOGROUPACTION';
			$logparam['identity'] = '';
			$logparam['user'] = '';
			$logparam['description'] = 'Log proses attendance group saveMemberToGroupAction';
			$logparam['request'] = json_encode($requestPost);
			$logparam['response'] = json_encode($res);

			$this->writeLogAction($logparam);
			
			return $this->getOutput(json_encode($res));
		}else{
			
			$responseResult = array(
				'code' => $result->code,
				'info' => $result->info,
				'data' => $result->data
			); 
			
			$logparam['subject'] = 'ATTENDANCE GROUP SAVEMEMBERTOGROUPACTION';
			$logparam['identity'] = '';
			$logparam['user'] = '';
			$logparam['description'] = 'Log proses attendance group saveMemberToGroupAction';
			$logparam['request'] = json_encode($requestPost);
			$logparam['response'] = json_encode($responseResult);

			
			return $this->getREST()->getResponse($result);
		}

	}
}
