<?php
namespace Neuron\Attendance\Controller;

use Neuron\Person\Entities as Persons;
use Neuron\Person\Entity as Person;

use Neuron\Attendance\Timetable;
use Neuron\Attendance\Timetables;

use Neuron\Attendance\Shift;
use Neuron\Attendance\Shifts;


class Index extends Controller {

    protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/attendance/layout/form';
		$prefix = 'neuron/attendance/index';

		/* libraries */
		if(! class_exists('Neuron\Application\Framework\Entity')) {
			$this->using('jquery')
                ->using('bootstrap')
                ->using('theme',99);
        }
        
        $this->using('popper');
        $this->using('fontawesome');
		$this->using('naf-inside', 19);

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

        // $view->setVariables(array(
        //     'sessmgt' => $this->getSession(),
        // ));

		return $view;
    }

    public function TestWidgetAction(){
		$this->usingjs('bootbox', 21);
		$this->using('p-loading', 22);
        $this->usingjs('moment', 23);
        $this->using('chart.js', 24);

        $sessmgt = $this->getSession()->get();
        $sess = (isset($sessmgt['ref_id'])) ? true : false;
        
        return $this->getView('dashboard-widget', get_defined_vars());
	}
	
	public function startingGuideAction(){
		$entities 					= new Persons(Person\Storage::factory($this->getDb(),$this->getConfig()));
		$person 					= $entities->load();
		if($person->code == 0){
			$data 					= $person->data;
			if($data['countTotal'] > 0){
				$person 			= true;
			}else{
				$person 			= false;
			}
		}else{
			$person 					= false;
		}

		$timetables 				= new Timetables(Timetable\Storage::factory($this->getDb(),$this->getConfig()));
		$timetables 				= $timetables->load(null,Timetable\Storage::LISTBY_PAGE,array('page' => 1,'records' => 10));
		
		if($timetables->code == 0){
			$timetable 				= $timetables->data['countTotal'];
		}else{
			$timetable 				= false;
		}

		$shifts 				= new Shifts(Shift\Storage::factory($this->getDb(),$this->getConfig()));
		$shifts 				= $shifts->load(null,Shift\Storage::LISTBY_PAGE,array('page' => 1,'records' => 10));

		if($shifts->code == 0){
			$shift 				= $shifts->data['countTotal'];
		}else{
			$shift 				= false;
		}

		return $this->getView('starting-guide',get_defined_vars());
	}
}
