<?php
namespace Neuron\Attendance\Controller;

use Neuron\Attendance\Entities;
use Neuron\Attendance\Entity as EntityA;
use Neuron\Employee\Entity as EmployeeEntity;
use Neuron\Employee\Map;
use Neuron\Order\Entities as OrderEntities;
use Neuron\Order\Entity as OrderEntity;
use Neuron\Application\Framework\Entity;

class Profile extends Controller{
    protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/attendance/layout/form';
		$prefix = 'neuron/attendance/profile';

		/* libraries */
		if(! class_exists('Neuron\Application\Framework\Entity')) {
			$this->using(
				'bootstrap-4',
				null,
				array(
					'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
					'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
					'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
					'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
				)
			);
		}

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['employee'])) {
			$config = $config['employee'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . $name);

        // $view->setVariables(array(
        //     'sessmgt' => $this->getSession(),
        // ));

		return $view;
	}

    public function summaryAttendanceAction($user){
        $naf            = Entity::get();
        $sessmgt        = $naf->session()->get();
        $active_role    = $sessmgt['active_role']['code'];

        /* Cari tau apakah user yang login = pemilik profile? */
        $sessionOwner   = $naf->session()->owner();
		$isOwner 		= $user->id == $sessionOwner ? true : false;

        // Get employee
        $map        = new Map(Map\Storage::factory($this->getDb(),$this->getConfig()));
        $map->load($user->id,Map\Storage::LOADBY_USERID);
        $employee   = $map->employee();
        $empId      = intval($employee->id);

        // Get attendances
        $startDate  = date('Y-m-01');
        $endDate    = date('Y-m-t');

        $attendance = new EntityA(EntityA\Storage::factory($this->getDb(),$this->getConfig()));
        $totalAttend = intval($attendance->countByType(1,$startDate,$endDate,$empId));
        $totalNotAttend = intval($attendance->countByType(3,$startDate,$endDate,$empId));

        if(class_exists('Neuron\Leave\Model\Entity')){
            $orders  = new OrderEntities(OrderEntity\Storage::factory($this->getDb(),$this->getConfig()));
            // Get total sick
            $paramsSick     = [
                'where' => [
                    'order_subtype_id'  => 2111
                ],
                'sdate' => $startDate,
                'edate' => $endDate
            ];
            $totalSick  = $orders->load($user->id,OrderEntity\Storage::LISTBY_USER,$paramsSick);
            $totalSick  = $totalSick->code == 0 ? count($totalSick->data) : 0;

            $paramsPerminttance     = [
                'where' => [
                    'order_subtype_id'  => 2105
                ],
                'sdate' => $startDate,
                'edate' => $endDate
            ];
            $totalPerminttance  = $orders->load($user->id,OrderEntity\Storage::LISTBY_USER,$paramsPerminttance);
            $totalPerminttance  = $totalPerminttance->code == 0 ? count($totalPerminttance->data) : 0;
        }


        return $this->getView('summary-attendance',get_defined_vars());
    }
}