<?php
namespace Neuron\Attendance\Controller;
use Neuron\Attendance\Entity;

class ReportingHr extends Controller {
    const ATTEND_TYPE_IN                = 0;
    const ATTEND_TYPE_OUT               = 1;
    CONST ATTEND_TYPE_NOT_IN_RANGE_IN   = 2;
    CONST ATTEND_TYPE_NOT_IN_RANGE_OUT  = 3;
    CONST ATTEND_TYPE_ALREADY_IN        = 4;
    CONST ATTEND_TYPE_ALREADY_OUT       = 5;

	protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/attendance/layout/form';
		$prefix = 'neuron/attendance/v2_1';

		/* libraries */
		// $this->using('jquery', null, false)
		// 	->using('bootstrap', null)
		// 	->using('font-awesome', null, true, false);
		
		/* libraries */;
        $this->using('font-awesome', 10, 'https://use.fontawesome.com/releases/v5.8.1/css/all.css');

        $this->using('select2', 22, array(
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
             /* ini load sesuai bahasa dari session */
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
             /**/
            'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
            'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
        ));
	    $this->using('generic');
		
		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}

	public function summaryAction() {
        $sessmgt = $this->getSession()->get();
        $sess = (isset($sessmgt['ref_id'])) ? true : false;

        $this->using('bootbox', 21);
		$this->using('p-loading', 22);
		$this->using('moment', 23);
		$this->usingjs('jquery.validate', 34);
        $this->using('air-datepicker', 24);
        $title = 'Dashboard attendance';

        # generate filter value
        $last_filter = $this->params()->fromQuery();
        $start_date = (isset($last_filter['start_date']) && !empty($last_filter['start_date'])) ? $last_filter['start_date'] : date("d F Y", mktime(0, 0, 0, date("m"), 1));
        $end_date = (isset($last_filter['end_date']) && !empty($last_filter['end_date'])) ? $last_filter['end_date'] : date('t F Y');
        $interval = (isset($last_filter['interval']) && !empty($last_filter['interval'])) ? $last_filter['interval'] : 2;
        $interval_recomendation = (isset($last_filter['interval_recomendation']) && !empty($last_filter['interval_recomendation'])) ? $last_filter['interval_recomendation'] : 2;

        $range = (isset($last_filter['range']) && !empty($last_filter['range'])) ? $last_filter['range'] : null;
        $range_recomendation = (isset($last_filter['range_recomendation']) && !empty($last_filter['range_recomendation'])) ? $last_filter['range_recomendation'] : null;

        # recomendation summary
        $filter['start_date'] = date("Y-m-d", strtotime($start_date));
        $filter['end_date'] = date("Y-m-d", strtotime($end_date));
        $params = array(
            'where' => array(
                'sdate' => $filter['start_date'],
                'edate' => $filter['end_date'],
            )
        );

        // get data approvals
        $approvals = $this->countRequestAction($params);

        // "data": {"data":{"where":{"order_type_id":$("#order_type_id").val(),"order_status_id":$("#order_status_id").val(),"create_user_id":$("#set_create_user_id").val(), "sdate":$("#start_dt").val(),"edate":$("#end_dt").val()}}},

        if ($approvals->code == 0) {
            // count total approval request
            
            $app_count = 0;
            foreach ($approvals->data as $key => $val ) {
                $type_code  = $key;
                $count      = $val['counter'];
                $app_count  +=$count;
                $labels[]   = $val['label'];
                $counter[]  = $val['counter'];
            }

            // detail summary approval request
            $app_request = $approvals->data;  
        }

        // summary pamantra
        $pparams = array(
            'filter_period'=> '2020-01', 
            'type_chart'=>'Full',
        );
        
        $pamantra = $this->pamantraAction($pparams);
        $count_pamantra =  count($pamantra->data['list']);

        return $this->getView('reporting/summary', get_defined_vars());
    }
    
    public function countRequestAction($params){
        $entities = new \Neuron\Approval\Entities(\Neuron\Order\Entity\Storage::factory($this->getDb(),$this->getConfig()));
        $result = $entities->reportChart($data->data['keyword'], $data->data['mode'], $params);

        return $result;
    }

    public function pamantraAction($params){
        $storage = \Neuron\Payroll\Bonus\Storage::factory($this->getDb(), $this->getConfig());
        $entity = new \Neuron\Payroll\Bonuses($storage);
        $bonus = new \Neuron\Payroll\Bonus($storage);

        $mode = isset($post['mode'])? $post['mode']: \Neuron\Payroll\Entity\Storage::LIST_ALL;
        $keyword = @$post['keyword'];
        $result = $entity->load($keyword, $mode, $params);

        return $result;
    }

	public function summarysAction() {

		
		$this->using('bootbox', 21);
		$this->using('p-loading', 22);
		$this->using('moment', 23);
		$this->usingjs('jquery.validate', 34);
        $this->using('air-datepicker', 24);

		$sessmgt = $this->getSession()->get();
		$sess = (isset($sessmgt['ref_id'])) ? true : false;

        $last_filter = $this->params()->fromQuery();

		$title = 'Attendance';
        $start_date = (isset($last_filter['start_date']) && !empty($last_filter['start_date'])) ? $last_filter['start_date'] : date("d F Y", mktime(0, 0, 0, date("m"), 1));
        $end_date = (isset($last_filter['end_date']) && !empty($last_filter['end_date'])) ? $last_filter['end_date'] : date('t F Y');
        $interval = (isset($last_filter['interval']) && !empty($last_filter['interval'])) ? $last_filter['interval'] : 2;
        $interval_recomendation = (isset($last_filter['interval_recomendation']) && !empty($last_filter['interval_recomendation'])) ? $last_filter['interval_recomendation'] : 2;

        $range = (isset($last_filter['range']) && !empty($last_filter['range'])) ? $last_filter['range'] : null;
        $range_recomendation = (isset($last_filter['range_recomendation']) && !empty($last_filter['range_recomendation'])) ? $last_filter['range_recomendation'] : null;

        //load data summary
        $filter['start_date'] = date("Y-m-d", strtotime($start_date));
        $filter['end_date'] = date("Y-m-d", strtotime($end_date));
        $filter['ref_id'] = $sessmgt['ref_id'];
        $entity = new Entity(Entity\Storage::factory($this->getDb(), $this->getConfig()));
        $result = $entity->loadSummary($filter);
        $summary = $result->data;


        //load data attendance
        $entity     = new \Neuron\Attendance\Entity(\Neuron\Attendance\Entity\Storage::factory($this->getDb(),$this->getConfig()));
        $result     = $entity->load(
            null,\Neuron\Attendance\Entity\Storage::LOADBY_ID,
            array(
                'ref_id'        => $sessmgt['ref_id'],
                'start_date'    => date("Y-m-d")
            )
        );
        $dataAttendance = $entity->pull();

        $shift                  = new \Neuron\Attendance\Shift(\Neuron\Attendance\Shift\Storage::factory(
            $this->getDb(),$this->getConfig()
        ));
        $data['ref_id']         = $sessmgt['ref_id'];
        $data['start_date']     = date('Y-m-d');
        $data['start_dtm']      = date('Y-m-d H:i:s');
        $data['day_no']         = $shift->getDayNumber($data['start_date'])->data;
        $shift->load(null,\Neuron\Attendance\Shift\Storage::LOADBY_BETWEENDATE_REF_ID_DAYNO,$data);
        $canAttend              = true;
        $info                   = "Can attend";
        $attendType             = self::ATTEND_TYPE_IN;
        $autoPop                = false;
        
        $isWorkday  = $shift->is_workday;
        if($isWorkday){
            if($entity->id && $entity->type_id != 3){
                // udah ada absennya 
                $isWithinRange          = $shift->isWithinTimeRange(date('H:i:s'),$shift->out_beginning_time,$shift->out_ending_time);
                if(!$isWithinRange){
                    // Belum jam pulang, berarti gabisa absen
                    $canAttend  = false;
                    $info       = $this->translate("You're already attended. you cannot clock out at this time.");
                    $attendType = self::ATTEND_TYPE_NOT_IN_RANGE_OUT;
                }else{
                    if($entity->end_dtm != null){
                        $canAttend  = false;
                        $info       = $this->translate("You're already clock out.");
                        $attendType = self::ATTEND_TYPE_ALREADY_OUT;
                    }else{
                        $attendType = self::ATTEND_TYPE_OUT;
                    }
                }
            }else{
                /* Cari dulu, hari ini libur ga */
                $events             = new \Neuron\Calendar\Events(\Neuron\Calendar\Event\Storage::factory(
                    $this->getDb(),
                    $this->getConfig()
                ));
                $loadEvents   = $events->load(
                    0, # 0 = hari libur
                    \Neuron\Calendar\Event\Storage::LISTBY_WORKDAY,
                    array(
                        'start_date'    => date('Y-m-d',strtotime($data['start_dtm'])),
                        'end_date'      => date('Y-m-d',strtotime($data['start_dtm'])),
                        'date_between'  => true
                    )
                );
                if($loadEvents->code == 0){
                    $data   = $loadEvents->data;
                    $eventData = $data['list'][0];
                    $canAttend = false;
                    $attendType = self::ATTEND_TYPE_NOT_IN_RANGE_IN;
                    $info       = $this->translate("Cannot attend at holiday").". [ ".$eventData['event_title']." ]";
                }else{
                    // Check kalo melewati batas waktu absen, gabisa absen;
                    $canAttend      = $shift->isWithinTimeRange(date("H:i"),$shift->in_beginning_time,$shift->in_ending_time);
                    $attendType     = ($canAttend) ? self::ATTEND_TYPE_IN : self::ATTEND_TYPE_NOT_IN_RANGE_IN;
                    $info           = ($canAttend) ? "OK" : $this->translate("Cannot clock in at this time. Clock in start at") .' '. $shift->in_beginning_time .' '. $this->translate('Until') .' '.$shift->in_ending_time;
                    $autoPop        = ($canAttend) ? true : false;
                }

            }
        }else{
            $info       = "Cannot Attend at holiday"; 
            $canAttend  = false;
        }

        $paramsAttendance = [
            'can_attend'    => $canAttend,
            'attendance'    => $entity->pull(),
            'shift'         => $shift->pull(),
            'attend_type'   => $attendType,
            'auto_pop'      => $autoPop,
            'info'          => $info
        ];


		return $this->getView('reporting/summary', get_defined_vars());
	}
    public function summaryDataAction() {

		$sessmgt = $this->getSession()->get();

        $post = $this->getREST()->getParameters();

        //load data summary
        $filter['start_date'] = isset($post['start_date'])? date("Y-m-d", strtotime($post['start_date'])) : date("Y-m-d", mktime(0, 0, 0, date("m"), 1));
        $filter['end_date'] = isset($post['end_date'])? date("Y-m-d", strtotime($post['end_date'])) : date("Y-m-t");
        $filter['ref_id'] = $sessmgt['ref_id'];
        $entity = new Entity(Entity\Storage::factory($this->getDb(), $this->getConfig()));
        $result = $entity->loadSummary($filter);

        return $this->getREST()->getResponse($result);
	}

    public function howWellStatusAction() {
        $result = new \Neuron\Generic\Result();
		$sessmgt = $this->getSession()->get();

        $post = $this->getREST()->getParameters();
        if($post['interval'] == 1){
            $start_date = date('Y-m-d',strtotime('this week monday'));
            $end_date = date('Y-m-d',strtotime('this week sunday'));
        }elseif ($post['interval'] == 2){ 
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m"), 1));
            $end_date = date("Y-m-t");
        }elseif ($post['interval'] == 3){ 
            $start_date = date("Y-01-d", mktime(0, 0, 0, date("m"), 1));
            $end_date = date("Y-12-t");
        }elseif ($post['interval'] == 4){
            $range = explode(' - ',$post['range']);
            $start_date = date("Y-m-d", strtotime($range[0]));
            $end_date = date("Y-m-d", strtotime($range[1])) ;
        }


        //load data summary
        $filter['start_date'] = $start_date;
        $filter['end_date'] = $end_date;
        $filter['ref_id'] = $sessmgt['ref_id'];
        $entity = new Entity(Entity\Storage::factory($this->getDb(), $this->getConfig()));
        $retval = $entity->loadSummary($filter);
        $dataRetval = $retval->data;
        $dataRetval['start_date'] = date("d F Y", strtotime($start_date));
        $dataRetval['end_date'] = date("d F Y", strtotime($end_date));

        $result->data = $dataRetval;
        return $this->getREST()->getResponse($result);
	}

    public function summaryRecommendationAction()
    {
        $result = new \Neuron\Generic\Result();
		$sessmgt = $this->getSession()->get();

        $post = $this->getREST()->getParameters();
        if($post['interval'] == 1){
            $start_date = date('Y-m-d',strtotime('this week monday'));
            $end_date = date('Y-m-d',strtotime('this week sunday'));
        }elseif ($post['interval'] == 2){ 
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m"), 1));
            $end_date = date("Y-m-t");
        }elseif ($post['interval'] == 3){ 
            $start_date = date("Y-01-d", mktime(0, 0, 0, date("m"), 1));
            $end_date = date("Y-12-31");
        }elseif ($post['interval'] == 4){
            $range = explode(' - ',$post['range']);
            $start_date = date("Y-m-d", strtotime($range[0]));
            $end_date = date("Y-m-d", strtotime($range[1])) ;
        }

        $filter['start_date'] = $start_date;
        $filter['end_date'] = $end_date;
        $filter['ref_id'] = $sessmgt['ref_id'];
        $filter['user_id'] = $sessmgt['user_id'];
        // $entity = new Entity(Entity\Storage::factory($this->getDb(), $this->getConfig()));
        // $result = $entity->loadSummaryRecommendation($filter);
        $sApproval = \Neuron\Order\Entity\Storage::factory($this->getDb(), $this->getConfig());
        $mApproval = new \Neuron\Approval\Entities($sApproval);
        $where['where']['create_user_id'] = $filter['user_id'];
        $where['where']['order_status_id'] = 2;
        $where['where']['xn5'] = 2;
        $where['where']['sdate'] = $filter['start_date'];
        $where['where']['edate'] = $filter['end_date'];
        $retval = $mApproval->reportChart(null, \Neuron\Order\Entity\Storage::LIST_ALL, $where, true);


        $dataRetval['list'] = $retval->data;
        $dataRetval['start_date'] = date("d F Y", strtotime($start_date));
        $dataRetval['end_date'] = date("d F Y", strtotime($end_date));

        $result->data = $dataRetval;
        return $this->getREST()->getResponse($result);
    }

    public function summaryDetailAction() {

		$this->using('bootbox', 21);
		$this->using('p-loading', 22);
		$this->using('moment', 23);
		$this->usingjs('jquery.validate', 34);
        $this->using('air-datepicker', 24);

		// $sessmgt = $this->getSession()->get();
		// $sess = (isset($sessmgt['ref_id'])) ? true : false;

        // $type_id = $this->params()->fromQuery('type');
        // $filter  = $this->params()->fromQuery('filter');
        // $delimiter = $this->translate("to");
        // $range = explode($delimiter, $filter);

		// $title = 'Attendance';
        // if(count($range) > 1){
        //     $start_date = date("d F Y", strtotime($range[0]));
        //     $end_date = date('d F Y', strtotime($range[1]));
        // }else{
        //     $start_date = date("d F Y", mktime(0, 0, 0, date("m"), 1));
        //     $end_date = date('t F Y');
        // }

		return $this->getView('reporting/app-summary-detail', get_defined_vars());
	}

    public function dataSummaryDetailAction() {
        $result = new \Neuron\Generic\Result();
		$sessmgt = $this->getSession()->get();

        $post       = $this->getRequest()->getPost();

        //load data summary
        $post['start_date'] = isset($post['start_date'])? date("Y-m-d", strtotime($post['start_date'])) : date("Y-m-d", mktime(0, 0, 0, date("m"), 1));
        $post['end_date'] = isset($post['end_date'])? date("Y-m-d", strtotime($post['end_date'])) : date("Y-m-t");
        $post['ref_id'] = $sessmgt['ref_id'];
        
        if(isset($post['type_id']) && empty($post['type_id'])){
            unset($post['type_id']);
        }
        $entities = new \Neuron\Attendance\Entities(Entity\Storage::factory($this->getDb(), $this->getConfig()));
        
        $result       = $entities->load(null,\Neuron\Attendance\Entity\Storage::LIST_ALL,$post);
        if($result->code == 0){
            if(isset($post['draw'])){
                $resData    = array(
                    'draw' => $post['draw'],
                    'recordsTotal' => $result->data['countTotal'],
                    'recordsFiltered' => $result->data['countTotal'],
                    'data'  => $result->data['rows']
                );
            }else{
                $resData    = array(
                    'draw' => $post['draw'],
                    'recordsTotal' => 0,
                    'recordsFiltered' => 0,
                    'data'  => array()
                );
            }
            return $this->getOutput(json_encode($resData));

        }

        return $this->getREST()->getResponse($result);
	}
}