<?php
namespace Neuron\Attendance\Controller;

use Neuron\Attendance\Module;
use Neuron\Attendance\Timetable as TimetableModel;
use Neuron\Generic\Result;
use Neuron\Attendance\Timetable\Group;
use Neuron\Attendance\Timetable\Changeshift;
use Neuron\Attendance\Timetable\Objects;
use Neuron\Attendance\Timetable\ObjectTimetable;
use Neuron\Attendance\Timetables;

class Timetable extends Controller {

	protected $ref_code = 'Employee';
	protected $ref_id = '1111';
	const UPDATE_BY = '10000000';
	protected $_UPDATE_BY;


	const SUNDAY 		= 1;
	const MONDAY 		= 2;
	const TUESDAY 		= 3;
	const WEDNESDAY 	= 4;
	const THURSDAY 		= 5;
	const FRIDAY 		= 6;
	const SATURDAY 		= 7;

	protected function getView($name, $variables = array()){
		/* default layout & view prefix */
		$layout = 'neuron/attendance/layout/form';
		$prefix = 'neuron/attendance/timetable';

		$this->using('font-awesome', 10, 'https://use.fontawesome.com/releases/v5.8.1/css/all.css');

	    $this->using('select2', 22, array(
	        'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
	         /* ini load sesuai bahasa dari session */
	        'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
	         /**/
	        'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
	        'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
	    ));

		/* libraries */;
		if(! class_exists('Neuron\Application\Framework\Entity')) {
	        $this->using(
		            'bootstrap-4',
		            null,
		            array(
		                'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
		                'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
		                'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
		                'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
		            )
		        )
		        ->using('toast',null)
		        ->using('bootbox',null);
		}
		
		$this->using('generic',99);

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}
	protected function getViewPartial($name, $variables = array()){
		$prefix = 'neuron/attendance/timetable';

		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}
	public function ManageAction(){
	    $this->usingjs('bootbox', 21);
	    $this->using('p-loading', 22);
	    $this->using('bootstrap-select', 23);
		$this->using('generic', 24);

		$this->usingjs('moment-weekdaysin', 26);

		$this->using('datatable', 20, array(
		    'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
		    'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
		    'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));


	    $this->using('jquery.validate',28);

		$sessmgt = $this->getSession()->get();
        $sess = (isset($sessmgt['ref_id'])) ? true : false;

		$title = 'Timetables';
		
		// ACL
		$add = $this->checkGrants('add_timetable');
		$edit = $this->checkGrants('edit_timetable');
		$remove = $this->checkGrants('remove_timetable');
		$detail = $this->checkGrants('detail_timetable');
		$manageshift = $this->checkGrants('manageshift_timetable');
		$mappingshift = $this->checkGrants('mappingshift_timetable');

		$layout = $this->layout();
		// $layout->setVariables(['previous' => '<a href="'.$this->getPublicURL().'/attendance/form/request">'.$this->translate("Request").'</a>']);
		$layout->setVariables(['current' => $this->translate('Manage timeshift')]);

		if(!isset($_GET['tour'])){
			if(!file_exists('temp/flagAttendance/flagAdmin.txt')){
				if(!file_exists('temp/flagAttendance')){
					mkdir('temp/flagAttendance',0775);
				}
				fopen('temp/flagAttendance/flagAdmin.txt','w');
				$this->redirect()->toUrl($this->getPublicUrl().'/attendance/timetable/manage?tour=1');
			}
		}

		return $this->getView('manage', get_defined_vars());
	}
	public function listAction(){
		$post = $this->getPostParams();

		$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(), $this->getConfig());
		$model = new \Neuron\Attendance\Timetable($storage);

		$result = $model->listdata($post);

		if(isset($post['draw'])){
			$response = $this->getResponse();
			$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
			$response->setContent(json_encode($result));
			return $response;
		}else{
			return $this->getREST()->getResponse($result);
		}
	}
	public function FormTimetableAction(){
		$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(), $this->getConfig());

		$title = "Attendance Form";
		$id = $this->params()->fromQuery('id');
		$data = null;

		if($id) {
			$model = new \Neuron\Attendance\Timetable($storage);
			$data = $model->load($id);
		}

		$request = $this->getRequest();
		$params = $request->getPost();

		if ($request->isPost())
		{
			$update = (!empty($params['timetable_id'])) ? true : false;

			$data = array(
					'timetable_id' => $params['timetable_id'],
					'code' => $params['code'],
					'time_mode' => $params['time_mode'],
					'name' => $params['name'],
				);

			$model = new \Neuron\Attendance\Timetable($storage, $data);
			$retval = $model->save($update);

			$response = $this->getResponse();
			$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
			$response->setContent(json_encode($retval));
			return $response;
		}

		$data = $data['data'];
		return $this->getViewPartial('form', get_defined_vars());
	}
	public function IsCodeExistAction() {
		$code = $this->params()->fromPost('code');
		$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(), $this->getConfig());

		$model = new \Neuron\Attendance\Timetable($storage);
		$result = $model->searchByCode($code);

		$return = ($result)? false:true;

		$response = $this->getResponse();
		$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
		$response->setContent(json_encode($return));
		return $response;
	}
	public function ManageShiftAction() {
		$this->using("jquery.validate",28);
		$this->using('air-datepicker',30);
		
		$this->using('datatable', 20, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
		    'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
		    'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		
		$this->using('moment',24);
		$this->usingjs('moment-weekdaysin', 26);

	    $this->usingjs('bootbox', 21);
	    $this->using('p-loading', 22);
	    $this->using('bootstrap-select', 23);
		$this->using('generic', 35);
		$this->using('bootstrap-select',36);

		$post = $this->getPostParams();

		// ACL
		$add = $this->checkGrants('add_shift');
		$edit = $this->checkGrants('edit_shift');
		$remove = $this->checkGrants('remove_shift');
		$detail = $this->checkGrants('detail_shift');

		$layout = $this->layout();
		$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/attendance/timetable/manage">' . $this->translate("Manage timeshift") . '</a>']);
		$layout->setVariables(['current' => $this->translate('Manage Shift')]);

		$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(), $this->getConfig());
		$model = new \Neuron\Attendance\Timetable($storage);

		$sessmgt = $this->getSession()->get();
		$sess = (isset($sessmgt['ref_id'])) ? true : false;
		$title = 'Timetable';

		$data = $model->loadTimetable($post['id']);
		// print_r($data); die();
		$id = $data['timetable_id'];
		$code = $data['code'];
		$time_mode = $data['time_mode'];
		return $this->getView('manage-shift', get_defined_vars());
	}
	public function FormShiftAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());

		$title = "Shift Form";
		$TimetableID = $this->params()->fromQuery('tid');
		$id = $this->params()->fromQuery('id');
		$data = null;

		$request = $this->getRequest();
		$params = $request->getPost();

		if ($request->isPost()){
			$update = (!empty($params['timetable_shift_id'])) ? true : false;

			$i = 0;
			foreach($params['day_no'] as $row) {
				$data = array(
						'timetable_shift_id' => $params['timetable_shift_id'],
						'timetable_id' => $params['timetable_id'],
						'shift_no' => time(),
						'day_no' => $row,
						'is_workday' => $params['is_workday'],
						'on_duty_time' => $params['on_duty_time'],
						'off_duty_time' => $params['off_duty_time'],
						'in_beginning_time' => $params['in_beginning_time'],
						'in_ending_time' => $params['in_ending_time'],
						'out_beginning_time' => $params['out_beginning_time'],
						'out_ending_time' => $params['out_ending_time'],
						'late_time' => $params['late_time'],
						'overtime_start_time' => $params['overtime_start_time'],
						'start_date' => $params['start_date'],
						'end_date' => $params['end_date'],
					);

				$model = new \Neuron\Attendance\Shift($storage, $data);
				$retval = $model->save($update);

				$i++;
			}

			$response = $this->getResponse();
			$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
			$response->setContent(json_encode($i === count($params['day_no'])));
			return $response;
		}
		else {
			if($id) {
				$model = new \Neuron\Attendance\Shift($storage);
				$data = $model->load($id);
			}
		}

		$data = $data['data'];
		return $this->getViewPartial('form-shift', get_defined_vars());
	}
	public function ShiftListAction() {
		$sessmgt = $this->getSession()->get();
		$request = $this->getRequest();
		$post = $this->getPostParams();

		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
		$shift = new \Neuron\Attendance\Shift($storage);

		if(isset($post['search']['value']) && $post['search']['value']){
			$post = $post->toArray();
			$post['search']['value'] = $this->getDayNoSearch($post['search']['value']) ?? $post['search']['value'];
			$post['day_no'] = $this->getDayNoSearch($post['search']['value']) ?? false;
		}

		$result = $shift->listdata($post);
		$data = $result->data;
		if($data['rows']){
			$rows = [];
			foreach ($data['rows'] as $row) {
				$row['day_name'] = $this->translate($row['day_name']);
				$rows[] = $row;
			}
			$data['rows'] = $rows;
		}
		$output = array(
			'draw' => $post['draw'],
			'recordsTotal' => intval($data['total']),
			'recordsFiltered' => intval($data['total']),
			'data' => $data['rows']
		);
		return $this->getOutput(json_encode($output));
	}
	public function IsShiftExistAction() {
		$param['timetable_id'] = $this->params()->fromPost('tid');
		$param['shift_no'] = $this->params()->fromPost('sn');
		$param['day_no'] = $this->params()->fromPost('dn');

		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());

		$model = new \Neuron\Attendance\Shift($storage);
		$result = $model->searchByShiftDay($param);

		$return = ($result)? false:true;

		$response = $this->getResponse();
		$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
		$response->setContent(json_encode($return));
		return $response;
	}
	public function deleteShiftAction() {
	    $storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	  	$shift = new \Neuron\Attendance\Shift($storage);

	    $post = $this->getPostParams();
	    $post['by'] = 'timetable';
	    $result = $shift->listObject($post);
	  	if($result){
	  		echo json_encode(array('success' => false, 'message'=> 'Cannot delete shift. shift already used.'));
	    	return $this->getResponse();
	  	}
	    $deltt = $shift->delete($post['id']);
	    $success = false;
		if ($deltt) $success = true;

	    echo json_encode(array('success' => $success));
	    return $this->getResponse();
	}
	public function replaceShiftAction(){
		$post = $this->getPostParams();
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());

		$shift = new \Neuron\Attendance\Shift($storage);
		$update = (!empty($post['timetable_shift_id'])) ? true : false;

		$dayno = $post['day_no'];
		if($dayno){
			foreach ($dayno as $value) {
				$shift->timetable_shift_id = $post['timetable_shift_id'];
				$shift->timetable_id = $post['timetable_id'];
				$shift->shift_no = $post['shift_no'];
				$shift->day_no = $value;
				$shift->is_workday = $post['is_workday'];
				$shift->on_duty_time = $post['on_duty_time'];
				$shift->off_duty_time = $post['off_duty_time'];
				$shift->in_beginning_time = $post['in_beginning_time'];
				$shift->in_ending_time = $post['in_ending_time'];
				$shift->out_beginning_time = $post['out_beginning_time'];
				$shift->out_ending_time = $post['out_ending_time'];
				$shift->late_time = $post['late_time'];
				$shift->leave_early_time = $post['leave_early_time'];
				$shift->overtime_start_time = $post['overtime_start_time'];
				$shift->start_date = date('Y-m-d', strtotime($post['start_date']));
				$shift->end_date = date('Y-m-d', strtotime($post['end_date']));

				$retval = $shift->replace($update);
				if(!$retval){
					echo json_encode(array('success'=>false, 'message'=> 'Error on replace shift!'));
						return $this->getResponse();
				}
			}
		}
		echo json_encode(array('success'=>true, 'message'=> 'shift replaced'));
			return $this->getResponse();
	}
	public function listMiscAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
		$ms = new \Neuron\Attendance\Shift($storage);
		$post = $this->getPostParams();

		$listMisc = array();
		$dataMisc = $ms->listMisc($post['id']);
		if($dataMisc){
			foreach ($dataMisc as $value) {
				array_push($listMisc, $value);
			}
		}
		
		return $this->getOutput(json_encode(array('success'=>true, 'message'=> 'loaded', 'data'=> $listMisc)));
	}
	public function saveShiftMiscAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
		$ms = new \Neuron\Attendance\Shift($storage);
		$post = $this->getPostParams();

		$update = false;
		if($post['shift_misc_id']){
			$update = true;
		}
		
		$dataMisc = $ms->saveMisc($post, $update);
		
		$success = false;
		$message = $dataMisc->info;

		if($dataMisc->code == 0){
			$success = true;
			$message = 'Shift misc saved' ;
		}
		
		echo json_encode(array('success'=>$success, 'message'=> $message));
		return $this->getResponse();
	}
	public function deleteMiscAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
		$ms = new \Neuron\Attendance\Shift($storage);
		$post = $this->getPostParams();

		$delsm = $ms->deleteMisc($post['id']);
	    $success = false;
		if ($delsm) $success = true;

		echo json_encode(array('success'=>$success));
		return $this->getResponse();
	}
	public function listGroupAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	  	$ctt = new \Neuron\Attendance\Shift($storage);

	  	$post = $this->getPostParams();
	  	if($post['id']){
	  		$result = $ctt->listGroup($post['id']);
	  	}else{
	  		$result = $ctt->listGroup(null);
	  	}
	  	$arrGroup  = array();
	  	$arrMap = array();
	  	if($result){
	  		foreach ($result as $value) {
	  			if (!array_key_exists($value['group_id'], $arrMap)){
		  			$arrMap[$value['group_id']] = array();	
	  			}
	  			array_push($arrMap[$value['group_id']], $value['timetable_id']);
	  			$url_in_array = in_array($value['group_id'], array_column($arrGroup, 'group_id'));
				if(!$url_in_array) {
	  				array_push($arrGroup, $value);   
				}
	  		}
	  	}
		 	echo json_encode(array('listGroup'=>$arrGroup, 'Mapping'=>$arrMap));
			return $this->getResponse();
	}
	public function saveGroupAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	    $ctt = new \Neuron\Attendance\Shift($storage);
	    $group = new Group(Group\Storage::factory($this->getDb(),$this->getConfig()));

	    $post = $this->getPostParams();

	    if (!empty($post['group_id'])) {
	        $update = true;
	    } else {
	        $update = false;
	    }

	    $loadGroup = $group->loadEx($post['name'],Group\Storage::LOADBY_NAME);
	    if($loadGroup->data){
	    	$result = new \Neuron\Generic\Result(0,400,$this->translate('Group with the same name already exists.'));
	    }else{
		    $retval = $ctt->saveGroup($post, $update);
		    if($retval){
		    	$result = new \Neuron\Generic\Result(0,0,$this->translate('Success saving group.'));
		    }else{
		    	$result = new \Neuron\Generic\Result(0,500,$this->translate('Failed saving group.'));
		    }
	    }
	    return $this->getREST()->getResponse($result);
	}
	public function deleteGroupAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	    $ctt = new \Neuron\Attendance\Shift($storage);
	    
	    $post = $this->getPostParams();
	    // $delGroupTt = $ctt->deleteGroupTt($post['group_id']);
	    // $delGroupTt = $ctt->deleteObjectTt($post['group_id']);
	    // $delGroupMem = $ctt->deleteGroupMem($post['group_id']);
	    $delGroup = $ctt->deleteGroup($post['group_id']);
	    $success = false;
	    if ($delGroup) $success = true;

	    echo json_encode(array('success' => $success));
	    return $this->getResponse();
	}
	public function listObjectAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	  	$ctt = new \Neuron\Attendance\Shift($storage);

	  	$post = $this->getPostParams();
	  	$result = $ctt->listObject($post);
	  	$arrObject  = array();
	  	if($result){
	  		foreach ($result as $value) {
	  			array_push($arrObject, $value);
	  		}
	  	}
		 	echo json_encode(array('listObject'=>$arrObject));
			return $this->getResponse();
	}
	public function deleteObjectAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	    $ctt = new \Neuron\Attendance\Shift($storage);
	    
	    $post = $this->getPostParams();

	    $post['update_by'] = self::UPDATE_BY;

	    $delGroup = $ctt->deleteObject($post);
	    $success = false;
	    if ($delGroup) $success = true;

	    echo json_encode(array('success' => $success));
	    return $this->getResponse();
	}
	public function saveTimeshiftObjectAction(){
		$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
	    $ctt = new \Neuron\Attendance\Shift($storage);
	    $post = $this->getPostParams();
	    $timetable_id = $post['timetable_id'];
	    if(array_key_exists('group', $post)){
	    	$listGroup = $post['group'];
	    }else{
	    	$listGroup = array();
	    }
	    if(array_key_exists('date_tt', $post)){
	    	$listDate = $post['date_tt'];
	    }else{
	    	$listDate = array();
	    }
	   
	    $arrObject = array();
	    $listGroupOld = array();
	    // print_r($listGroup); die();
	    $dataGroupOld = $ctt->loadGroupTimetable($timetable_id);
	    // print_r($dataGroupOld);die();
	    if($dataGroupOld){
	    	foreach ($dataGroupOld as $groupOld) {
	    		if(!in_array($groupOld['group_id'], $listGroup)){
	    			$gObject = array('by'=>'group', 'id'=>$groupOld['group_id']);
	    			$listObject = $ctt->listObject($gObject);
	    			// print_r($listObject);die();
	    			if($listObject){
	    				foreach ($listObject as $object) {
	    					// print_r($object); die();
	    					$data['update_by'] = self::UPDATE_BY;
	    					$data['timetable_id']= $timetable_id;
	    					$data['ref_id'] = $object['ref_id'];
	    					$delObject = $ctt->deleteObjectByRef($data);
	    					if(!$delObject){
	    						echo json_encode(array('success' => false, 'message'=>'error on terminate object in timeshift'));
	        					return $this->getResponse();
	    					}
	    				}
	    			}
	    			$datagt['id'] = $groupOld['id'];
	    			$datagt['applied_by'] = self::UPDATE_BY;
	    			$ctt->deleteShiftGroupTable($datagt);
	    		}
	    	}
	    }

	    if(count($listGroup)>0){
	    	foreach ($listGroup as $value) {
	    		$gObject = array('by'=>'group', 'id'=>$value);
	    		$start_date_tt = $listDate[$value]['start_date_tt'];
	    		$end_date_tt = $listDate[$value]['end_date_tt'];
	    		$checkGroup = $ctt->checkGroupByDate($value, $timetable_id, $start_date_tt, $end_date_tt); 
	    		// print_r($checkGroup); die();
	    		if(!$checkGroup){
	    			$listObject = $ctt->listObject($gObject);
	        		if($listObject){
				  		foreach ($listObject as $val) {
				  			$checkobj =$ctt->checkObjectByDate($val['ref_id'], $timetable_id, $start_date_tt, $end_date_tt);
				  			// print_r($checkobj);
				  			if (!$checkobj) {
				  				$data['timetable_id'] = $timetable_id;
				                $data['ref_id'] = $val['ref_id'];
				                $data['ref_code'] = 'EMPLOYEE';
				                $data['start_date'] = $start_date_tt;
				                $data['end_date'] = $end_date_tt;
				                $data['update_by'] = self::UPDATE_BY;
				                $save = $ctt->saveShiftObjectTable($data, false);
				                if(!$save){
				                	echo json_encode(array('success' => false, 'message'=>'error on mapping object to timeshift'));
	        						return $this->getResponse();
				                }
				            }else{
				            	if( $end_date_tt > $checkobj['end_date']){
				            		// print_r('bisa diatur');die();
				            		$data['timetable_id'] = $timetable_id;
					                $data['ref_id'] = $val['ref_id'];
					                $data['ref_code'] = 'EMPLOYEE';
					                $data['start_date'] = date('Y-m-d', strtotime($checkobj['end_date'] . ' +1 day'));
					                $data['end_date'] = $end_date_tt;
					                $data['update_by'] = self::UPDATE_BY;
					                $save = $ctt->saveShiftObjectTable($data, false);
					                if(!$save){
					                	echo json_encode(array('success' => false, 'message'=>'error on mapping object to timeshift'));
		        						return $this->getResponse();
					                }
				            	}else{
					            	echo json_encode(array('success' => false, 'message'=>'ref id already mapped on this date'));
		        					return $this->getResponse();
				            	}
				            }
				  		}
				  	}
				  	$dataGroup['object_group_id'] = $value;
				  	$dataGroup['timetable_id'] = $timetable_id;
				  	$dataGroup['start_date'] = $start_date_tt;
				  	$dataGroup['end_date'] = $end_date_tt;
				  	$dataGroup['applied_status'] = 1;
				  	$dataGroup['applied_by'] = self::UPDATE_BY;
				  	$saveGroupTt = $ctt->saveShiftGroupTable($dataGroup, false);
				  	if(!$saveGroupTt){
				  		echo json_encode(array('success' => false, 'message'=>'error on mapping group to timeshift'));
	        			return $this->getResponse();
				  	}
	    		}else{
	    			$listObject = $ctt->listObject($gObject);
	        		if($listObject){
				  		foreach ($listObject as $val) {
				  			$checkobj =$ctt->checkObjectByDate($val['ref_id'], $timetable_id, $start_date_tt, $end_date_tt); 
				  			if (!$checkobj) {
				  				$data['timetable_id'] = $timetable_id;
				                $data['ref_id'] = $val['ref_id'];
				                $data['ref_code'] = 'EMPLOYEE';
				                $data['start_date'] = $start_date_tt;
				                $data['end_date'] = $end_date_tt;
				                $data['update_by'] = self::UPDATE_BY;
				                $save = $ctt->saveShiftObjectTable($data, false);
				                if(!$save){
				                	echo json_encode(array('success' => false, 'message'=>'error on mapping object to timeshift'));
	        						return $this->getResponse();
				                }
				            }
				  		}
				  	}
	    		}
	    	}
	    }
	    // print_r($post['timetable_id']); die();
	   	// $saveTos = $ctt->saveObject($post, $update, $asMember); 

	    echo json_encode(array('success' => true));
	    return $this->getResponse();
	}
	public function saveTimetableAction(){
		$this->getSession()->get();
		$post 	= $this->getRequest()->getPost()->toArray();
		$timetable = new TimetableModel(TimetableModel\Storage::factory($this->getDb(),$this->getConfig()));

		$timetableData = [
			'timetable_id' 	=> $post['timetable_id'] ?? null,
			'code' 			=> $post['shift_code'] ?? null,
			'name' 			=> $post['shift_name'] ?? null,
			'description' 	=> $post['shift_description'] ?? null
		];

		$shift = [
			'timetable_shift_id' 	=> null,
			'timetable_id' 			=> null,
			'code' 					=> isset($post['code'])? $post['code'] : $post['shift_code'],
			'name' 					=> $post['name'],
			'day_no' 				=> $post['day_no'],
			'is_workday' 			=> $post['is_workday'],
			'on_duty_time' 			=> $post['on_duty_time'],
			'off_duty_time' 		=> $post['off_duty_time'],
			'in_beginning_time' 	=> $post['in_beginning_time'],
			'in_ending_time' 		=> $post['in_ending_time'],
			'out_beginning_time' 	=> $post['out_beginning_time'],
			'out_ending_time' 		=> $post['out_ending_time'],
			'late_time' 			=> $post['late_time'],
			'leave_early_time' 		=> $post['leave_early_time'],
			'overtime_start_time' 	=> $post['overtime_start_time'],
			'start_date' 			=> $post['start_date'],
			'end_date' 				=> $post['end_date']
		];

		$breakTimes = array();
		$dataBreaks = $post['break'];
		if(isset($post['break']) && $post['break']){
			foreach ($dataBreaks as $k => $breaks) {
				foreach ($breaks as $k2 => $value) {
					$breakTimes[$k2][$k] = $value;
				}
			}
		}

		$data = [
			'timetable' 	=> $timetableData,
			'shift' 		=> $shift,
			'breakTimes' 	=> $breakTimes,
		];
		
		$result 	= $timetable->saveEx($data, $this->getDb());

		$result->info = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}

	public function changeShiftAction(){
		$this->usingjs('bootbox', 21);
		$this->using('p-loading', 22);
        $this->using('toast',27);
		
		$this->using('datatable', 20, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
			'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
			'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));

		$this->using('moment',24);
		$this->using('air-datepicker',25);
		$this->using('jquery.validate',26);

		$sessmgt = $this->getSession()->get();
        $sess = (isset($sessmgt['ref_id'])) ? true : false;

        $title = $this->translate("Change Shift");

		$shift = new \Neuron\Attendance\Shift(\Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig()));
		$dataShifts = $shift->listActiveShift()->data['list'];

		$layout = $this->layout();
		// $layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/attendance/form/request">' . $this->translate("Request") . '</a>']);
		$layout->setVariables(['current' => $this->translate('Change Shift')]);

		return $this->getView('changeshift',get_defined_vars());		
	}
	public function saveChangeShiftAction(){
		$post = $this->getPostParams()->toArray();

		if(class_exists('Neuron\Application\Framework\Entity')){
		    $this->_session = \Neuron\Application\Framework\Entity::get($this)->session();
		    $user_id = $this->_session->get('user_id');
		} else {
		    $user_id = 0;
		}
		
		$post['change_by'] = $user_id;
		unset($post['timetable_object_id']);
		$changeShift = new Changeshift(Changeshift\Storage::factory(
			$this->getDb(),
			$this->getConfig()));
		
		$result = $changeShift->saveEx($post);

		if($result->code == 0){
			$objectTimetable 	= new ObjectTimetable(Objects\Storage::factory($this->getDb(),$this->getConfig()));
			$result 			= $objectTimetable->changeShift($changeShift);
		}

		return $this->getREST()->getResponse($result);
	}
	public function addObjectAction(){
		$this->using('bootbox',21);
		$this->using('p-loading',22);
		$this->using('jquery.validate',32);
		$this->using('moment',33);
		$this->using('air-datepicker',40);
		$this->using('select2', 22, array(
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
		     /* ini load sesuai bahasa dari session */
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
		     /**/
		    'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
		    'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));

		$this->using('datatable', 20, array(
		    'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
		    'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
		    'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));

		$sessmgt = $this->getSession()->get();
		$timetable_id = $this->params()->fromQuery('timetable_id');
		
		// Get Timetable Code
		$storage = TimetableModel\Storage::factory($this->getDb(),$this->getConfig());
		$timetable = new TimetableModel($storage);
		$timetable->load($timetable_id);
		$dataTimetable = $timetable->pull();
		$code = $dataTimetable['code'];
			
		// get timetable child
		$timetableChild = $timetable->loadChild($timetable_id);

		//ACL CRUD OBJECT
		$addObject = $this->checkGrants('add_object');
		$editObject = $this->checkGrants('edit_object');
		$removeObject = $this->checkGrants('remove_object');
		$detailObject = $this->checkGrants('detail_object');

		$layout = $this->layout();
		$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/attendance/timetable/manage">' . $this->translate("Manage timeshift") . '</a>']);
		$layout->setVariables(['current' => $this->translate('Manage object')]);
		$title = $this->translate('Timetable Object');
		return $this->getView('manage-object',get_defined_vars());
	}
	public function loadByParentAction(){
		// $test = new \newClass\TestClass\noClass;
        try {
            /* get post */
            $post = $this->getRequest()->getPost();
			$parent = $this->params()->fromQuery('timetable_id');

            /* bootgrid or API */
			$mode = \Neuron\Attendance\Timetable\Storage::LISTBY_PARENT;

            if(isset($post['rowCount']) && isset($post['current'])){
                $params = array(
                    'page' => $post['current'],
                    'records' => $post['rowCount'],
                    'sort' => @$post['sort'],
                );
                $bootgrid = true;
            }else{
                $bootgrid = false;
            }

			$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(),$this->getConfig());
			$timetables = new \Neuron\Attendance\Timetables($storage);


			$result = $timetables->load($parent,$mode);
            

            /* bootgrid? */
            if ($bootgrid) {
                if ($result->code == $result::CODE_SUCCESS) {

                     // calc total 
                    $total = $result->data['countTotal'];;
                    $pager = $result->data['pager'];

                    $listData['rows'] = $result->data['list'];
                    $listData['total'] = $total;
                    $listData['current'] = intval($params['page']);
                    $listData['rowCount'] = $pager->getLimit(); //$roles->count();

                } else {

                    $page = intval($params['page']);
                    $records = intval($params['records']);

                    $listData['rows'] = array();
                    $listData['total'] = $page * $records;
                    $listData['current'] = $page;
                    $listData['rowCount'] = $records;
				}
				
                return $this->getOutput(json_encode($listData));
                
            }   
            
        } catch (\Exception $ex) {
            error_log('Error at ' . $ex->getFile() . ' line ' . $ex->getLine() . ': ' . $ex->getMessage());
            $result = new \Neuron\Generic\Result();
            $result->code = 500;
            $result->info = $ex->getMessage();
            return $this->getREST()->getResponse($result);
        }
        return $this->getREST()->getResponse($result);        
    }
	
    public function saveObjectAction(){
		/* Dipindah ke src\Neuron\Attendance\Controller\Obj.php@saveAction */
    	$result = new \Neuron\Generic\Result();
    	$result->info = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
    }
    public function saveObjectGroupAction(){
		$session 			= $this->getSession()->get();
		$this->_UPDATE_BY	= (isset($session['user_id']) && strlen($session['user_id']) >= 0) ? $session['user_id'] : self::UPDATE_BY;

		$post = $this->getRequest()->getPost();
		$post['end_date'] = (isset($post['end_date']) && strlen($post['end_date'] > 0) && $post['end_date'] != '0000-00-00') ? $post['end_date'] : null;

    	$group_id = $post['group_id_post'];
    	$result = new Result();

    	if(!isset($post['day_no']) && empty($post['day_no'])){
    		$result->info = 'No Timetable choosen. please choose at least one day';
    		$result->code = 2;
	    	return $this->getREST()->getResponse($result);
    		exit;
    	}

    	// Loading Model.....
    		// CTT = shift model
			$storage = \Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig());
		    $ctt = new \Neuron\Attendance\Shift($storage);

	    	$storageMember = TimetableModel\Group\Member\Storage::factory($this->getDb(),$this->getConfig());
	    	$members = new TimetableModel\Group\Members($storageMember);

	    	$storageObject= TimetableModel\Objects\Storage::factory($this->getDb(),$this->getConfig());
	    	$object = new TimetableModel\ObjectTimetable($storageObject);

    	$dataMember = $members->load($group_id,TimetableModel\Group\Member\Storage::LISTBY_GROUPID)->data['list'];

		
		$listErrorData = array();

    	if($dataMember){
	    	$day_no = $post['day_no'];
	    	$listValidData = array();

			// check duplicate data
	    	foreach ($dataMember as $dataMember) {
	    		$params = array();
	    		foreach ($day_no as $timetable_id) {
	    			$check = array(
	    				'timetable_id' => $timetable_id,
	    				'ref_name' => $dataMember['ref_name'],
	    				'ref_code' => "EMPLOYEE",
	    				'ref_id' => $dataMember['ref_id'],
	    				'start_date' => $post['start_date'],
	    				'end_date' => $post['end_date'],
	    				'last_update' => date('Y-m-d H:i:s'),
	    				'update_by' => $this->_UPDATE_BY,
					);
					$checkStartDate = date('Y-m-d',strtotime($post['start_date']));
					$checkEndDate 	= date('Y-m-d',strtotime($post['end_date']));

					$checkData 	= $ctt->isDuplicate($check['ref_id'],$check['timetable_id'],$checkStartDate,$checkEndDate);
					
		        	if($checkData){
						$listErrorData[] = $check;
		        	}else{
						$listValidData[] = $check;
		        	}
	    		}
			}
	    	if(count($listErrorData) > 0){
	    		$result->code = 2;
				$result->info = 'Submitted data contain duplicate or overlapping data';
	    	}else{
	    		foreach ($day_no as $timetable_id){
	    			$params = array(
	    				'object_group_id' => $group_id,
	    				'timetable_id' => $timetable_id,
	    				'start_date' => $post['start_date'],
	    				'end_date'=> $post['end_date']
	    			);
					$insert = $object->saveExGroup($params);
	    		}
	    		foreach ($listValidData as $data) {
					$save = $object->saveEx($data);
	    		}
	    	}
    	}else{
    		$result->code = 403;
    		$result->info = 'This group has no member';
		}
		$result->data = array('listError' => $listErrorData);
    	return $this->getREST()->getResponse($result);
    }
    public function removeTimetableAction(){
    	$result = new Result();

    	$storage = \Neuron\Attendance\Timetable\Storage::factory($this->getDb(), $this->getConfig());
      	$mtt = new \Neuron\Attendance\Timetable($storage);

        $post = $this->getPostParams();

       	// Variable Definition
        	$objectData = array();
        // check
        	// get all timetable_id where parent_id is posted timetable_id
        	$timetables = new \Neuron\Attendance\Timetables($storage);
			$dataTimetables = $timetables->load($post['timetable_id'],\Neuron\Attendance\Timetable\Storage::LISTBY_PARENT);
			
			if($dataTimetables->code == 0){
				$dataTimetables = $dataTimetables->data['list'];
			}else{
				$dataTimetables = array();
			}
			
        	if(count($dataTimetables) && !isset($post['force'])){
        		$result->code 	= 999;
        		$result->info 	= $this->translate("Cannot delete this timetables! This timetables have an ative object");
	    		$result->data = $post;
        		return $this->getREST()->getResponse($result);
			}

        	$storageObject = TimetableModel\Objects\Storage::factory($this->getDb(),$this->getConfig());
			// $objects = new TimetableModel\ObjectTimetable($storageObject);

			$objects 	= new Objects(Objects\Storage::factory($this->getDb(),$this->getConfig()));


        	if($dataTimetables){
	        	foreach ($dataTimetables as $data) {
					
					$dataObjects = $objects->listData($data['timetable_id'],TimetableModel\Objects\Storage::LISTBY_TIMETABLEID);
					
	        		if($dataObjects){
	        			$dataObjects 	= $dataObjects->data['list'];
		        		if(count($dataObjects) > 0){
		        			foreach ($dataObjects as $extracted) {
		        				$objectData[] = $extracted;
		        			}
		        		}
	        		}
	        	}
			}

    	if(count($objectData) > 0 && !isset($post['force'])){
    		$result->code = 999;
    		$result->info = 'This timetable is used.';
    		$result->data = $post;
    	}else{
    		if(isset($post['force'])){
				$object = new TimetableModel\ObjectTimetable($storageObject);
    			foreach ($objectData as $data) {
    				$data['end_date'] = date('Y-m-d');
					$result = $object->saveEx($data);
				}
				$deltt = $mtt->delete($post['timetable_id']);
    		}else{
				$deltt = $mtt->delete($post['timetable_id']);
    		}
    	}

    	return $this->getREST()->getResponse($result);
    }
    public function uploadTimetableAction(){
		$result = new \Neuron\Generic\Result();
		$files = $this->getRequest()->getFiles();

		if(count($files) <= 0 ){
			$result->code = 401;
			$result->info = 'No file selected';
			return $this->getREST()->getResponse($result);
			exit();
		}

		$config = $this->getConfig();

		if(!isset($config['start_date'])){
			$result = new \Neuron\Generic\Result();
			$result->info = 'Start date not found in config. Please Contact your Administrator';
			$result->code = 2;
			return $this->getREST()->getResponse($result);
		}

		$uploadPath = getcwd() . '/public/uploads/excel';
		$uploadPath = $uploadPath . '\\' . date('Y/m/d');

		$uploadfile = true;
		if(!file_exists($uploadPath)){
		    mkdir($uploadPath, 0755, true);
		}

		if(count($files['file']) > 0){
		    foreach($files as $file){
		    	$fileType = $file['type']; 
		    	$filename = $uploadPath.'/'.$file['name'];
		    	// var_dump($filename);die();
		        if($fileType != 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'){
		        	$uploadfile = false;
		        	$result->info = 'Hanya dapat mengunggah file berekstensi .xlsx';
		        	$result->code = 2;
		        	return $this->getREST()->getResponse($result);
		        	break;
		        	exit();
		        }

		        if(file_exists($filename)) $filename = substr($filename, 0, strrpos($filename, '.')) . ' Copy ' . date('His') . substr($filename, strrpos($filename, '.'));
		    
		        if(!move_uploaded_file($file['tmp_name'], $filename)){
		            $uploadfile = false;
		            break;
		        }
		    }
		}

		if($uploadfile){
			//convert excel to array 
			$xlsx = \SimpleXLSX\SimpleXLSX::parse($filename);
			$rows = $xlsx->rows();

			$headerRow = $rows[0];
			$dayRow = $rows[1];
			$dateRow = $rows[2];
			
			$dateRange2 = array();
			
			for($i = 4;$i < count($headerRow); $i++){
				if(!empty($headerRow[$i])){
					$dateRange2 = array(
						'year' => date('Y', strtotime($headerRow[$i])),
						'month' => date('m', strtotime($headerRow[$i]))
					);
				}
			}

			$result->data = $filename;
			
			if( !isset($dateRange2['year']) || !isset($dateRange2['month']) ){
				$result->code = 300;
				$result->info = 'Please upload the correct file.';
				return $this->getREST()->getResponse($result);
			}

			$dateRange1 = array(
				'year' => date('Y', strtotime($rows[0][3])),
				'month' => date('m', strtotime($rows[0][3]))
			);

			unset($rows[0]);
			unset($rows[1]);
			unset($rows[2]);

			/* Ngambil Jumlah hari dalam 1 bulan $dayCount */

				$startDate = abs($config['start_date']);
				$lastDate = $startDate-1;

				$date1 = $dateRange1['year'].'-'.$dateRange1['month'].'-'.$startDate;
				$date2 = $dateRange2['year'].'-'.$dateRange2['month'].'-'.$lastDate;

				$date = round(
					strtotime($date2) - strtotime($date1)
				);

				$dayCount = round($date / (60 * 60 * 24));

			// Load Model
			$modelShift = new \Neuron\Attendance\Shift(\Neuron\Attendance\Shift\Storage::factory($this->getDb(),$this->getConfig()));
			$modelObject = new \Neuron\Attendance\Timetable\ObjectTimetable(\Neuron\Attendance\Timetable\Object\Storage::factory(
				$this->getDb(),
				$this->getConfig()
			));

			$list = array();

			// Cari user ID yang login untuk kolom update_by;

			if(class_exists('Neuron\Application\Framework\Entity')){
			    $this->_session = \Neuron\Application\Framework\Entity::get($this)->session();
			    $user_id = $this->_session->get('user_id');
			} else {
			    $user_id = 0;
			}

			foreach ($rows as $key => $value) {
				$shift = array();
				for($i=3;$i<=($dayCount+3);$i++){

					// Ambil bulan dan tahun berdasarkan header

					if($headerRow[$i] != null){
						$objectMonth = explode(' ',$headerRow[$i])[0];
						$objectMonth = date('m', strtotime($objectMonth));
						$objectYear = explode(' ',$headerRow[$i])[1];
					}

					$day_no = $this->getDayNo($dayRow[$i]);
					$modelShift->loadShiftByDayNo($day_no);
					
					$dataShift = $modelShift->pull();
					$timetable_id = $dataShift['timetable_id'];

					$objectDate = $dateRow[$i];
					$objectStartDate = $objectYear.'-'.$objectMonth.'-'.$objectDate;

					$params = array(
						'timetable_id' => $timetable_id,
						'ref_code' => $this->ref_code,
						'ref_id' => $value[2],
						'start_date' => $objectStartDate,
						'end_date' => $objectStartDate,
						'last_update' => date('Y-m-d H:i:s'),
						'update_by' => $user_id
					);

					$modelObject->saveEx($params);

					$shift[] = array(
						'day' => $dayRow[$i],
						'date' => $dateRow[$i],
						'shift' => $value[$i],
						'day_no' => $day_no,
						'timetable_id' => $timetable_id,
					);

				}

				$list[] = array(
					'fullName' => $value[1],
					'nik' => $value[2],
					'shift' => $shift,
				);	
			}
			
		} else {
		    $result = new Result(0, 1, 'Upload attachment failed, please try again.');
		}
		return $this->getREST()->getResponse($result);
	}
	public function getDayNo($dayName){
		switch ($dayName) {
			case 'Mon':
				return self::MONDAY;
				break;
			case 'Tue':
				return self::TUESDAY;
				break;
			case 'Wed':
				return self::WEDNESDAY;
				break;
			case 'Thu':
				return self::THURSDAY;
				break;
			case 'Fri':
				return self::FRIDAY;
				break;
			case 'Sat':
				return self::SATURDAY;
				break;
			case 'Sun':
				return self::SUNDAY;
				break;
		}
	}
	public function listActiveShiftAction(){
		$post = $this->getPostParams();
		$shift = new \Neuron\Attendance\Shift(\Neuron\Attendance\Shift\Storage::factory($this->getDb(), $this->getConfig()));

		if(isset($post['exclude_shift_code'])){
			$exclude 		= $post['exclude_shift_code'];
			$timetable  	= new TimetableModel(TimetableModel\Storage::factory($this->getDb(),$this->getConfig()));
			$loadTimetable	= $timetable->searchByCode($exclude);
			if($loadTimetable['parent_timetable_id']){
				$exclude  	= $loadTimetable['parent_timetable_id'];
			}else{
				$exclude 	= null;
			}
		}else{
			$exclude 	= null;
		}
		
		$dataShifts = $shift->listActiveShift(
			null, 
			isset($post['date'])? date('Y-m-d', strtotime($post['date'])): null,
			isset($post['dayno'])? $post['dayno']: null,
			$exclude
		)->data['list'];
		
		return $this->getOutput(json_encode(array('success'=>true, 'message'=> 'loaded data', 'list'=>$dataShifts)));
	}
	public function getUpdateBy(){
		$session 	= $this->getSession()->get();
		if(isset($session['user_id']) && strlen($session['user_id']) > 0){
			$this->_UPDATE_BY = $session['user_id'];
		}else{
			$this->_UPDATE_BY = self::UPDATE_BY;
		}

		return $this->_UPDATE_BY;
	}

	public function createTimetableAction() {
		$layout = $this->layout();
        $layout->setVariables(['breadcrumb' => $breadcrumb]);
        
        $this->using('generic', 19);
		
        $this->using('bootbox', 21);
		$this->using('p-loading', 22);
		$this->using('moment', 23);
		$this->using('air-datepicker', 24);
		$this->using('jquery.validate', 25);
		$this->using('select2', 26, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			 /* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			 /**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
        ));
        
        $this->using('smart-wizard', 28);

        return $this->getView('crud', get_defined_vars());
    }

	//upload shift
	public function uploadShiftAction(){
		$this->usingjs('bootbox', 21);
		$this->using('air-datepicker', 24, array(
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/datepicker.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/css/datepicker.min.css',
			'https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/i18n/datepicker.en.min.js'
		));
		$this->using('generic', 24);

		$this->using('datatable', 20, array(
		    'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
		    'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
		    'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));

		$this->using('select2',23,[
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/css/select2.min.css',
			
		]);

		$this->using('wizard',20,[
			'https://cdn.jsdelivr.net/npm/smartwizard@5/dist/css/smart_wizard_all.min.css',
			'https://cdn.jsdelivr.net/npm/smartwizard@5/dist/js/jquery.smartWizard.min.js'
		]);

	    $this->using('jquery.validate',28);


		$sessmgt = $this->getSession()->get();

		$title = 'Upload Shift';

		$layout = $this->layout();
	
		$layout->setVariables(['current' => $this->translate('Upload Shift')]);

		$timetables 	= new Timetables(TimetableModel\Storage::factory($this->getDb(),$this->getConfig()));
		$timetables 	= $timetables->load(null,TimetableModel\Storage::LISTBY_PARENT);
		$timetables 	= $timetables->code == 0 ? $timetables->data['list'] : [];
		// echo '<pre>'; print_r($timetables) ;echo '</pre>';die();
		// return $this->getView('upload-shift', get_defined_vars());
		return $this->getView('new-upload-shift', get_defined_vars());
	}

	public function downloadFormatAction()
	{
		$result = new Result();
        $post =  $this->params()->fromQuery();
        $sTimtable = TimetableModel\Storage::factory($this->getDb(), $this->getConfig());
        $mtimetable = new TimetableModel($sTimtable);
        $download = $mtimetable->downloadFormat($post);
        return $this->getREST()->getResponse($download);
	}

	public function uploadStartAction(){
        $result 		= new Result();
		$post 			= $this->getRequest()->getFiles()->toArray();
		$mUpload 		= new \Neuron\Attendance\Timetable\Upload(\Neuron\Attendance\Timetable\Upload\Storage::factory($this->getDb(),$this->getConfig()));
		$result 		= $mUpload->upload($post,$this->getSession()->owner());
		
		$result->info 	= $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}
	public function uploadListAction(){
        $storage = \Neuron\Attendance\Timetable\Upload\Storage::factory($this->getDb(), $this->getConfig());
	  	$upload = new \Neuron\Attendance\Timetable\Uploads($storage);

		$post = $this->getPostParams();
		//echo '<pre>'; print_r($post); echo '</pre>';
          
        if (isset($post['start']) && isset($post['length'])) {
            $params = array(
                'page' => ($post['start'] + $post['length']) / $post['length'],
                'records' => $post['length'],
                'order' => $post['order'],
                'columns' => $post['columns'],
                'filter_status'=> $post['filter_status'],
                'ref_id'=> $post['ref_id']
            );
            $keyword = $post['search']['value'];
            $datatable = true;
            if($post['length'] == -1){
                $mode = \Neuron\Attendance\Timetable\Upload\Storage::LIST_ALL;
            }else{
                $mode = \Neuron\Attendance\Timetable\Upload\Storage::LISTBY_PAGE;
            }
        } else {
            $post = $this->getREST()->getParameters();
            $params = is_array(@$post['additional']) ? @$post['additional'] : array();
            $keyword = @$post['keyword'];
            $mode = isset($post['mode'])? $post['mode']: \Neuron\Attendance\Timetable\Upload\Storage::LIST_ALL;
            $datatable = false;
        }
        $result = $upload->load($keyword, $mode, $params);
          
        if ($datatable) {
            if ($result->code == $result::CODE_SUCCESS) {
                $listData['draw'] = $post['draw'];
                $listData['recordsTotal'] = $result->data['countTotal'];
                $listData['recordsFiltered'] = $result->data['countTotal'];
                $listData['data'] = $result->data['list'];
            } else {
                $listData['draw'] = $post['draw'];
                $listData['recordsTotal'] = 0;
                $listData['recordsFiltered'] = 0;
                $listData['data'] = array();
            }
            
            return $this->getOutput(json_encode($listData));
        }
	  	// $treehtml = $ccompo->genTableTree($tree);
  		return $this->getRest()->getResponse($result);
	}

	public function detailUploadListAction(){
        $storage = \Neuron\Attendance\Timetable\Upload\Detail\Storage::factory($this->getDb(), $this->getConfig());
	  	$upload = new \Neuron\Attendance\Timetable\Upload\Details($storage);

		$post = $this->getPostParams();
		//echo '<pre>'; print_r($post); echo '</pre>';
          
        if (isset($post['start']) && isset($post['length'])) {
            $params = array(
                'page' => ($post['start'] + $post['length']) / $post['length'],
                'records' => $post['length'],
                'order' => $post['order'],
                'columns' => $post['columns'],
                'filter_status'=> $post['status'],
                'upload_file_shift_id'=> $post['upload_file_shift_id']
            );
            $keyword = $post['search']['value'];
            $datatable = true;
            if($post['length'] == -1){
                $mode = \Neuron\Attendance\Timetable\Upload\Detail\Storage::LIST_ALL;
            }else{
                $mode = \Neuron\Attendance\Timetable\Upload\Detail\Storage::LISTBY_PAGE;
            }
        } else {
            $post = $this->getREST()->getParameters();
            $params = is_array(@$post['additional']) ? @$post['additional'] : array();
            $keyword = @$post['keyword'];
            $mode = isset($post['mode'])? $post['mode']: \Neuron\Attendance\Timetable\Upload\Detail\Storage::LIST_ALL;
            $datatable = false;
        }
        $result = $upload->load($keyword, $mode, $params);
          
        if ($datatable) {
            if ($result->code == $result::CODE_SUCCESS) {
                $listData['draw'] = $post['draw'];
                $listData['recordsTotal'] = $result->data['countTotal'];
                $listData['recordsFiltered'] = $result->data['countTotal'];
                $listData['data'] = $result->data['list'];
            } else {
                $listData['draw'] = $post['draw'];
                $listData['recordsTotal'] = 0;
                $listData['recordsFiltered'] = 0;
                $listData['data'] = array();
            }
            
            return $this->getOutput(json_encode($listData));
        }
	  	// $treehtml = $ccompo->genTableTree($tree);
  		return $this->getRest()->getResponse($result);
	}
    public function getDayNoSearch($dayName){
		
		if($dayName && $this->plugin('translate')->getTranslator()->getLocale() == 'id_ID'){
			if(strtolower($dayName) == 'sen' || strtolower($dayName) == 'senin')
				return self::MONDAY;
			elseif(strtolower($dayName) == 'sel' || strtolower($dayName) == 'selasa')
				return self::TUESDAY;
			elseif(strtolower($dayName) == 'rab' || strtolower($dayName) == 'rabu')
				return self::WEDNESDAY;
			elseif(strtolower($dayName) == 'kam' || strtolower($dayName) == 'kamis')
				return self::THURSDAY;
			elseif(strtolower($dayName) == 'jum' || strtolower($dayName) == 'jumat')
				return self::FRIDAY;
			elseif(strtolower($dayName) == 'sab' || strtolower($dayName) == 'sabtu')
				return self::SATURDAY;
			elseif(strtolower($dayName) == 'min' || strtolower($dayName) == 'minggu')
				return self::SUNDAY;
		}else{
			switch ($dayName) {
				case 'Mon':
					return self::MONDAY;
					break;
				case 'Tue':
					return self::TUESDAY;
					break;
				case 'Wed':
					return self::WEDNESDAY;
					break;
				case 'Thu':
					return self::THURSDAY;
					break;
				case 'Fri':
					return self::FRIDAY;
					break;
				case 'Sat':
					return self::SATURDAY;
					break;
				case 'Sun':
					return self::SUNDAY;
					break;
			}
		}

		return false;
	}
}
