<?php
namespace Neuron\Attendance\Controller;

use Neuron\Access\Session;

class Widget extends Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/attendance/layout/plain');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/attendance/widget';

		/* libraries */
		$this->using('popper',11);
		$this->using('fontawesome', 12);
		$this->using('nicescroll', 13);
		$this->using('toast', 14);

		$this->using('datatable', 15);
		$this->using('air-datepicker', 16);
		$this->using('jquery.validate', 17);
		$this->using('moment', 18);
		$this->using('chart.js', 19);

        $config = $this->getConfig();
        
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
            $prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
        $view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder

		return $view;
	}

	public function attendanceAction(){
		$this->using('p-loading',20);
		$this->using('datatable', 20, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
			'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
			'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		$this->using('moment',21);
		$this->using('air-datepicker',22);
		$this->using('jquery.validate',23);
		return $this->getViewPartial('attendance');
	}
	
	public function WidgetOvertimeAction(){
        return $this->getViewPartial('widget-overtime', get_defined_vars());
	}
	
	public function detailAttendanceAction() {
		
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		$id = $this->params()->fromQuery('attendance_id');		

		$title = $this->translate("Attendance Detail");

		return $this->getViewPartial('detail-attendance', get_defined_vars());
	}

	public function todayStatusAction(){
		return $this->getViewPartial('today-status');
	}

}