<?php
namespace Neuron\Attendance\Controller\Widget;

use Neuron\Access\Session;

class Attendance extends \Neuron\Attendance\Controller\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/attendance/layout/plain');

		return $d;
	}

	protected function getView($name, $variables = array()) {
	    /* default layout & view prefix */
	    $layout = 'neuron/attendance/layout/form';
	    $prefix = 'neuron/attendance/group';

		/* libraries */
		if(! class_exists('Neuron\Application\Framework\Entity')) {
            $this->using('jquery', null)
                ->using('bootstrap', null)
                ->using('fontawesome', null)
                ->using('generic',null)
                ->using('select2',null)
				->using('theme',99);
        }

	    /* get layout n view prefix from config */
	    $config = $this->getConfig();
	    if (isset($config['attendance'])) {
	        $config = $config['attendance'];
	        $layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
	        $prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
	    }

	    /* set layout and view */
	    $this->layout($layout);
	    $view = new \Zend\View\Model\ViewModel($variables);
	    $view->setTemplate($prefix . '/' . strtolower($name));

	    return $view;
	}
	
	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/attendance/widget';

		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function FormAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (isset($sessmgt['ref_id'])) ? true : false;

		$ref_id = $this->params()->fromQuery('refid');
		$timetable_id = $this->params()->fromQuery('ttid');
		if(!isset($ref_id)) {
			$ref_id = $sessmgt['ref_id'];
		}

		$params = [
			'ta.ref_id' => $ref_id,
			'tt.timetable_id' => $timetable_id
		];

		$dataEmp = array();
		if(class_exists('Neuron\Employee\Entity')){
			$storageEmp = \Neuron\Employee\Entity\Storage::factory($this->getDb(), $this->getConfig());
    		$cemp = new \Neuron\Employee\Entity($storageEmp);
    		$dataEmp = $cemp->detailEmp($ref_id);
		}
		$ref_name = '';
		if($dataEmp['data']){
			$ref_name = $dataEmp['data'][0]['first_name'].' '. $dataEmp['data'][0]['last_name'];
		}

		$storage = \Neuron\Attendance\Timetable\Objects\Storage::factory($this->getDb(), $this->getConfig());
		$model = new \Neuron\Attendance\Timetable\ObjectTimetable($storage);
		$loadObject = $model->loadObjectByParam($params);
	 	$title = $this->translate("Form Attendance");
		$person = null;

		return $this->getViewPartial('form', get_defined_vars());
	}

	public function CrudAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (isset($sessmgt['ref_id'])) ? true : false;

		$ref_id = $this->params()->fromQuery('refid');
		$timetable_id = $this->params()->fromQuery('ttid');
		if(!isset($ref_id)) {
			$ref_id = $sessmgt['ref_id'];
		}

		$params = [
			'ta.ref_id' => $ref_id,
			'tt.timetable_id' => $timetable_id
		];

		$storage = \Neuron\Attendance\Timetable\Object\Storage::factory($this->getDb(), $this->getConfig());
		$model = new \Neuron\Attendance\Timetable\ObjectTimetable($storage);
		$loadObject = $model->loadObjectByParam($params);

	 	$title = $this->translate("Form Attendance");
		$person = null;

		return $this->getViewPartial('crud', get_defined_vars());
	}

	public function formAttendanceAction(){
        return $this->getView('attendance',get_defined_vars());
	}
}