<?php
namespace Neuron\Attendance\Controller\Widget;

use Neuron\Access\Session;
use Neuron\Upload\Upload as UploadModel;

class AttendanceDetail extends \Neuron\Attendance\Controller\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/attendance/layout/blank');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/attendance/widget';

		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function detailAttendanceAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		$id = $this->params()->fromQuery('attendance_id');

		$var = 'uploader_document';
		$config = $this->getConfig()['upload_document'];
		if(isset($sessmgt['ref_id'])){
			$config['location'] = $config['location'] . '/' . $sessmgt['ref_id'];
		}
		$upload = new UploadModel($var, $config);
		

		$title = $this->translate("Attendance Details");

		return $this->getViewPartial('detail-attendance', get_defined_vars());
	}

}