<?php
namespace Neuron\Attendance\Controller\Widget;

use Neuron\Access\Session;

class Myapproval extends \Neuron\Attendance\Controller\Controller {
	const ORDER_TYPE_ATTENDANCE    = 2101;
    const ORDER_TYPE_OVERTIME      = 2102;
	const ORDER_TYPE_CHANGESHIFT   = 2103;
	

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/attendance/layout/blank');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/attendance/widget';

		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function IndexAction() {		
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		return $this->getViewPartial('approval', get_defined_vars());
	}

	public function FormApprovalAction() {
		if (!defined('APPROVE')) define('APPROVE', 2);
		if (!defined('REJECT')) define('REJECT', 3);
		$sessmgt = $this->getSession()->get();
		$storage = \Neuron\Attendance\Request\Storage::factory($this->getDb(), $this->getConfig());
		$data = null;

		$id = $this->params()->fromQuery('approval_id');
		$notif_inbox_id = ($this->params()->fromQuery('notif_inbox_id')!=null) ? $this->params()->fromQuery('notif_inbox_id') : "";

		$title = "Request Detail";

		if($id) {
        	$catt = new \Neuron\Attendance\Request($storage);
			$datalist = $catt->loadApproval($id, $sessmgt['ref_id']);
			if($datalist['request_type'] ==self::ORDER_TYPE_ATTENDANCE){
				$datalist['request_type_name'] = 'Attendance';
			}else if($datalist['request_type'] ==self::ORDER_TYPE_OVERTIME){
				$datalist['request_type_name'] = 'Overtime';
			}else{
				$datalist['request_type_name'] = 'Change Shift';
			}
			if($datalist['start_dtm'] && $datalist['start_dtm'] != '0000-00-00 00:00:00'){
				$datalist['start_dtm'] = date('d M Y H:i:s', strtotime($datalist['start_dtm']));
			}else{
				$datalist['start_dtm'] = null;
			}

			if($datalist['end_dtm'] && $datalist['end_dtm'] != '0000-00-00 00:00:00'){
				$datalist['end_dtm'] = date('d M Y H:i:s', strtotime($datalist['end_dtm']));
			}else{
				$datalist['end_dtm'] = null;
			}
		}
		$data = $datalist;
		// print_r($data); die();

		return $this->getViewPartial('form-approval', get_defined_vars());
	}

}