<?php
namespace Neuron\Attendance\Controller\Widget;

use Neuron\Access\Session;
	
class Myrequest extends \Neuron\Attendance\Controller\Controller {

	public function onDispatch(\Zend\Mvc\MvcEvent $e) {

		$d = parent::onDispatch($e);  //INI HARUS DIPANGGIL!!!!
		$this->layout()->setTemplate('neuron/attendance/layout/blank');

		return $d;
	}

	protected function getViewPartial($name, $variables = array()) {
		$prefix = 'neuron/attendance/widget';

		$config = $this->getConfig();
		if (isset($config['attendance'])) {
			$config = $config['attendance'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	public function IndexAction() {

		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		$config = $this->getConfig();
		$checkin_recomendation = $config['attendance']['checkin_recomendation'];

		$usrRefId = $sessmgt["ref_id"];
		$usrJobId = null;
		$usrOrgId = null;

		if(isset($sessmgt['ohp_id'])) {
		    $usrJobId = $sessmgt["detail"]->position_id;
		    $usrOrgId = $sessmgt["detail"]->organization_id;
		}

		$title = $this->translate("Create Recomendation");

		// $sessmgt = $this->getSession()->get();
		// $sess = (count($sessmgt) > 0) ? true : false;

		return $this->getViewPartial('list', get_defined_vars());
	}

	public function FormRequestAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		$config = $this->getConfig();
		$checkin_recomendation = $config['attendance']['checkin_recomendation'];

		$usrRefId = $sessmgt["ref_id"];
		$usrJobId = null;
		$usrOrgId = null;

		if(isset($sessmgt['ohp_id'])) {
			$usrJobId = $sessmgt["detail"]->position_id;
			$usrOrgId = $sessmgt["detail"]->organization_id;
		}

		$title = $this->translate("Create Recomendation");

		return $this->getViewPartial('form-request', get_defined_vars());
	}

	public function DetailAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;
		
		$title = "Detail Recomendation";
		$request_id = $this->params()->fromQuery('request_id');
		$notif_inbox_id = ($this->params()->fromQuery('notif_inbox_id')!=null) ? $this->params()->fromQuery('notif_inbox_id') : "";

		$storage = \Neuron\Attendance\Request\Storage::factory($this->getDb(), $this->getConfig());
		$creq = new \Neuron\Attendance\Request($storage);
		
		$dataRequest = $creq->loadRequest('request_id', $request_id)[0];

		$ReqType = "";

		switch ($dataRequest['request_type']) {
			case '1':
				$ReqType = "Attendance";
				break;
			
			case '2':
				$ReqType = "Overtime";
				break;
			
			case '3':
				$ReqType = "Change Shift";
				break;
		}

		$approvals 		= $creq->loadApprovalBy('request_id',$request_id);
		$dataApproval 	= array();
        $arrRef_id 		= [];
        $params 		= array();
        $rows 			= array();
		if($approvals){
			foreach ($approvals as $approval) {
				$row 	= $approval;
				$rows[] = $approval;
				$arrRef_id[] 	= $row['ref_id'];
			}
		}

		$params['arr_ref_id'] = $arrRef_id;

		$cstorage = \Neuron\Employee\Entity\Storage::factory($this->getDb(), $this->getConfig());
        $cpersons = new \Neuron\Employee\Entity($cstorage);
        $cresult = $cpersons->listEmployee($params)['data'];

        if($rows){
        	foreach ($rows as $row) {
        		$ref_id 	= $row['ref_id'];
        		$ref_name 	= '-';
        		foreach ($cresult as $cr) {
        			if($cr['id'] == $ref_id){
        				$ref_name = $cr['first_name'].' '.$cr['last_name'];
        			}
        		}
        		$row['ref_name'] 	= $ref_name;
        		$dataApproval[]  	= $row;
        	}
        }

        if($notif_inbox_id){
            $read['type'] = 3;
            $read['user_id'] = @$sessmgt['detail']->user_id;
            $read['notif_inbox_id'] =$notif_inbox_id;
            $this->readNotif($read); 
        }
		return $this->getViewPartial('widget-detail-request', get_defined_vars());
	}

	public function FormSettingAction() {
		$storage = \Neuron\Attendance\Request\Setting\Storage::factory($this->getDb(), $this->getConfig());
		$data = null;

		$id = $this->params()->fromQuery('id');

		$title = "Form Attendance Setting";
		$dataDetail = NULL;
		
		if($id) {
			$title = "Edit Attendance Setting";
			$lExp = new \Neuron\Attendance\Request\Setting($storage);

			$data = $lExp->load($id);

			$params = array(
				'setting_id' => $id,
				'page' => 1,
				'rowCount' => 999,
				'searchPhrase' => null
			);
			
			$storageDet = \Neuron\Attendance\Request\Setting\Detail\Storage::factory($this->getDb(), $this->getConfig());
			$cDet = new \Neuron\Attendance\Request\Setting\Detail($storageDet);
			$res = $cDet->listdata($params);
			
			$dataDetail = $res->data['data'];
		}

		
		$request = $this->getRequest();
		$params = $request->getPost();
		if ($request->isPost()){
			$update = (!empty($params['setting_id'])) ? true:false;

			$cexp = new \Neuron\Attendance\Request\Setting($storage, $params);
			$retval = $cexp->save($update);

			if($retval) {
				$setting_id = $cexp->setting_id;

				$storageDet = \Neuron\Attendance\Request\Setting\Detail\Storage::factory($this->getDb(), $this->getConfig());
				$dataDetail = json_decode($params['detail'], true);
				$num_to_approve = $params['num_to_approve'];

				for ($i=0; $i < $num_to_approve ; $i++) {					
					if(isset($dataDetail[$i])) {
						if (!empty($dataDetail[$i]['detail_id'])) {
							$update = true;

							$lExp = new \Neuron\Attendance\Request\Setting\Detail($storageDet);
							$data = $lExp->load($dataDetail[$i]['detail_id'],$cexp->setting_id);
							$data = $data['data'];

							$dataDetail[$i]['seq'] = $data['seq'];
						}
						else {
							$update = false;

							$arrP = array(
								'setting_id' => $setting_id,
							);

							$lsd = new \Neuron\Attendance\Request\Setting\Detail($storageDet);
							$result = $lsd->listdata($arrP);
							$lsd = $result->data['data'];

							$seq = 1;

							if(count($lsd) > 0){
								$lastRecord = end($lsd);
								$seq = $lastRecord['seq'] + $seq;
							}

							$dataDetail[$i]['seq'] = $seq;
						}
						$dataDetail[$i]['setting_id'] = $setting_id;
						

						$cexp = new \Neuron\Attendance\Request\Setting\Detail($storageDet, $dataDetail[$i]);
						$retval = $cexp->save($update);
					}
					else {
						$update = false;

						$arrP = ['setting_id' => $setting_id];

						$lsd = new \Neuron\Attendance\Request\Setting\Detail($storageDet);
						$result = $lsd->listdata($arrP);
						$lsd = $result->data['data'];

						$seq = 1;

						if(count($lsd) > 0){
							$lastRecord = end($lsd);
							$seq = $lastRecord['seq'] + $seq;
						}
						
						$paramsDetail = [];
						$paramsDetail["setting_id"] = $setting_id;
						$paramsDetail["seq"] = $seq;
						$paramsDetail["approval_type_id"] = 1;
						$paramsDetail["type_value"] = null;

						$cexp = new \Neuron\Attendance\Request\Setting\Detail($storageDet, $paramsDetail);
						$retval = $cexp->save($update);
					}
				}
			}

			$response = $this->getResponse();
			$response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
			$response->setContent(json_encode($retval));
			return $response;
		}

		$data = $data['data'];
		return $this->getViewPartial('form-setting', get_defined_vars());
	}

	public function MappingTypeAction() {
		$sessmgt = $this->getSession()->get();
		$sess = (count($sessmgt) > 0) ? true : false;

		$title = $this->translate('Mapping Type');

		return $this->getViewPartial('mapping-type', get_defined_vars());
	}

}