<?php

namespace Neuron\Attendance;

use Neuron\Attendance\Detail;
use Neuron\Generic\Result;

class Details extends \Neuron\Generic\Set
{
    protected $_storage;

    public function __construct(Detail\Storage\Skeleton $storage)
    {

        $this->_storage = $storage;
    }

    public function load($id = null, $mode = Detail\Storage::LIST_ALL, $params = array())
    {

        $result = new \Neuron\Generic\Result();

        /* clear list */
        $this->clear();

        if ($rs = $this->_storage->loadList($id, $mode, $params)) {
            if ($rows = $rs->list) {
                $list = array();
                foreach ($rows as $row) {
                    // print_r($row); die();
                    /* for issue oracle */
                    $row = array_change_key_case($row);
                    unset($row['b_rownum']);

                    /* for issue sqlserver */
                    unset($row['__zend_row_number']);

                    /* new detail */
                    $detail = new Detail($this->_storage);
                    $detail->push($row);
                    $this->add($detail);
                    $list[] = $row;
                }

                // print_r($list); die();
                $result->data = array(
                    'pager' => $rs->pager,
                    'list' => $list,
                    'countTotal' => $rs->countTotal,
                );
            } else {
                $result->code = 2;
                $result->info = 'detail_load_none';
            }
        } else {
            $result->code = 1;
            $result->info = 'detail_load_notfound';
        }
        return $result;
    }
}
