<?php
namespace Neuron\Attendance;

class Generic{
    protected $_cacheDir;

    /* Untuk menghitung jumlah hari dalam berapa waktu */
    public static function getCountDay($start,$end){

        $end = strtotime($end) ;// or your date as well
        $start = strtotime($start);
        $datediff = $end - $start;
        return round($datediff / (60 * 60 * 24));
    }

    public function getCacheAdapter(){
        $this->_cacheDir = getcwd().'/cache/attendance/';
        if(!file_exists($this->_cacheDir)){
            mkdir($this->_cacheDir);
        }
        
		$cache 		= \Zend\Cache\StorageFactory::factory(array(
			'adapter' 	=> array(
				'name' 		=> 'filesystem',
				'options' 	=> array(
					'ttl' 			=> 300,
					'cache_dir'		=> $this->_cacheDir
				),
			),
			'plugins' 	=> array(
				'exception_handler' 	=> array('throw_exceptions' => false)
			)
        ));
        $cache->clearExpired();
        return $cache;
    }

    public function clearCache($cacheHash){
        $cache  = $this->getCacheAdapter();
        return $cache->removeItem($cacheHash);
    }

    /**
     * @author Ramdhani lukman 
     * mendapatkan semua tanggal di jangka waktu .
     * keren coy, text ini bisa di sniff sama vscode
     * 
     * @param datetime $start_date tanggal awal
     *
     * @param datetime $end_date tanggal akhir
     *
     * @return array
     */
    public static function dateToArray($start_date,$end_date){
        $begin = new \DateTime($start_date);
        $end = new \DateTime($end_date);
        $begin->setTime(0,0); 
        $end->setTime(12,0);

        $interval = \DateInterval::createFromDateString('1 day');
        $period = new \DatePeriod($begin, $interval, $end);

        $listDate   = [];

        foreach ($period as $dt) {
            $listDate[] = $dt->format("Y-m-d");
        }
        return $listDate;
    }

    static function getAddonConfig(){
        /* local config cache */
        $naf    = \Neuron\Application\Framework\Entity::get();
        $vendorDir  = $naf->base()->getVenDir();
        $file = join(DIRECTORY_SEPARATOR,[
            $vendorDir,
            'Addon',
            'Order',
            'SimpleFlow',
            'Config.php'
        ]);
        
        if(file_exists($file)){
            $config = new \Zend\Config\Config(include $file, true);
            if (isset($config->simpleflow)){
                $config = $config->simpleflow;
            }else {
                $config = new \Zend\Config\Config([], true);
            }
            $cfg = $config->toArray();
        } else {
            $cfg = [];
        }

        $base = $naf->base()->getModuleConfig();
        $_config = \Zend\Stdlib\ArrayUtils::merge($cfg, $base);
        return $_config;
    }
    
}