<?php
namespace Neuron\Attendance\Request;
use Neuron\Generic\Result;
use Neuron\Generic\Set;
use Neuron\Application\Framework\Entity;

use Neuron\Attendance\Request\Approval;

use Neuron\Attendance\Request\Types;
use Neuron\Attendance\Request\Approvals;

class Approvals extends Set{
	protected $_storage;
	function __construct(Approval\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null,$mode = Approval\Storage::LIST_ALL,$params = array() ){
		$result 		= new Result();
		$list 			= array();
		$rs 			= $this->_storage->loadList($id,$mode,$params);
		if($rs->list){
			foreach ($rs->list as $row) {
                $row = array_change_key_case($row);
                unset($row['b_rownum']);
                
				$approval 		= new Approval($this->_storage);
				
				/* add url to avatar */
				if(class_exists('Neuron\Application\Framework\Entity')){
					$naf = Entity::get();
					$baseURL = $naf->layout()->getHomeURL();
					$row['avatar'] = $baseURL.$row['avatar'];
				}
				
                $approval->push($row);
                $this->add($approval);
				
                $list[] 		= $row;
			}

			
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> $rs->countTotal
			);
		}else{
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> 0
			);
		}
		return $result;
	}

	public function loadCountByType($id = null, $mode = Approval\Storage::LIST_ALL,$params = array()){
        $result 		= new Result;
        $types       = new Types(Type\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig()));
        $rs      = $types->load();
        if($rs->data['rows']){
            $arrtype = array();
            foreach($rs->data['rows'] as $type){
                unset($type['setting']);
                unset($type['setting_id']);
                $type['count'] = $this->_storage->loadCountByType($mode, array('ref_id' => $params['ref_id'], 'request_type'=> $type['type_id'], 'status_id'=> 1));
                $type['pastCount'] = $this->_storage->loadCountByType($mode, array('ref_id' => $params['ref_id'], 'request_type'=> $type['type_id'],'status_id'=> 1, 'notEquals'=> 1));
    
                array_push($arrtype, $type);
            }
            $result->data = $arrtype;
        }else{
            $result->data = null;
        }

        return $result;
    }
}