<?php
namespace Neuron\Attendance\Request\Setting;

use Neuron\Generic\Entity\Map;

class Detail extends \Neuron\Generic\Entity\Mapper {
    
    protected $_storage;

    public function __construct(\Neuron\Attendance\Request\Setting\Detail\Storage\Skeleton $storage, $data = array()) {

        $this->_storage = $storage;

        parent::__construct(
            $data, 
            array(
                new Map('detail_id'),
                new Map('setting_id'),
                new Map('seq'),
                new Map('approval_type_id'),
                new Map('type_value'),
                new Map('setting_approval_id',null,true),
                new Map('type_value_description',null,true)
            ),
            parent::CASE_INSENSITIVE
        );
    }

    public function listdata($params) {
        $data = $this->_storage->listdata($params);

        $paramcount = (isset($params['rowCount']) ? $params['rowCount'] : 0);
        $parampage = (isset($params['page']) ? $params['page'] : 0);

        $rowCount = ($paramcount > 0) ? $paramcount : $data['dataCount']['total_count'];
        
        $draw = (isset($params['draw'])) ? $params['draw'] : null;
        $output = array(
            'draw' => $draw,
            'recordsFiltered' => intval($data['dataCount']['total_count']),
            'recordsTotal' => intval($data['dataCount']['total_count']),
            'data' => $data['dataAll']
        );

        $result = new \Neuron\Generic\Result();
        $result->data = $output;

        return $result;
    }
	
    public function load($id,$setting_id = false) {
        if ($data = $this->_storage->load($id,$setting_id)) {
            // $this->push($data);
            // push ini untuk mengesign ke diri sendiri

            $return = array(
                    'guid' => 0,
                    'code' => 200,
                    'info' => 'Data Found',
                    'data' => $data
                );

            return $return;
        }

        return array(
                    'guid' => 0,
                    'code' => 203,
                    'info' => 'Data Not Found',
                    'data' => null
                );
    }

    public function save($update = false) {
        if ($id = $this->_storage->save($this, $update)) {
            $this->setting_id = $id;
            return true;
        }
        return false;
    }

    public function saveChange($param) {
        return $this->_storage->saveChange($param);
    }

    public function delete($id = null, $mode = Detail\Storage::DELETEBY_ID) {
        return $this->_storage->remove($id,$mode);
    }

    public function approvalTypeDdl($term = null) {
        return $this->_storage->approvalTypeDdl($term);
    }

    public function searchExisting($setting_id, $seq) {
        return $this->_storage->searchExisting($setting_id, $seq);
    }

    public function loadDetail($id){
        return $this->_storage->loadDetail($id);
    }

    public function loadSeqUp($setting, $seq){
        return $this->_storage->loadSeqUp($setting, $seq);
    }
    
}
