<?php
namespace Neuron\Attendance\Request\Setting;

use Neuron\Attendance\Request\Setting\Detail;
use Neuron\Generic\Result;
use Neuron\Employee;

class Details extends \Neuron\Generic\Set{
    protected $_storage;

    public function __construct(Detail\Storage\Skeleton $storage){
        $this->_storage = $storage;
    }

    public function load($id = null , $mode = Detail\Storage::LIST_ALL,$params = array()){
        $result     = new Result();
        $rs         = $this->_storage->loadList($id,$mode,$params);
        $list       = array();
        $countTotal = 0;
        if($rs){
            $countTotal = $rs->countTotal;
            $rows       = $rs->rows;
            foreach ($rows as $row ) {
                $row = array_change_key_case($row);
                unset($row['b_rownum']);

                $typeValDescription     = null;
                if($row['approval_type_id'] == Detail\Storage::TYPE_SPECIFIC){
                    $employeeStorage    = Employee\Entity\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig());
                    $employee           = new Employee\Entity($employeeStorage);
                    $data               = $employee->loadMap($row['type_value'],'person_id')['data'];
                    $typeValDescription = $data['first_name'].' '.$data['last_name'];
                }

                $row['type_value_description'] = $typeValDescription;

                $detail     = new Detail($this->_storage);
                $detail->push($row);
                $this->add($detail);

                $list[]     = $row;
            }
        }
        
        $result->data   = array(
            'rows'  => $list,
            'countTotal' => $countTotal
        );

        return $result;

    }
}

