<?php
namespace Neuron\Attendance\Request\Setting;

use Neuron\Attendance\Request\Setting\Type;
use Neuron\Generic\Result;
use Neuron\Employee;

class Types extends \Neuron\Generic\Set{
    protected $_storage;

    public function __construct(Type\Storage\Skeleton $storage){
        $this->_storage = $storage;
    }

    public function load($id = null , $mode = Type\Storage::LIST_ALL,$params = array()){
        $result     = new Result();
        $rs         = $this->_storage->loadList($id,$mode,$params);
        $list       = array();
        $countTotal = 0;
        if($rs){
            $countTotal = $rs->countTotal;
            $rows       = $rs->rows;
            foreach ($rows as $row ) {
                $row = array_change_key_case($row);
                unset($row['b_rownum']);
                
                $type     = new Type($this->_storage);
                $type->push($row);
                $this->add($type);

                $list[]     = $row;
            }
        }
        
        $result->data   = array(
            'rows'  => $list,
            'countTotal' => $countTotal
        );

        return $result;

    }
}

