<?php
namespace Neuron\Attendance\Request;
use Neuron\Generic\Result;
use Neuron\Generic\Set;

use Neuron\Attendance\Request\Status;

class Statuses extends Set{
	protected $_storage;
	function __construct(Status\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null,$mode = Status\Storage::LIST_ALL,$params = array() ){
		$result 		= new Result();
		$list 			= array();
		$rs 			= $this->_storage->loadList($id,$mode,$params);
		if($rs){
			foreach ($rs->list as $row) {
                $row = array_change_key_case($row);
                unset($row['b_rownum']);
                
                $approval 		= new Status($this->_storage);
                $approval->push($row);
                $this->add($approval);

                $list[] 		= $row;
			}
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> $rs->countTotal
			);
		}else{
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> 0
			);
		}
		return $result;
	}
}