<?php
namespace Neuron\Attendance\Request;

use Neuron\Generic\Result;
use Neuron\Generic\Entity\Map;
use Neuron\Generic\Entity\Mapper;

class Type extends Mapper{
	protected $_storage;

	function __construct(Type\Storage\Skeleton $storage,$data = array()){
		$this->_storage = $storage;
		parent::__construct(
			$data,
			array(
				new Map('type_id'),
				new Map('type_name'),
				new Map('setting_id'),
				new Map('setting_name',null,true),
				new Map('num_to_approve',null,true),
				new Map('min_approved',null,true),
				new Map('min_rejected',null,true),
				new Map("mandatory_end_date",null,true)
			),
			parent::CASE_INSENSITIVE
		);
	}

	public function load($id = null, $mode = Type\Storage::LOADBY_ID,$params = array()){
		$result 	= new Result();

		$data 		= $this->_storage->load($id,$mode,$params);

		if($data){
			$result->data = $data;
			$this->push($data);
		}else{
			$result->data = array();
		}

		return $result;
	}
}