<?php
namespace Neuron\Attendance\Request\Type\Storage;

use Neuron\Attendance\Request\Type;

class Mysql extends \Neuron\Db\Storage implements Skeleton{

	public function loadList($id = null, $mode = Type\Storage::LIST_ALL,$params = array() ){
		$select 		= $this->select();
		$select->from($this->_tables['attd_request_type']);

		if($mode != Type\Storage::LIST_ALL){
			
		}

		if(isset($params['length']) && $params['length'] > 0){
			$select->limit(intval($params['length']));
			if(isset($params['start'])){
				$select->offset(intval($params['start']));
			}
		}

		if(isset($params['order'])){
			$columnName 	= $params['columns'][ $params['order'][0]['column'] ]['data'];
			$dir 			= $params['order'][0]['dir'];
			$select->order($columnName.' '.$dir);
		}
		if(isset($params['search'])){
			if(strlen($params['search']['value']) > 0){
				$searchTerm 	= "(";
				foreach ($params['columns'] as $data) {
					$searchTerm .= "lower(".$data['data'].") LIKE '%".strtolower($params['search']['value'])."%'";
				}
				$searchTerm 	.= ")";

				$select->where($searchTerm);
			}
		}

		try {
			$result 	= new \stdClass;
			$rs 		= $this->fetchAll($select);
			if($rs){
				$result->list 	= $rs;

				$select->columns(array(
					'countTotal' 	=> new \Zend\Db\Sql\Expression('COUNT(*)')
				));
				$select->reset('limit')->reset('offset');
				$result->countTotal 	= $this->fetchRow($select)['countTotal'];
			}else{
				$result->list 	= array();
				$result->countTotal 	= 0;
			}
			
			return $result;
		} catch (Exception $e) {
			return false;
		}
	}
	public function load($id = null, $mode = Type\Storage::LOADBY_ID,$params = array()){
		$select = $this->select();
		$select->from(array('art' => $this->_tables['attd_request_type']));

		$select->join(array('ars' => $this->_tables['attd_request_setting']),'art.setting_id = ars.setting_id');

		switch ($mode) {
			case Type\Storage::LOADBY_ID:
				$select->where(array('art.type_id' => $id));
				break;
		}

		try {
			$data 	= $this->fetchRow($select);
			return $data;
		} catch (\Exception $e) {
			error_log('Error at : '.$ex->getFile().' Line : '.$ex->getLine(). ' : '. $ex->getMessage());
			return false;
		}
	}

}