<?php
namespace Neuron\Attendance\Request;
use Neuron\Generic\Result;
use Neuron\Generic\Set;

use Neuron\Attendance\Request\Type;
use Neuron\Attendance\Request\Setting;

class Types extends Set{
	protected $_storage;
	function __construct(Type\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null,$mode = Type\Storage::LIST_ALL,$params = array() ){
		$result 		= new Result();
		$list 			= array();
		$rs 			= $this->_storage->loadList($id,$mode,$params);
		$setting 		= new Setting(Setting\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig())); 

		if($rs){
			foreach ($rs->list as $row) {
				$row = array_change_key_case($row);
				unset($row['b_rownum']);
				
				$mandatory_endDate 	= FALSE;
				if($row['type_id'] == 2){
					$mandatory_endDate = TRUE;
				}
				
				$row['mandatory_end_date'] = $mandatory_endDate;

                $approval 		= new Type($this->_storage);
                $approval->push($row);
				$this->add($approval);

				$setting->load($row['setting_id']);
				$row['setting'] = $setting->pull();

				$settingDetail 	= new Setting\Details(Setting\Detail\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig()));
				$detail 		= $settingDetail->load($setting->setting_id,Setting\Detail\Storage::LISTBY_SETTING_ID);
				
				if($detail->code == 0){
					$detail 	= $detail->data['rows'];
					$row['setting']['detail'] = $detail;
				}else{
					$row['setting']['detail'] = array();
				}
				
                $list[] 		= $row;
			}
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> $rs->countTotal
			);
		}else{
			$result->data = array(
				'rows' 	=> $list,
				'countTotal' 	=> 0
			);
		}
		return $result;
	}
}