<?php
namespace Neuron\Attendance;

use Neuron\Generic\Result;
use Neuron\Attendance\Request\Approvals;
use Neuron\Attendance\Request\Approval;

use Neuron\Attendance\Request\Types;

class Requests extends \Neuron\Generic\Set{
	protected $_storage;
    protected $_parent = null;

    public function __construct(Request\Storage\Skeleton $storage) {

        $this->_storage = $storage;

    }

    public function load($id = null, $mode = Request\Storage::LIST_ALL,$params = array(),$timeMode = Request\Storage::TIME_NONE){
    	$result 		= new Result;
    	$list 			= array();

    	$rs 			= $this->_storage->loadList($mode,$params,$timeMode);
        $rows           = array();
        $approvals       = new Approvals(Approval\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig()));
        $approval       = new Approval(Approval\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig()));
    	if($rs){
            if($rs->data){
        		foreach ($rs->data as $data) {
                    $request_id     = $data['request_id'];
                    if($data['end_dtm'] == '0000-00-00 00:00:00'){
                        $data['end_dtm'] = null;
                    }

                    // Ngambil data approval, untuk mengetahui jumlah yang telah di approve, reject , dll
                    $dataApproval   = $approval->getApprovalStatus($request_id);

                    $dataApprovalEmp       = $approvals->load($request_id,Approval\Storage::LISTBY_REQUEST_ID,array('request_id' => $request_id));
                    $data['approval'] = $dataApprovalEmp->data['rows'];
                    $data['total_reject'] = $dataApproval->data['total_reject'];
                    $data['total_approve'] = $dataApproval->data['total_approve'];
                    $data['total_requested'] = $dataApproval->data['total_requested'];
                    $data['total_canceled'] = $dataApproval->data['total_canceled'];

                    $rows[] = $data;
        		}
            }
            
            $result->data = array(
                'rows'  => $rows,
                'countTotal' => $rs->countTotal
            );
    	}else{
    		$result->code = 0;
    		$result->info = "No data loaded";
    		$result->data 	= $list;
    	}

    	return $result;

    }


    public function loadCountByType($id = null, $mode = Request\Storage::LIST_ALL,$params = array(),$timeMode = Request\Storage::TIME_NONE){
        $result 		= new Result;
        $types       = new Types(Request\Type\Storage::factory($this->_storage->getAdapter(),$this->_storage->getConfig()));
        $rs      = $types->load();
        if($rs->data['rows']){
            $arrtype = array();
            foreach($rs->data['rows'] as $type){
                unset($type['setting']);
                unset($type['setting_id']);
                $type['terkini'] = $this->_storage->loadCountByType($mode, array('ref_id' => $params['ref_id'], 'request_type'=> $type['type_id'], 'status_id'=> 1), $timeMode);
                $type['terdahulu'] = $this->_storage->loadCountByType($mode, array('ref_id' => $params['ref_id'], 'request_type'=> $type['type_id'],'status_id'=> 1, 'status_id_not'=> 1), $timeMode);
    
                array_push($arrtype, $type);
            }
            $result->data = $arrtype;
        }else{
            $result->data = null;
        }

        return $result;
    }
}