<?php
return array(
	"CREATE TABLE `attd_reference` (
	`reference_id` smallint(4) NOT NULL AUTO_INCREMENT,
	`code` varchar(40) NOT NULL,
	`description` varchar(128) DEFAULT NULL,
	PRIMARY KEY (`reference_id`),
	UNIQUE KEY `code_UNIQUE` (`code`)
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_request_setting` (
	`setting_id` smallint(6) NOT NULL AUTO_INCREMENT,
	`setting_name` varchar(250) DEFAULT NULL,
	`num_to_approve` tinyint(2) NOT NULL DEFAULT '1' COMMENT 'max number of persons to request',
	`min_approved` tinyint(2) NOT NULL DEFAULT '1' COMMENT 'minimal person to approve tobe approved;\n0 = all',
	`min_rejected` tinyint(2) DEFAULT '0' COMMENT 'minimal person to approve tobe rejected\n0 = all',
	PRIMARY KEY (`setting_id`)
	) ENGINE=InnoDB;",

	"INSERT INTO `attd_request_setting` (`setting_id`, `setting_name`,`num_to_approve`,`min_approved`,`min_rejected`) VALUES
	(1, 'Default', 2, 2, 1);",

	"CREATE TABLE `attd_request_setting_approval_type` (
	`approval_type_id` tinyint(4) NOT NULL,
	`name` varchar(40) NOT NULL,
	`description` varchar(200) DEFAULT NULL,
	PRIMARY KEY (`approval_type_id`)
	) ENGINE=InnoDB;",
	
	"CREATE TABLE `attd_request_status` (
	`status_id` tinyint(4) NOT NULL AUTO_INCREMENT,
	`name` varchar(40) NOT NULL,
	PRIMARY KEY (`status_id`)
	) ENGINE=InnoDB;",

	"INSERT INTO `attd_request_status` (`status_id`, `name`) VALUES
	(1,'Requested'),
	(2,'Approved'),
	(3,'Rejected'),
	(4,'Canceled');",

	"CREATE TABLE `attd_source_type` (
	`id` tinyint(4) NOT NULL AUTO_INCREMENT,
	`source_type_code` varchar(20) NOT NULL,
	`description` varchar(80) DEFAULT NULL,
	`start_date` date NOT NULL,
	`end_date` date DEFAULT NULL,
	PRIMARY KEY (`id`),
	UNIQUE KEY `source_type_code_UNIQUE` (`source_type_code`)
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_timetable` (
	`timetable_id` int(11) NOT NULL AUTO_INCREMENT,
	`code` varchar(64) DEFAULT NULL,
	`parent_timetable_id` int(11) DEFAULT NULL,
	`time_mode` varchar(10) NOT NULL DEFAULT 'WEEKLY' COMMENT 'WEEKLY / MONTHLY',
	`name` varchar(64) NOT NULL,
	`description` text null,
	PRIMARY KEY (`timetable_id`)
	) ENGINE=InnoDB AUTO_INCREMENT=23;",

	"CREATE TABLE `attd_object_group` (
	`group_id` int(11) NOT NULL AUTO_INCREMENT,
	`name` varchar(40) NOT NULL,
	`ref_code` varchar(40) NOT NULL,
	`description` varchar(120) DEFAULT NULL,
	`start_date` date NOT NULL,
	`end_date` date DEFAULT NULL,
	PRIMARY KEY (`group_id`),
	KEY `fk_objgrp_grp_idx` (`ref_code`),
	CONSTRAINT `fk_objgrp_grp` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_object_group_member` (
	`group_member_id` int(11) NOT NULL AUTO_INCREMENT,
	`group_id` int(11) NOT NULL,
	`ref_code` varchar(40) NOT NULL,
	`ref_id` int(11) NOT NULL,
	`start_date` date NOT NULL,
	`end_date` date DEFAULT NULL,
	`last_update_dtm` datetime NOT NULL,
	`update_by` int(11) NOT NULL,
	PRIMARY KEY (`group_member_id`),
	KEY `fk_objgrpm_grp_idx` (`group_id`),
	KEY `fk_objgrpm_ref_idx` (`ref_code`),
	CONSTRAINT `fk_objgrpm_grp` FOREIGN KEY (`group_id`) REFERENCES `attd_object_group` (`group_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	CONSTRAINT `fk_objgrpm_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_object_group_timetable` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`object_group_id` int(11) NOT NULL,
	`timetable_id` int(11) NOT NULL,
	`start_date` date NOT NULL,
	`end_date` date NOT NULL,
	`applied_status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0=init/not applied; 1=applied; ',
	`applied_on` datetime DEFAULT NULL,
	`applied_by` int(11) DEFAULT NULL,
	PRIMARY KEY (`id`),
	KEY `fk_ogtt_og_idx` (`object_group_id`),
	KEY `fk_ogtt_tt_idx` (`timetable_id`),
	CONSTRAINT `fk_ogtt_og` FOREIGN KEY (`object_group_id`) REFERENCES `attd_object_group` (`group_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	CONSTRAINT `fk_ogtt_ts` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`timetable_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_request` (
	`request_id` int(11) NOT NULL AUTO_INCREMENT,
	`ref_code` varchar(40) NOT NULL,
	`ref_id` int(11) NOT NULL,
	`start_dtm` datetime NOT NULL,
	`end_dtm` datetime DEFAULT NULL,
	`request_type` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = attendance; 2 = overtime',
	`request_dtm` datetime NOT NULL,
	`status_id` tinyint(4) NOT NULL DEFAULT '1',
	`request_message` tinytext NOT NULL,
	PRIMARY KEY (`request_id`),
	KEY `fk_attdreq_ref_idx` (`ref_code`),
	KEY `fk_attdreq_status_idx` (`status_id`),
	CONSTRAINT `fk_attdreq_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
	CONSTRAINT `fk_attdreq_status` FOREIGN KEY (`status_id`) REFERENCES `attd_request_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB AUTO_INCREMENT=38;",

	"CREATE TABLE `attd_request_approval` (
	`approval_id` int(11) NOT NULL AUTO_INCREMENT,
	`request_id` int(11) NOT NULL,
	`ref_code` varchar(40) NOT NULL,
	`ref_id` int(11) NOT NULL,
	`status_id` tinyint(4) NOT NULL DEFAULT '1',
	`approval_dtm` datetime NOT NULL,
	`reason` varchar(200) DEFAULT NULL,
	PRIMARY KEY (`approval_id`),
	KEY `fk_reqappr_req_idx` (`request_id`),
	KEY `fk_reqappr_ref_idx` (`ref_code`),
	KEY `fk_reqappr_status_idx` (`status_id`),
	CONSTRAINT `fk_reqappr_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
	CONSTRAINT `fk_reqappr_req` FOREIGN KEY (`request_id`) REFERENCES `attd_request` (`request_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	CONSTRAINT `fk_reqappr_status` FOREIGN KEY (`status_id`) REFERENCES `attd_request_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB AUTO_INCREMENT=81;",

	"CREATE TABLE `attd_request_setting_detail` (
	`detail_id` int(11) NOT NULL AUTO_INCREMENT,
	`setting_id` smallint(6) NOT NULL,
	`seq` tinyint(4) DEFAULT NULL,
	`approval_type_id` tinyint(4) NOT NULL,
	`type_value` varchar(40) DEFAULT NULL,
	PRIMARY KEY (`detail_id`),
	KEY `fk_attdreqset_set_idx` (`setting_id`),
	KEY `fk_attdreqset_apprtype_idx` (`approval_type_id`),
	CONSTRAINT `fk_attdreqset_apprtype` FOREIGN KEY (`approval_type_id`) REFERENCES `attd_request_setting_approval_type` (`approval_type_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	CONSTRAINT `fk_attdreqset_set` FOREIGN KEY (`setting_id`) REFERENCES `attd_request_setting` (`setting_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	"INSERT INTO `attd_request_setting_detail` (`detail_id`, `setting_id`, `seq`, `approval_type_id`, `type_value`) VALUES
	(1, 1, 1, 1, ''),
	(2, 1, 2, 1, 'null');",
	
	"CREATE TABLE `attd_timetable_object` (
	`timetable_object_id` int(11) NOT NULL AUTO_INCREMENT,
	`timetable_id` int(11) NOT NULL,
	`ref_code` varchar(40) NOT NULL,
	`ref_id` int(11) NOT NULL,
	`start_date` date NOT NULL,
	`end_date` date DEFAULT NULL,
	`last_update` datetime NOT NULL,
	`update_by` int(11) NOT NULL,
	PRIMARY KEY (`timetable_object_id`),
	KEY `fk_ttempex_ttshift_idx` (`timetable_id`),
	CONSTRAINT `fk_tto` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`timetable_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_timetable_object_chshift` (
	`tt_employee_shift_id` int(11) NOT NULL AUTO_INCREMENT,
	`ref_code` varchar(40) NOT NULL,
	`ref_id` int(11) NOT NULL,
	`shift_change_date` date NOT NULL,
	`default_shift_id` int(11) NOT NULL,
	`change_shift_id` int(11) NOT NULL,
	`recommendation_id` int(11) DEFAULT NULL,
	`change_by` int(11) DEFAULT NULL,
	PRIMARY KEY (`tt_employee_shift_id`),
	KEY `fk_ttchshift_defshift_idx` (`default_shift_id`),
	KEY `fk_ttchshift_chshift_idx` (`change_shift_id`),
	KEY `fk_ttchshift_req` (`recommendation_id`),
	CONSTRAINT `fk_ttchshift_chshift` FOREIGN KEY (`change_shift_id`) REFERENCES `attd_timetable_shift` (`timetable_shift_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	CONSTRAINT `fk_ttchshift_defshift` FOREIGN KEY (`default_shift_id`) REFERENCES `attd_timetable_shift` (`timetable_shift_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
	) ENGINE=InnoDB;",

	"CREATE TABLE `attd_timetable_shift` (
	`timetable_shift_id` int(11) NOT NULL AUTO_INCREMENT,
	`timetable_id` int(11) NOT NULL,
	`day_no` tinyint(1) NOT NULL COMMENT '1 = sunday, 7 = saturday',
	`is_workday` enum('0','1') NOT NULL DEFAULT '1' COMMENT '1 = workday, 2 = holiday',
	`on_duty_time` time NOT NULL,
	`off_duty_time` time NOT NULL,
	`in_beginning_time` time NOT NULL,
	`in_ending_time` time NOT NULL,
	`out_beginning_time` time NOT NULL,
	`out_ending_time` time NOT NULL,
	`late_time` varchar(4) DEFAULT '0',
	`leave_early_time` varchar(4) DEFAULT '0',
	`overtime_start_time` time NOT NULL,
	`start_date` date DEFAULT NULL,
	`end_date` date DEFAULT NULL,
	PRIMARY KEY (`timetable_shift_id`),
	KEY `fk_ttdet_tt_idx` (`timetable_id`),
	CONSTRAINT `fk_ttdet_tt` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`timetable_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB AUTO_INCREMENT=21;",

	"CREATE TABLE `attd_timetable_shiftmisc` (
	`shift_misc_id` int(11) NOT NULL AUTO_INCREMENT,
	`timetable_shift_id` int(11) NOT NULL,
	`misc_name` varchar(64) NOT NULL,
	`start_time` time NOT NULL,
	`end_time` time NOT NULL,
	PRIMARY KEY (`shift_misc_id`),
	KEY `fk_ttshmisc_shift_idx` (`timetable_shift_id`),
	CONSTRAINT `fk_ttshmisc_shift` FOREIGN KEY (`timetable_shift_id`) REFERENCES `attd_timetable_shift` (`timetable_shift_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	//edit penambahan table evidence
	"CREATE TABLE `attd_evidence` (
		`attd_evidence_id` int(11) NOT NULL AUTO_INCREMENT,
		`attendance_id` int(11) NOT NULL,
		`action_type` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = attend, 2 = request',
		`filename` varchar(256) NOT NULL,
		PRIMARY KEY (`attd_evidence_id`),
		KEY `fk_attdevi_attd_idx` (`attendance_id`),
		CONSTRAINT `fk_attdevi_attd` FOREIGN KEY (`attendance_id`) REFERENCES `attendance` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	  ) ENGINE=InnoDB DEFAULT CHARSET=latin1;",	  

	"INSERT INTO `attd_source_type` (`id`, `source_type_code`, `description`, `start_date`, `end_date`) VALUES
	(1,'FP','attendance USING fingerprint (source_reference = fp_machine_id)', '2019-01-01', NULL),
	(2,'WEB','attendance USING main web (source_reference = login_id)', '2019-01-01', NULL),
	(3,'ADMIN','attendance SET BY admin (source_reference = admin_user_id)', '2019-01-01', NULL),
	(4,'REQUEST','attendance BY request recommendation (source_reference = request_id)', '2019-01-01', NULL);",

	"CREATE TABLE `attendance` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`type_id` TINYINT(1) NOT NULL DEFAULT '1' COMMENT '1 = attendance; 2 = overtime',
	`start_dtm` DATETIME NOT NULL,
	`start_description` VARCHAR(120) DEFAULT NULL,
	`end_dtm` DATETIME DEFAULT NULL,
	`end_description` VARCHAR(120) DEFAULT NULL,
	`ref_code` VARCHAR(40) NOT NULL,
	`ref_id` INT(11) NOT NULL,
	`source_type_code` VARCHAR(10) NOT NULL,
	`source_reference` VARCHAR(40) NOT NULL,
	`source_dtm` DATETIME NOT NULL,
	`overtime_start_dtm` DATETIME DEFAULT NULL,
	`overtime_end_dtm` DATETIME DEFAULT NULL,
	`longitude` TEXT,
	`latitude` TEXT,
	PRIMARY KEY (`id`),
	KEY `fk_attd_srctype_idx` (`source_type_code`),
	KEY `idx_attd_ref` (`ref_code`,`ref_id`),
	KEY `fk_attd_ref_idx` (`ref_code`),
	CONSTRAINT `fk_attd_ref` FOREIGN KEY (`ref_code`) REFERENCES `attd_reference` (`code`) ON UPDATE CASCADE,
	CONSTRAINT `fk_attd_srctype` FOREIGN KEY (`source_type_code`) REFERENCES `attd_source_type` (`source_type_code`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=INNODB AUTO_INCREMENT=145;",

	"INSERT INTO `attd_reference` (`reference_id`, `code`, `description`) values('1','EMPLOYEE','Employee'),('2','GROUP','Group');",
	
	# Insert Default 
	#table: acc_access_objects
	"INSERT INTO `acc_access_objects`(`access_object_code`,`access_object_type_id`,`access_object_parent`,`name`,`description`,`reference`) VALUES 
	('add_timetable',3,'mnu_attd','Add Timetable','Entity Add Timetable',''),
	('edit_timetable',3,'mnu_attd','Edit Timetable','Entity Edit Employee',''),
	('remove_timetable',3,'mnu_attd','Remove Timetable','Entity Remove Timetable',''),
	('detail_timetable',3,'mnu_attd','Detail Timetable','Entity Detail Timetable',''),
	('manageshift_timetable',3,'mnu_attd','Manage Shift','Entity Manage Shift',''),
	('mappingshift_timetable',3,'mnu_attd','Mapping Shift','Entity Mapping Shift',''),
	('add_shift',3,'mnu_attd','Add Shift','Entity Add Shift',''),
	('edit_shift',3,'mnu_attd','Edit Shift','Entity Edit Shift',''),
	('remove_shift',3,'mnu_attd','Remove Shift','Entity Remove Shift',''),
	('detail_shift',3,'mnu_attd','Detail Shift','Entity Detail Shift','');",

	"insert  into `acc_access_objects`
	(`access_object_code`,`access_object_type_id`,`access_object_parent`,`name`,`description`,`reference`) 
	values 
	('widget_widget-attd-today-status','4',NULL,'Today Status','Today Status',''),
	('widget_widget-attd','4',NULL,'Attendance Reporting','Attendance Reporting',''),
	('widget_widget-attd-overtime','4',NULL,'Overtime','Overtime','');",

	"insert  into `acc_access_grants`(`access_grant_id`,`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) values 
	(NULL, 1, 'widget_widget-attd', 4, 3, NOW(), NULL),
	(NULL, 1, 'widget_widget-attd', 4, 1, NOW(), NULL),
	(NULL, 1, 'widget_widget-attd-today-status', 4, 3, NOW(), NULL),
	(NULL, 1, 'widget_widget-attd-today-status', 4, 1, NOW(), NULL),
	(NULL, 1, 'widget_widget-attd-overtime', 4, 3, NOW(), NULL),
	(NULL, 1, 'widget_widget-attd-overtime', 4, 1, NOW(), NULL);",

	"INSERT  INTO `attd_request_setting_approval_type`(`approval_type_id`,`name`,`description`) values 
	(1,'Free','ALL object can be requested (type_value = ref_id approver)'),
	(2,'Spesific','Only the apoointed object can be requested (type_value = ref_id approver)'),
	(3,'Superior','Direct superiors of the object (required Organization libs) (type_value = org_id)'),
	(4,'Organization','ALL object ON the appointed org can be requested (required Organization libs) (type_value = org_id)');",

	## INSERT template notif attendance
	"INSERT INTO `not_templates` ( `notif_profile_id`, `template_code`, `template_name`, `description`, `icon`) VALUES('1','REQUEST_NEED_APPROVAL','New Attendance Request','Notifikasi yang dikirimkan ke Approvalnya ','http://icons.iconarchive.com/icons/scafer31000/bubble-circle-2/256/Message-icon.png');",
	"INSERT INTO `not_templates` (`notif_profile_id`, `template_code`, `template_name`, `description`, `icon`) VALUES('1','REQUEST_REJECT','Attendance Request Reject ','Notifikasi ketika request di Reject dikirim ke Requester',NULL);",


	#inser action notif acttendance
	"INSERT INTO `not_action` (`notif_action_code`, `notif_action_type_id`, `reference`, `data`, `remark`) values ('attendance_approval', '3', 'openModalApproval', NULl, 'Request List');",
	"INSERT INTO `not_action` (`notif_action_code`, `notif_action_type_id`, `reference`, `data`, `remark`) values ('attendance_request', '2', 'attendance/form/request', NULl, 'Approval List');",
	
	#INSERT content notif attendance
	"INSERT INTO `not_content` (`notif_template_id`,`subject`,`content`,`notif_action_code`)VALUES((SELECT notif_template_id FROM not_templates WHERE template_code = 'REQUEST_NEED_APPROVAL' LIMIT 1), 'Request Attendance from %name% waiting for your approval', 'Request Attendance %request_type% from %name% waiting for your approval', 'attendance_approval');",
	"INSERT INTO `not_content` (`notif_template_id`,`subject`,`content`,`notif_action_code`)VALUES((SELECT notif_template_id FROM not_templates WHERE template_code = 'REQUEST_REJECT' LIMIT 1), 'Your Attendance request %request_type% was rejected', 'Your Attendance request %request_type% was rejected', 'attendance_request');",

	#Insert Notification Action Type
	'INSERT INTO not_action_type (`notif_action_type_id`,`name`,`description`) VALUES (NULL,"Script","Execute Javascript function");',
	
	#request type
	"CREATE TABLE `attd_request_type` (
	`type_id` tinyint(11) NOT NULL AUTO_INCREMENT,
	`type_name` varchar(100) DEFAULT NULL,
	`setting_id` smallint(11) DEFAULT NULL,
	PRIMARY KEY (`type_id`),
	KEY `setting_id` (`setting_id`),
	CONSTRAINT `attd_request_type_ibfk_1` FOREIGN KEY (`setting_id`) REFERENCES `attd_request_setting` (`setting_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",
	
	"INSERT INTO `attd_request_type` (`type_id`,`type_name`,`setting_id`) VALUES 
	(1,'Attendance',1),
	(2,'Overtime',1),
	(3,'Change Shift',1);",

	//insert ke table order_types
	"INSERT IGNORE INTO order_types (order_type_id,name,description) VALUES
	('2100','Attendance','used by Approval modules');",

	//insert ke table order_subtypes
	"INSERT IGNORE INTO `order_subtypes` (`order_subtype_id`,`name`,`description`,`order_type_id`) VALUES
	('2101','Attendance','Order request attendance, used by module attendance','2100'),
	('2102','Overtime','Order request overtime, used by module attendance','2100'),
	('2103','Change Shift','Order request changeshift, used by module attendance','2100');",


	//insert ke table mapp setting
	"INSERT IGNORE INTO `app_request_type_map` (`order_type_id`, `setting_id`, `start_date`, `end_date`)VALUES
	('2101',1 ,NOW(),NULL),
	('2102',1 ,NOW(),NULL),
	('2103',1 ,NOW(),NULL);",

	# Grant Role User, di pindah ke module.php

	// "INSERT INTO `acc_access_grants` (`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) 
    //             VALUES ('1','mnu_attd','4','2',NOW(),'9999-09-09 00:00:00');",

	// "INSERT INTO `acc_access_grants` (`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) 
    //             VALUES ('1','mnu_attd_manage','4','2',NOW(),'9999-09-09 00:00:00');",

	// "INSERT INTO `acc_access_grants` (`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) 
    //             VALUES ('1','mnu_attd_request','4','2',NOW(),'9999-09-09 00:00:00');",

	// "INSERT INTO `acc_access_grants` (`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) 
	// 			VALUES ('1','mnu_attd_reporting','4','2',NOW(),'9999-09-09 00:00:00');",


	##### DEFAULT DATA FOR DEMO ######

	"INSERT INTO `attd_request` (`request_id`, `ref_code`, `ref_id`, `start_dtm`, `end_dtm`, `request_type`, `request_dtm`, `status_id`, `request_message`) VALUES
		(8, 'EMPLOYEE', 1, '2019-12-17 07:21:00', NULL, 1, '2019-12-17 16:22:33', 1, ' Bismillah masuk'),
		(9, 'EMPLOYEE', 1, '2019-12-16 06:22:00', NULL, 1, '2019-12-17 16:23:15', 2, ' Bismillah SPJ Jakarta'),
		(10, 'EMPLOYEE', 1, '2019-12-02 18:23:00', '2019-12-02 21:23:00', 2, '2019-12-17 16:24:37', 1, ' Lembur UAT'),
		(11, 'EMPLOYEE', 2, '2019-12-17 09:28:00', NULL, 1, '2019-12-17 16:29:30', 1, ' Hadir'),
		(12, 'EMPLOYEE', 2, '2019-12-16 08:29:00', NULL, 1, '2019-12-17 16:30:22', 2, ' Hadir'),
		(13, 'EMPLOYEE', 2, '2019-12-02 19:30:00', '2019-12-02 20:30:00', 2, '2019-12-17 16:32:12', 1, ' Lembur perumusan proker 2020'),
		(14, 'EMPLOYEE', 3, '2019-12-17 08:36:00', NULL, 1, '2019-12-17 16:37:58', 1, ' Masuk'),
		(15, 'EMPLOYEE', 3, '2019-12-16 08:38:00', NULL, 1, '2019-12-17 16:39:05', 2, ' Masuk'),
		(16, 'EMPLOYEE', 3, '2019-12-02 18:39:00', '2019-12-02 19:39:00', 2, '2019-12-17 16:40:02', 1, ' Lembur create sample data demo'),
		(17, 'EMPLOYEE', 4, '2019-12-16 09:20:00', NULL, 1, '2019-12-18 09:21:18', 1, ' Bismillah'),
		(18, 'EMPLOYEE', 4, '2019-12-17 07:17:00', NULL, 1, '2019-12-18 09:22:00', 2, ' Bismillah'),
		(19, 'EMPLOYEE', 4, '2019-12-04 18:22:00', '2019-12-04 21:22:00', 2, '2019-12-18 09:22:46', 1, ' Lembur KPS'),
		(20, 'EMPLOYEE', 5, '2019-12-16 09:24:00', NULL, 1, '2019-12-18 09:25:51', 1, ' Hadir'),
		(21, 'EMPLOYEE', 5, '2019-12-17 07:26:00', NULL, 1, '2019-12-18 09:26:34', 2, ' Hadir'),
		(22, 'EMPLOYEE', 5, '2019-12-05 20:26:00', '2019-12-05 21:26:00', 2, '2019-12-18 09:27:37', 1, ' Lembur BKI update API recent knowlegde'),
		(23, 'EMPLOYEE', 6, '2019-12-16 09:38:00', NULL, 1, '2019-12-18 09:38:27', 1, ' Masuk'),
		(24, 'EMPLOYEE', 6, '2019-12-17 07:38:00', NULL, 1, '2019-12-18 09:39:13', 2, ' Masuk'),
		(25, 'EMPLOYEE', 6, '2019-12-03 19:40:00', '2019-12-03 21:40:00', 2, '2019-12-18 09:42:08', 1, ' Lembur bug fixing person management'),
		(26, 'EMPLOYEE', 7, '2019-12-16 09:47:00', NULL, 1, '2019-12-18 09:47:45', 1, ' Hadir'),
		(27, 'EMPLOYEE', 7, '2019-12-17 07:47:00', NULL, 1, '2019-12-18 09:48:22', 2, ' Hadir'),
		(28, 'EMPLOYEE', 7, '2019-12-09 19:48:00', '2019-12-09 22:48:00', 2, '2019-12-18 09:49:08', 1, ' Lembur enhance leave management'),
		(29, 'EMPLOYEE', 8, '2019-12-16 09:49:00', NULL, 1, '2019-12-18 09:50:25', 1, ' Masuk'),
		(30, 'EMPLOYEE', 8, '2019-12-17 07:50:00', NULL, 1, '2019-12-18 09:50:58', 2, ' Masuk'),
		(31, 'EMPLOYEE', 8, '2019-12-10 21:51:00', '2019-12-18 22:51:00', 2, '2019-12-18 09:51:48', 1, ' Lembur bug fixing category management'),
		(32, 'EMPLOYEE', 9, '2019-12-16 14:53:00', NULL, 1, '2019-12-18 09:54:19', 1, ' Bismillah'),
		(33, 'EMPLOYEE', 9, '2019-12-17 13:55:00', NULL, 1, '2019-12-18 09:56:04', 2, ' Bismillah'),
		(34, 'EMPLOYEE', 9, '2019-12-10 23:56:00', '2019-12-11 01:56:00', 2, '2019-12-18 09:57:09', 1, ' Lembur KPS validasi data'),
		(35, 'EMPLOYEE', 10, '2019-12-16 14:01:00', NULL, 1, '2019-12-18 10:01:59', 2, ' Bismillah'),
		(36, 'EMPLOYEE', 10, '2019-12-11 23:02:00', '2019-12-12 01:02:00', 2, '2019-12-18 10:03:06', 1, ' Lembur standarisasi namespace'),
		(37, 'EMPLOYEE', 12, '2019-12-12 10:17:00', '2019-12-12 12:17:00', 2, '2019-12-18 10:18:08', 1, ' Lembur finance');",

	"INSERT INTO `attd_request_approval` (`approval_id`, `request_id`, `ref_code`, `ref_id`, `status_id`, `approval_dtm`, `reason`) VALUES
		(22, 8, 'EMPLOYEE', 2, 1, '2019-12-17 16:22:33', NULL),
		(23, 8, 'EMPLOYEE', 3, 1, '2019-12-17 16:22:33', NULL),
		(24, 9, 'EMPLOYEE', 2, 2, '2019-12-17 16:28:23', 'OK'),
		(25, 9, 'EMPLOYEE', 3, 2, '2019-12-17 16:35:10', 'ok'),
		(26, 10, 'EMPLOYEE', 2, 2, '2019-12-17 16:26:25', 'OK'),
		(27, 10, 'EMPLOYEE', 3, 2, '2019-12-17 16:34:59', 'ok'),
		(28, 11, 'EMPLOYEE', 1, 1, '2019-12-17 16:29:30', NULL),
		(29, 11, 'EMPLOYEE', 3, 1, '2019-12-17 16:29:30', NULL),
		(30, 12, 'EMPLOYEE', 1, 2, '2019-12-18 09:14:29', 'ok'),
		(31, 12, 'EMPLOYEE', 3, 2, '2019-12-17 16:35:40', 'ok'),
		(32, 13, 'EMPLOYEE', 1, 2, '2019-12-17 16:53:50', 'ok'),
		(33, 13, 'EMPLOYEE', 3, 2, '2019-12-17 16:34:03', 'ok'),
		(34, 14, 'EMPLOYEE', 1, 1, '2019-12-17 16:37:58', NULL),
		(35, 14, 'EMPLOYEE', 2, 1, '2019-12-17 16:37:59', NULL),
		(36, 15, 'EMPLOYEE', 1, 2, '2019-12-18 09:05:03', 'OK'),
		(37, 15, 'EMPLOYEE', 2, 2, '2019-12-18 09:16:35', 'ok'),
		(38, 16, 'EMPLOYEE', 1, 2, '2019-12-18 11:31:02', 'ok'),
		(39, 16, 'EMPLOYEE', 2, 2, '2019-12-18 11:32:02', 'ok'),
		(40, 17, 'EMPLOYEE', 5, 1, '2019-12-18 09:21:18', NULL),
		(41, 17, 'EMPLOYEE', 6, 1, '2019-12-18 09:21:18', NULL),
		(42, 18, 'EMPLOYEE', 5, 2, '2019-12-18 09:24:44', 'ok'),
		(43, 18, 'EMPLOYEE', 6, 2, '2019-12-18 09:36:46', 'ok'),
		(44, 19, 'EMPLOYEE', 5, 2, '2019-12-18 09:23:55', 'ok'),
		(45, 19, 'EMPLOYEE', 6, 2, '2019-12-18 09:35:12', 'ok'),
		(46, 20, 'EMPLOYEE', 4, 1, '2019-12-18 09:25:51', NULL),
		(47, 20, 'EMPLOYEE', 6, 1, '2019-12-18 09:25:51', NULL),
		(48, 21, 'EMPLOYEE', 6, 2, '2019-12-18 09:36:10', 'ok'),
		(49, 21, 'EMPLOYEE', 4, 2, '2019-12-18 09:44:47', 'ok'),
		(50, 22, 'EMPLOYEE', 4, 2, '2019-12-18 09:44:09', 'ok'),
		(51, 22, 'EMPLOYEE', 6, 2, '2019-12-18 09:35:02', 'ok'),
		(52, 23, 'EMPLOYEE', 5, 1, '2019-12-18 09:38:27', NULL),
		(53, 23, 'EMPLOYEE', 4, 1, '2019-12-18 09:38:27', NULL),
		(54, 24, 'EMPLOYEE', 5, 2, '2019-12-18 09:43:11', 'ok'),
		(55, 24, 'EMPLOYEE', 4, 2, '2019-12-18 09:44:28', 'ok'),
		(56, 25, 'EMPLOYEE', 5, 2, '2019-12-18 09:42:56', 'ok'),
		(57, 25, 'EMPLOYEE', 4, 2, '2019-12-18 09:43:46', 'ok'),
		(58, 26, 'EMPLOYEE', 8, 1, '2019-12-18 09:47:45', NULL),
		(59, 26, 'EMPLOYEE', 9, 1, '2019-12-18 09:47:45', NULL),
		(60, 27, 'EMPLOYEE', 8, 2, '2019-12-18 09:49:51', 'ok'),
		(61, 27, 'EMPLOYEE', 9, 2, '2019-12-18 09:53:05', 'ok'),
		(62, 28, 'EMPLOYEE', 8, 2, '2019-12-18 09:49:43', 'ok'),
		(63, 28, 'EMPLOYEE', 9, 2, '2019-12-18 09:52:52', 'ok'),
		(64, 29, 'EMPLOYEE', 9, 1, '2019-12-18 09:50:25', NULL),
		(65, 29, 'EMPLOYEE', 7, 1, '2019-12-18 09:50:25', NULL),
		(66, 30, 'EMPLOYEE', 9, 2, '2019-12-18 09:52:40', 'ok'),
		(67, 30, 'EMPLOYEE', 7, 2, '2019-12-18 09:59:46', 'ok'),
		(68, 31, 'EMPLOYEE', 9, 2, '2019-12-18 09:52:28', 'ok'),
		(69, 31, 'EMPLOYEE', 7, 2, '2019-12-18 09:59:14', 'ok'),
		(70, 32, 'EMPLOYEE', 7, 1, '2019-12-18 09:54:19', NULL),
		(71, 32, 'EMPLOYEE', 8, 1, '2019-12-18 09:54:20', NULL),
		(72, 33, 'EMPLOYEE', 7, 2, '2019-12-18 09:59:24', 'ok'),
		(73, 33, 'EMPLOYEE', 8, 2, '2019-12-18 09:58:07', 'ok'),
		(74, 34, 'EMPLOYEE', 7, 2, '2019-12-18 09:59:02', 'ok'),
		(75, 34, 'EMPLOYEE', 8, 2, '2019-12-18 09:57:56', 'ok'),
		(76, 35, 'EMPLOYEE', 11, 2, '2019-12-18 10:04:00', 'ok'),
		(77, 35, 'EMPLOYEE', 12, 2, '2019-12-18 10:12:47', 'ok'),
		(78, 36, 'EMPLOYEE', 11, 2, '2019-12-18 10:03:48', 'ok'),
		(79, 36, 'EMPLOYEE', 12, 2, '2019-12-18 10:12:39', 'ok'),
		(80, 37, 'EMPLOYEE', 10, 2, '2019-12-18 10:30:13', 'ok'),
		(81, 37, 'EMPLOYEE', 11, 2, '2019-12-18 10:19:50', 'ok');",

	"INSERT INTO `attd_timetable` (`timetable_id`, `code`, `parent_timetable_id`, `time_mode`, `name`) VALUES
		(1, 'REG', NULL, 'WEEKLY', 'Reguler'),
		(2, 'SREG_2', 1, 'WEEKLY', 'Shift Reguler'),
		(3, 'SREG_3', 1, 'WEEKLY', 'Shift Reguler'),
		(4, 'SREG_4', 1, 'WEEKLY', 'Shift Reguler'),
		(5, 'SREG_5', 1, 'WEEKLY', 'Shift Reguler'),
		(6, 'SREG_6', 1, 'WEEKLY', 'Shift Reguler'),
		(7, 'SHF', NULL, 'WEEKLY', 'Shifting'),
		(8, 'SPAGI_2', 7, 'WEEKLY', 'Shift Pagi'),
		(9, 'SPAGI_3', 7, 'WEEKLY', 'Shift Pagi'),
		(10, 'SPAGI_4', 7, 'WEEKLY', 'Shift Pagi'),
		(11, 'SPAGI_5', 7, 'WEEKLY', 'Shift Pagi'),
		(12, 'SPAGI_6', 7, 'WEEKLY', 'Shift Pagi'),
		(13, 'SSIANG_2', 7, 'WEEKLY', 'Shift Siang'),
		(14, 'SSIANG_3', 7, 'WEEKLY', 'Shift Siang'),
		(15, 'SSIANG_4', 7, 'WEEKLY', 'Shift Siang'),
		(16, 'SSIANG_5', 7, 'WEEKLY', 'Shift Siang'),
		(17, 'SSIANG_6', 7, 'WEEKLY', 'Shift Siang'),
		(18, 'SMALAM_2', 7, 'WEEKLY', 'Shift Malam'),
		(19, 'SMALAM_3', 7, 'WEEKLY', 'Shift Malam'),
		(20, 'SMALAM_4', 7, 'WEEKLY', 'Shift Malam'),
		(21, 'SMALAM_5', 7, 'WEEKLY', 'Shift Malam'),
		(22, 'SMALAM_6', 7, 'WEEKLY', 'Shift Malam');",

	"INSERT INTO `attd_timetable_object` (`timetable_object_id`, `timetable_id`, `ref_code`, `ref_id`, `start_date`, `end_date`, `last_update`, `update_by`) VALUES
		(1, 2, 'EMPLOYEE', 1, '2019-12-01', '2020-12-31', '2019-12-16 15:54:11', 10000000),
		(2, 3, 'EMPLOYEE', 1, '2019-12-01', '2020-12-31', '2019-12-16 15:54:11', 10000000),
		(3, 4, 'EMPLOYEE', 1, '2019-12-01', '2020-12-31', '2019-12-16 15:54:11', 10000000),
		(4, 5, 'EMPLOYEE', 1, '2019-12-01', '2020-12-31', '2019-12-16 15:54:11', 10000000),
		(5, 6, 'EMPLOYEE', 1, '2019-12-01', '2020-12-31', '2019-12-16 15:54:11', 10000000),
		(6, 2, 'EMPLOYEE', 2, '2019-12-01', '2020-12-31', '2019-12-16 15:54:28', 10000000),
		(7, 3, 'EMPLOYEE', 2, '2019-12-01', '2020-12-31', '2019-12-16 15:54:28', 10000000),
		(8, 4, 'EMPLOYEE', 2, '2019-12-01', '2020-12-31', '2019-12-16 15:54:28', 10000000),
		(9, 5, 'EMPLOYEE', 2, '2019-12-01', '2020-12-31', '2019-12-16 15:54:29', 10000000),
		(10, 6, 'EMPLOYEE', 2, '2019-12-01', '2020-12-31', '2019-12-16 15:54:29', 10000000),
		(11, 2, 'EMPLOYEE', 3, '2019-12-01', '2020-12-31', '2019-12-16 15:54:45', 10000000),
		(12, 3, 'EMPLOYEE', 3, '2019-12-01', '2020-12-31', '2019-12-16 15:54:45', 10000000),
		(13, 4, 'EMPLOYEE', 3, '2019-12-01', '2020-12-31', '2019-12-16 15:54:45', 10000000),
		(14, 5, 'EMPLOYEE', 3, '2019-12-01', '2020-12-31', '2019-12-16 15:54:45', 10000000),
		(15, 6, 'EMPLOYEE', 3, '2019-12-01', '2020-12-31', '2019-12-16 15:54:45', 10000000),
		(16, 2, 'EMPLOYEE', 4, '2019-12-01', '2020-12-31', '2019-12-16 15:55:01', 10000000),
		(17, 3, 'EMPLOYEE', 4, '2019-12-01', '2020-12-31', '2019-12-16 15:55:01', 10000000),
		(18, 4, 'EMPLOYEE', 4, '2019-12-01', '2020-12-31', '2019-12-16 15:55:01', 10000000),
		(19, 5, 'EMPLOYEE', 4, '2019-12-01', '2020-12-31', '2019-12-16 15:55:01', 10000000),
		(20, 6, 'EMPLOYEE', 4, '2019-12-01', '2020-12-31', '2019-12-16 15:55:01', 10000000),
		(21, 2, 'EMPLOYEE', 5, '2019-12-01', '2020-12-31', '2019-12-16 15:55:16', 10000000),
		(22, 3, 'EMPLOYEE', 5, '2019-12-01', '2020-12-31', '2019-12-16 15:55:16', 10000000),
		(23, 4, 'EMPLOYEE', 5, '2019-12-01', '2020-12-31', '2019-12-16 15:55:16', 10000000),
		(24, 5, 'EMPLOYEE', 5, '2019-12-01', '2020-12-31', '2019-12-16 15:55:16', 10000000),
		(25, 6, 'EMPLOYEE', 5, '2019-12-01', '2020-12-31', '2019-12-16 15:55:16', 10000000),
		(26, 2, 'EMPLOYEE', 6, '2019-12-01', '2020-12-31', '2019-12-16 15:55:27', 10000000),
		(27, 3, 'EMPLOYEE', 6, '2019-12-01', '2020-12-31', '2019-12-16 15:55:27', 10000000),
		(28, 4, 'EMPLOYEE', 6, '2019-12-01', '2020-12-31', '2019-12-16 15:55:27', 10000000),
		(29, 5, 'EMPLOYEE', 6, '2019-12-01', '2020-12-31', '2019-12-16 15:55:28', 10000000),
		(30, 6, 'EMPLOYEE', 6, '2019-12-01', '2020-12-31', '2019-12-16 15:55:28', 10000000),
		(31, 8, 'EMPLOYEE', 7, '2019-12-01', '2020-12-31', '2019-12-16 15:56:36', 10000000),
		(32, 9, 'EMPLOYEE', 7, '2019-12-01', '2020-12-31', '2019-12-16 15:56:36', 10000000),
		(33, 10, 'EMPLOYEE', 7, '2019-12-01', '2020-12-31', '2019-12-16 15:56:36', 10000000),
		(34, 11, 'EMPLOYEE', 7, '2019-12-01', '2020-12-31', '2019-12-16 15:56:36', 10000000),
		(35, 12, 'EMPLOYEE', 7, '2019-12-01', '2020-12-31', '2019-12-16 15:56:36', 10000000),
		(36, 8, 'EMPLOYEE', 8, '2019-12-01', '2020-12-31', '2019-12-16 15:57:09', 10000000),
		(37, 9, 'EMPLOYEE', 8, '2019-12-01', '2020-12-31', '2019-12-16 15:57:09', 10000000),
		(38, 10, 'EMPLOYEE', 8, '2019-12-01', '2020-12-31', '2019-12-16 15:57:09', 10000000),
		(39, 11, 'EMPLOYEE', 8, '2019-12-01', '2020-12-31', '2019-12-16 15:57:09', 10000000),
		(40, 12, 'EMPLOYEE', 8, '2019-12-01', '2020-12-31', '2019-12-16 15:57:09', 10000000),
		(41, 13, 'EMPLOYEE', 9, '2019-12-01', '2020-12-31', '2019-12-16 15:57:36', 10000000),
		(42, 14, 'EMPLOYEE', 9, '2019-12-01', '2020-12-31', '2019-12-16 15:57:36', 10000000),
		(43, 15, 'EMPLOYEE', 9, '2019-12-01', '2020-12-31', '2019-12-16 15:57:36', 10000000),
		(44, 16, 'EMPLOYEE', 9, '2019-12-01', '2020-12-31', '2019-12-16 15:57:36', 10000000),
		(45, 17, 'EMPLOYEE', 9, '2019-12-01', '2020-12-31', '2019-12-16 15:57:36', 10000000),
		(46, 13, 'EMPLOYEE', 10, '2019-12-01', '2020-12-31', '2019-12-16 16:00:44', 10000000),
		(47, 14, 'EMPLOYEE', 10, '2019-12-01', '2020-12-31', '2019-12-16 16:00:45', 10000000),
		(48, 15, 'EMPLOYEE', 10, '2019-12-01', '2020-12-31', '2019-12-16 16:00:45', 10000000),
		(49, 16, 'EMPLOYEE', 10, '2019-12-01', '2020-12-31', '2019-12-16 16:00:45', 10000000),
		(50, 17, 'EMPLOYEE', 10, '2019-12-01', '2020-12-31', '2019-12-16 16:00:45', 10000000),
		(51, 18, 'EMPLOYEE', 11, '2019-12-01', '2020-12-31', '2019-12-16 16:01:04', 10000000),
		(52, 19, 'EMPLOYEE', 11, '2019-12-01', '2020-12-31', '2019-12-16 16:01:05', 10000000),
		(53, 20, 'EMPLOYEE', 11, '2019-12-01', '2020-12-31', '2019-12-16 16:01:05', 10000000),
		(54, 21, 'EMPLOYEE', 11, '2019-12-01', '2020-12-31', '2019-12-16 16:01:05', 10000000),
		(55, 22, 'EMPLOYEE', 11, '2019-12-01', '2020-12-31', '2019-12-16 16:01:05', 10000000),
		(56, 18, 'EMPLOYEE', 12, '2019-12-01', '2020-12-31', '2019-12-16 16:01:22', 10000000),
		(57, 19, 'EMPLOYEE', 12, '2019-12-01', '2020-12-31', '2019-12-16 16:01:23', 10000000),
		(58, 20, 'EMPLOYEE', 12, '2019-12-01', '2020-12-31', '2019-12-16 16:01:23', 10000000),
		(59, 21, 'EMPLOYEE', 12, '2019-12-01', '2020-12-31', '2019-12-16 16:01:23', 10000000),
		(60, 22, 'EMPLOYEE', 12, '2019-12-01', '2020-12-31', '2019-12-16 16:01:23', 10000000),
		(61, 18, 'EMPLOYEE', 13, '2019-12-01', '2020-12-31', '2019-12-16 16:01:40', 10000000),
		(62, 19, 'EMPLOYEE', 13, '2019-12-01', '2020-12-31', '2019-12-16 16:01:40', 10000000),
		(63, 20, 'EMPLOYEE', 13, '2019-12-01', '2020-12-31', '2019-12-16 16:01:40', 10000000),
		(64, 21, 'EMPLOYEE', 13, '2019-12-01', '2020-12-31', '2019-12-16 16:01:40', 10000000),
		(65, 22, 'EMPLOYEE', 13, '2019-12-01', '2020-12-31', '2019-12-16 16:01:40', 10000000);",

	"INSERT INTO `attd_timetable_shift` (`timetable_shift_id`, `timetable_id`, `day_no`, `is_workday`, `on_duty_time`, `off_duty_time`, `in_beginning_time`, `in_ending_time`, `out_beginning_time`, `out_ending_time`, `late_time`, `leave_early_time`, `overtime_start_time`, `start_date`, `end_date`) VALUES
		(1, 2, 2, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(2, 3, 3, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(3, 4, 4, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(4, 5, 5, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(5, 6, 6, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(6, 8, 2, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(7, 9, 3, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(8, 10, 4, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(9, 11, 5, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(10, 12, 6, '1', '08:00:00', '17:00:00', '06:00:00', '12:00:00', '16:00:00', '21:00:00', '15', '60', '18:00:00', '2019-12-01', '2020-12-31'),
		(11, 13, 2, '1', '14:00:00', '23:00:00', '13:00:00', '17:00:00', '22:00:00', '23:00:00', '15', '60', '23:00:00', '2019-12-01', '2020-12-31'),
		(12, 14, 3, '1', '14:00:00', '23:00:00', '13:00:00', '17:00:00', '22:00:00', '23:00:00', '15', '60', '23:00:00', '2019-12-01', '2020-12-31'),
		(13, 15, 4, '1', '14:00:00', '23:00:00', '13:00:00', '17:00:00', '22:00:00', '23:00:00', '15', '60', '23:00:00', '2019-12-01', '2020-12-31'),
		(14, 16, 5, '1', '14:00:00', '23:00:00', '13:00:00', '17:00:00', '22:00:00', '23:00:00', '15', '60', '23:00:00', '2019-12-01', '2020-12-31'),
		(15, 17, 6, '1', '14:00:00', '23:00:00', '13:00:00', '17:00:00', '22:00:00', '23:00:00', '15', '60', '23:00:00', '2019-12-01', '2020-12-31'),
		(16, 18, 2, '1', '23:00:00', '08:00:00', '21:00:00', '03:00:00', '07:00:00', '11:00:00', '15', '60', '09:00:00', '2019-12-01', '2020-12-31'),
		(17, 19, 3, '1', '23:00:00', '08:00:00', '21:00:00', '03:00:00', '07:00:00', '11:00:00', '15', '60', '09:00:00', '2019-12-01', '2020-12-31'),
		(18, 20, 4, '1', '23:00:00', '08:00:00', '21:00:00', '03:00:00', '07:00:00', '11:00:00', '15', '60', '09:00:00', '2019-12-01', '2020-12-31'),
		(19, 21, 5, '1', '23:00:00', '08:00:00', '21:00:00', '03:00:00', '07:00:00', '11:00:00', '15', '60', '09:00:00', '2019-12-01', '2020-12-31'),
		(20, 22, 6, '1', '23:00:00', '08:00:00', '21:00:00', '03:00:00', '07:00:00', '11:00:00', '15', '60', '09:00:00', '2019-12-01', '2020-12-31');",

	"INSERT INTO `attendance` (`id`, `type_id`, `start_dtm`, `start_description`, `end_dtm`, `end_description`, `ref_code`, `ref_id`, `source_type_code`, `source_reference`, `source_dtm`, `overtime_start_dtm`, `overtime_end_dtm`, `longitude`, `latitude`) VALUES
		(4, 1, '2019-12-17 15:59:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-17 15:59:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(5, 1, '2019-12-02 07:13:00', 'Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-02 07:13:00', '2019-12-02 18:23:00', '2019-12-02 21:23:00', NULL, NULL),
		(6, 1, '2019-12-02 07:23:00', 'Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-02 07:23:00', '2019-12-02 19:30:00', '2019-12-02 20:30:00', NULL, NULL),
		(7, 1, '2019-12-02 07:23:00', 'Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-02 07:23:00', '2019-12-02 18:39:00', '2019-12-02 19:39:00', NULL, NULL),
		(8, 1, '2019-12-16 06:22:00', ' Bismillah SPJ Jakarta', NULL, NULL, 'EMPLOYEE', 1, 'REQUEST', '9', '2019-12-17 16:35:11', NULL, NULL, NULL, NULL),
		(9, 1, '2019-12-03 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(10, 1, '2019-12-04 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(11, 1, '2019-12-05 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(12, 1, '2019-12-06 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(13, 1, '2019-12-09 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(14, 1, '2019-12-10 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(15, 1, '2019-12-11 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(16, 1, '2019-12-12 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(17, 1, '2019-12-13 08:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 1, 'WEB', '1', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(18, 1, '2019-12-03 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(19, 1, '2019-12-04 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(20, 1, '2019-12-05 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(21, 1, '2019-12-06 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(22, 1, '2019-12-09 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(23, 1, '2019-12-10 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(24, 1, '2019-12-11 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(25, 1, '2019-12-12 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(26, 1, '2019-12-13 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'WEB', '2', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(27, 1, '2019-12-03 08:00:00', 'Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(28, 1, '2019-12-04 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(29, 1, '2019-12-05 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(30, 1, '2019-12-06 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(31, 1, '2019-12-09 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(32, 1, '2019-12-10 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(33, 1, '2019-12-11 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(34, 1, '2019-12-12 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(35, 1, '2019-12-13 08:00:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 3, 'WEB', '3', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(36, 1, '2019-12-02 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-02 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(37, 1, '2019-12-03 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(38, 1, '2019-12-04 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-04 08:00:00', '2019-12-04 18:22:00', '2019-12-04 21:22:00', '107.64050710000001', '-6.9610185'),
		(39, 1, '2019-12-05 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(40, 1, '2019-12-06 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(41, 1, '2019-12-09 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(42, 1, '2019-12-10 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(43, 1, '2019-12-11 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(44, 1, '2019-12-12 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(45, 1, '2019-12-13 08:00:00', ' Bismillah masuk', NULL, NULL, 'EMPLOYEE', 4, 'WEB', '4', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(46, 1, '2019-12-02 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-02 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(47, 1, '2019-12-03 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(48, 1, '2019-12-04 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(49, 1, '2019-12-05 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-05 08:00:00', '2019-12-05 20:26:00', '2019-12-05 21:26:00', '107.64050710000001', '-6.9610185'),
		(50, 1, '2019-12-06 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(51, 1, '2019-12-09 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(52, 1, '2019-12-10 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(53, 1, '2019-12-11 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(54, 1, '2019-12-12 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(55, 1, '2019-12-13 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'WEB', '5', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(56, 1, '2019-12-02 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-02 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(57, 1, '2019-12-03 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-03 08:00:00', '2019-12-03 19:40:00', '2019-12-03 21:40:00', '107.64050710000001', '-6.9610185'),
		(58, 1, '2019-12-04 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(59, 1, '2019-12-05 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(60, 1, '2019-12-06 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(61, 1, '2019-12-09 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(62, 1, '2019-12-10 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(63, 1, '2019-12-11 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(64, 1, '2019-12-12 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(65, 1, '2019-12-13 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 6, 'WEB', '6', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(66, 1, '2019-12-02 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-02 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(67, 1, '2019-12-03 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(68, 1, '2019-12-04 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(69, 1, '2019-12-05 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(70, 1, '2019-12-06 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(71, 1, '2019-12-09 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-09 08:00:00', '2019-12-09 19:48:00', '2019-12-09 22:48:00', '107.64050710000001', '-6.9610185'),
		(72, 1, '2019-12-10 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-10 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(73, 1, '2019-12-11 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(74, 1, '2019-12-12 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(75, 1, '2019-12-13 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'WEB', '7', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(76, 1, '2019-12-02 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-02 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(77, 1, '2019-12-03 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-03 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(78, 1, '2019-12-04 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-04 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(79, 1, '2019-12-05 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-05 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(80, 1, '2019-12-06 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-06 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(81, 1, '2019-12-09 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-09 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(82, 1, '2019-12-10 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-10 08:00:00', '2019-12-10 21:51:00', '2019-12-18 22:51:00', '107.64050710000001', '-6.9610185'),
		(83, 1, '2019-12-11 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-11 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(84, 1, '2019-12-12 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-12 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(85, 1, '2019-12-13 08:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 8, 'WEB', '8', '2019-12-13 08:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(86, 1, '2019-12-02 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-02 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(87, 1, '2019-12-03 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-03 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(88, 1, '2019-12-04 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-04 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(89, 1, '2019-12-05 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-05 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(90, 1, '2019-12-06 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-06 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(91, 1, '2019-12-09 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-09 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(92, 1, '2019-12-10 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-10 14:00:00', '2019-12-10 23:56:00', '2019-12-11 01:56:00', '107.64050710000001', '-6.9610185'),
		(93, 1, '2019-12-11 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-11 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(94, 1, '2019-12-12 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-12 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(95, 1, '2019-12-02 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-02 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(96, 1, '2019-12-03 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-03 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(97, 1, '2019-12-04 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-04 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(98, 1, '2019-12-05 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-05 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(99, 1, '2019-12-06 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-06 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(100, 1, '2019-12-09 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-09 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(101, 1, '2019-12-10 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-10 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(102, 1, '2019-12-11 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-11 14:00:00', '2019-12-11 23:02:00', '2019-12-12 01:02:00', '107.64050710000001', '-6.9610185'),
		(103, 1, '2019-12-12 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-12 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(104, 1, '2019-12-13 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 10, 'WEB', '10', '2019-12-13 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(105, 1, '2019-12-13 14:00:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 9, 'WEB', '9', '2019-12-13 14:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(106, 1, '2019-12-02 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-02 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(107, 1, '2019-12-03 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-03 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(108, 1, '2019-12-04 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-04 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(109, 1, '2019-12-05 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-05 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(110, 1, '2019-12-06 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-06 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(111, 1, '2019-12-09 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-09 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(112, 1, '2019-12-10 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-10 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(113, 1, '2019-12-11 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-12 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(114, 1, '2019-12-13 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-13 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(115, 1, '2019-12-02 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-02 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(116, 1, '2019-12-03 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-03 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(117, 1, '2019-12-04 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-04 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(118, 1, '2019-12-05 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-05 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(119, 1, '2019-12-06 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-06 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(120, 1, '2019-12-09 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-09 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(121, 1, '2019-12-10 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-10 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(122, 1, '2019-12-11 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-12 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(123, 1, '2019-12-13 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-13 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(124, 1, '2019-12-02 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-02 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(125, 1, '2019-12-03 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-03 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(126, 1, '2019-12-04 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-04 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(127, 1, '2019-12-05 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-05 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(128, 1, '2019-12-06 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-06 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(129, 1, '2019-12-09 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-09 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(130, 1, '2019-12-10 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-10 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(131, 1, '2019-12-11 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-11 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(132, 1, '2019-12-12 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-12 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(133, 1, '2019-12-13 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 13, 'WEB', '13', '2019-12-13 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(134, 1, '2019-12-12 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 11, 'WEB', '11', '2019-12-12 23:00:00', NULL, NULL, '107.64050710000001', '-6.9610185'),
		(135, 1, '2019-12-12 23:00:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 12, 'WEB', '12', '2019-12-12 23:00:00', '2019-12-12 10:17:00', '2019-12-12 12:17:00', '107.64050710000001', '-6.9610185'),
		(136, 1, '2019-12-16 08:29:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 2, 'REQUEST', '12', '2019-12-18 09:14:30', NULL, NULL, NULL, NULL),
		(137, 1, '2019-12-16 08:38:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 3, 'REQUEST', '15', '2019-12-18 09:16:36', NULL, NULL, NULL, NULL),
		(138, 1, '2019-12-17 07:17:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 4, 'REQUEST', '18', '2019-12-18 09:36:47', NULL, NULL, NULL, NULL),
		(139, 1, '2019-12-17 07:38:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 6, 'REQUEST', '24', '2019-12-18 09:44:28', NULL, NULL, NULL, NULL),
		(140, 1, '2019-12-17 07:26:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 5, 'REQUEST', '21', '2019-12-18 09:44:47', NULL, NULL, NULL, NULL),
		(141, 1, '2019-12-17 07:47:00', ' Hadir', NULL, NULL, 'EMPLOYEE', 7, 'REQUEST', '27', '2019-12-18 09:53:05', NULL, NULL, NULL, NULL),
		(142, 1, '2019-12-17 13:55:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 9, 'REQUEST', '33', '2019-12-18 09:59:25', NULL, NULL, NULL, NULL),
		(143, 1, '2019-12-17 07:50:00', ' Masuk', NULL, NULL, 'EMPLOYEE', 8, 'REQUEST', '30', '2019-12-18 09:59:46', NULL, NULL, NULL, NULL),
		(144, 1, '2019-12-16 14:01:00', ' Bismillah', NULL, NULL, 'EMPLOYEE', 10, 'REQUEST', '35', '2019-12-18 10:12:48', NULL, NULL, NULL, NULL);
	",

	

	"CREATE TABLE `attd_details` (
		`attd_detail_id` int(11) NOT NULL AUTO_INCREMENT,
		`attendance_id` int(11) NOT NULL,
		`timetable_id` int(11) NOT NULL,
		`attd_in_out` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = in; 2 = out',
		`ip_address` varchar(32) DEFAULT NULL,
		`geocode_location` text,
		PRIMARY KEY (`attd_detail_id`),
		KEY `fk_attddet_attd_idx` (`attendance_id`),
		KEY `fk_attddet_timetable_idx` (`timetable_id`),
		CONSTRAINT `fk_attddet_attd` FOREIGN KEY (`attendance_id`) REFERENCES `attendance` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
		CONSTRAINT `fk_attddet_timetable` FOREIGN KEY (`timetable_id`) REFERENCES `attd_timetable` (`timetable_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB DEFAULT CHARSET=latin1;",


	# data yang dibutuhkan untuk integrasi ke module order [BEGIN]
		
		// order type
		"INSERT INTO `order_types` (`order_type_id`, `name`, `description`) VALUES
		(2100, 'Attendance', 'used by Approval modules');",

		// order subtype
		"INSERT INTO `order_subtypes` (`order_subtype_id`, `name`, `description`, `order_type_id`) VALUES
		(2101, 'Attendance', 'used by Approval modules', 2100),
		(2102, 'Overtime', 'used by Approval modules', 2100),
		(2103, 'Change Shift', 'used by Approval modules', 2100);",

		// approval request type map
		"INSERT INTO `app_request_type_map` (`type_id`, `order_type_id`, `setting_id`, `start_date`, `end_date`) VALUES
		(1, 2101, 1, '2020-08-06', NULL),
		(2, 2102, 1, '2020-10-06', NULL),
		(3, 2103, 1, '2020-10-06', NULL);",

		// approval request setting
		"INSERT INTO `app_request_setting` (`setting_id`, `setting_name`, `num_to_approve`, `min_approved`, `min_rejected`, `status`, `document_flag`, `notification_flag`, `sequential`, `direct_reject`) VALUES
		(1, 'Default', 3, 2, 1, 1, 1, 1, 1, 'N'),
		(2, 'Custom', 2, 2, 1, 1, 1, 1, 1, 'N'),
		(5, 'Attendance', 3, 2, 2, 1, 1, 1, 0, 'N'),
		(7, 'Overtime', 2, 2, 1, 1, 0, 1, 0, 'N'),
		(8, 'ChangeShift', 1, 1, 1, -1, 0, 0, 0, 'N');",

	# data yang dibutuhkan untuk integrasi ke module order [END]

	## create table upload shift
	"CREATE TABLE `attd_upload_shift` (
		`upload_file_shift_id` int(11) NOT NULL AUTO_INCREMENT,
		`file_name` varchar(255) NOT NULL,
		`file_path` varchar(255) NOT NULL,
		`total_data` int(11) DEFAULT NULL,
		`total_success` int(11) DEFAULT NULL,
		`total_failed` int(11) DEFAULT NULL,
		`status` varchar(45) NOT NULL COMMENT '0: Inisialisasi, 1: On progress, 2: Success, 3: Error',
		`upload_dtm` datetime NOT NULL,
		`upload_by` varchar(32) NOT NULL,
		PRIMARY KEY (`upload_file_shift_id`)
	) ENGINE=InnoDB AUTO_INCREMENT=935 DEFAULT CHARSET=latin1",
	
	"CREATE TABLE `attd_upload_shift_detail` (
		`detail_id` int(11) NOT NULL AUTO_INCREMENT,
		`upload_file_shift_id` int(11) NOT NULL,
		`employee_code` varchar(45) NOT NULL,
		`name` varchar(100) NOT NULL,
		`timetable_code` varchar(45) DEFAULT NULL,
		`date` date DEFAULT NULL,
		`status` varchar(45) DEFAULT NULL COMMENT '0: Inisialisasi, 1: On progress, 2: Success, 3: Error (Tidak Ada Shift), 4: Error (Sudah ada absensi pada shift existing)',
		`schedule_start` timestamp NULL DEFAULT NULL,
		`schedule_end` timestamp NULL DEFAULT NULL,
		PRIMARY KEY (`detail_id`)
	) ENGINE=InnoDB AUTO_INCREMENT=541329 DEFAULT CHARSET=latin1",
	##


);