<?php
namespace Neuron\Attendance\Timetable\Changeshift\Storage;

use Neuron\Attendance\Timetable\Changeshift;

class Mysql extends \Neuron\Db\Storage implements Skeleton {
    
    public function loadList($id = null, $mode = Changeshift\Storage::LIST_ALL,$params = array()){
        // Base select
        $select = $this->select();
        $select->from(
            array('ta' => $this->_tables['attd_timetable_object_chshift'])
        );

        if($mode == Changeshift\Storage::LISTBY_PAGE){
            $pager = new \Neuron\Db\Storage\Pager($params);
            $select->limit($pager->getLimit(),$pager->getOffset())->cache(0);
        }else{

            $pager = new \Neuron\Db\Storage\Pager(1,99999999);
            if(isset($params['page']) && isset($params['records'])){
                $pager = new \Neuron\Db\Storage\Pager($params);
                $select->limit($pager->getLimit(),$pager->getOffset())->cache(0);
            }
            switch ($mode) {
                case Changeshift\Storage::LISTBY_ID:
                    $select->where($this->__(array('ticket_Changeshift_id' => $id)));
                    break;
                case Changeshift\Storage::LISTBY_DATE:
                    $select->where(
                        array(
                            'start_date >= "'.$params['date'].'"',
                            'end_date <= "'.$params['date'].'"'
                        )
                    );
                    break;
            }

        }

        try{
            if($rows = $this->fetchAll($select)){
                $result = new \stdClass();
                $result->list = $rows;
                $result->pager = $pager;
                $result->countTotal = $rows->total;
                return $result;
            }

            return false;
        }catch(\Exception $ex){
            error_log('Error at : '.$ex->getFile().' Line : '.$ex->getLine(). ' : '. $ex->getMessage());
            return false;
        }
    }

    public function save(Changeshift $changeshift,$update = false){
        try{
            if($update){
                $update = $this->update();
                $update->table($this->_tables['attd_timetable_object_chshift']);
                $update->where($this->__(array('tt_employee_shift_id' => $changeshift->id)));
                $update->set($this->__($changeshift->pull()));
                if($this->execute($update)){
                    return $changeshift->id;
                }
            }else{
                $changeshift->id = 0;
                $insert = $this->insert();
                $insert->into($this->_tables['attd_timetable_object_chshift']);
                $insert->autoincrement($this->__('tt_employee_shift_id'));
                $insert->values($this->__($changeshift->pull()));
                if($id = $this->execute($insert)){
                    $changeshift->id = $id;
                    return $changeshift->id;
                }
            }
        }catch(\Exception $ex){
            error_log('Error at : '.$ex->getFile().' Line : '.$ex->getLine().' : '.$ex->getMessage());
            return false;
        }
    }
    public function load($id = null, $mode = Changeshift\Storage::LOADBY_ID , $params = array()){
        $select = $this->select();
        $select->from($this->_tables['attd_timetable_object_chshift']);

        switch ($mode) {
            case Changeshift\Storage::LOADBY_ID:
                $select->where($this->__(array('tt_employee_shift_id' => $id)));
                break;
            case Changeshift\Storage::LOADBY_REC_ID:
                $select->where($this->__(array('recommendation_id' => $id)));
                break;
            case Changeshift\Storage::LOADBY_REFID_CHANGEDATE:
                $select->where(array(
                    'ref_id'                => $params['ref_id'],
                    'shift_change_date'     => date('Y-m-d',strtotime($params['shift_change_date']))
                ));
        }

        // echo str_replace('"','',$select->getSqlString())."<br />"; die();

        try{
            $data = $this->fetchRow($select);
            return $data;
        }catch(\Exception $ex){
            error_log('Error at : '.$ex->getFile().' Line : '.$ex->getLine(). ' : '. $ex->getMessage());
            return false;
        }
    }

    public function deleteRow($id = null ,$mode = Object\Storage::DELETEBY_ID){
        $delete = $this->delete();
        $delete->from($this->_tables['ticket_objects']);
        switch ($mode) {
            case Object\Storage::DELETEBY_ID:
                $delete->where($this->__(array('ticket_object_id' => $id)));
                break;
        }
        try{
            if($this->execute($delete)){
                return $id;
            }
        }catch(\Exception $ex){
            error_log('Error at : '.$ex->getFile().' Line : '.$ex->getLine(). ' : '. $ex->getMessage());
            return false;
        }
    }

}