<?php
namespace Neuron\Attendance\Timetable\Group;


use Neuron\Generic\Result;

class Members extends \Neuron\Generic\Set{
	protected $_storage;

	public function __construct(Member\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null, $mode = Member\Storage::LIST_ALL ,$params = array()){
		$result = new Result();
		$list = array();

		if($rows = $this->_storage->loadList($id,$mode,$params)){
			$this->clear();
			if($rows->countTotal > 0){
				foreach ($rows->list as $row) {
					$row = array_change_key_case($row);
					$member = new Member($this->_storage);
					$member->push($row);
					$this->add($member);
					$list[] = $row;
				}
			}
		}
		
		if(!class_exists('\Neuron\Employee\Entity')){
			$list = $this->addRefName($list);
		}

		if(count($list) > 0){
			$result->data = array(
				'list' => $list,
				'countTotal' => $rows->countTotal
			);
		}else{
			$result->code = 1;
			$result->info = 'Shift Members load none';
		}
		return $result;
	}

	public function addRefName($rows){
		$config['tables'] = $this->_storage->getTables();
		if(class_exists('Neuron\Employee\Entity')){
			$employee = new \Neuron\Employee\Entity(\Neuron\Employee\Entity\Storage::factory(
				$this->_storage->getAdapter(), array('tables' => $this->_storage->getTables())	
			));
            $dataEmp = $employee->detailEmp();
            $employee = $dataEmp['data'];
		}else{
			$employee = array();
		}

		// looping passed rows
		$list = array();
		foreach ($rows as $row) {
			// find the match ref_id with employee
				foreach ($employee as $empRow) {
					if($empRow['id'] == $row['ref_id']){
						$ref_name = $empRow['first_name'].' '.$empRow['last_name'];
						break;
					}else{
						$ref_name = 'References ID not found.';
					}
				}
				$row['ref_name'] = $ref_name;

			$list[] = $row;
		}

		return $list;
	}
}