<?php
namespace Neuron\Attendance\Timetable\Group;


use Neuron\Generic\Result;

class Timetables extends \Neuron\Generic\Set{
	protected $_storage;

	public function __construct(Timetable\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null, $mode = Timetable\Storage::LIST_ALL ,$params = array()){
		$result = new Result();
		$list = array();

		if($rows = $this->_storage->loadList($id,$mode,$params)){
			$this->clear();
			if($rows->countTotal > 0){
				foreach ($rows->list as $row) {
					$row = array_change_key_case($row);
					$agent = new Timetable($this->_storage);
					$agent->push($row);
					$this->add($agent);
					$list[] = $agent->pull();
				}
			}
		}

		if(count($list) > 0){
			$result->data = array(
				'list' => $list,
				'countTotal' => $rows->countTotal,
				'pager' => $rows->pager);
		}else{
			$result->code = 1;
			$result->info = 'Shift Timetables load none';
		}
		return $result;
	}

	public function filterList($params = array()){
		$result = new Result();
		$list = array();

		if($rows = $this->_storage->filterList($params)){
			$this->clear();
			if($rows->countTotal > 0){
				foreach ($rows->list as $row) {
					array_push($list, $row);
				}
			}
		}

		if(count($list) > 0){
			$result->data = array(
				'list' => $list,
				'countTotal' => $rows->countTotal,
				'pager' => $rows->pager);
		}else{
			$result->code = 1;
			$result->info = 'Shift Timetables load none';
		}
		return $result;
	}
}