<?php
namespace Neuron\Attendance\Timetable;


use Neuron\Generic\Result;

class Groups extends \Neuron\Generic\Set{
	protected $_storage;

	public function __construct(Group\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null, $mode = Group\Storage::LIST_ALL ,$params = array()){
		$result = new Result();
		$list = array();

		if($rows = $this->_storage->loadList($id,$mode,$params)){
			$this->clear();
			if($rows->countTotal > 0){
				foreach ($rows->list as $row) {
					$row = array_change_key_case($row);
					$agent = new Group($this->_storage);
					$agent->push($row);
					$this->add($agent);
					$list[] = $agent->pull();
				}
			}
		}

		if(count($list) > 0){
			$result->data = array(
				'list' => $list,
				'countTotal' => $rows->countTotal,
				'pager' => $rows->pager);
		}else{
			$result->code = 1;
			$result->info = 'Shift Groups load none';
		}
		return $result;
	}
	public function loadDataTable($post){
		$data = $this->_storage->loadDataTable($post);

		$list = array();
		if($data['rows']){
			foreach ($data['rows'] as $rows) {
				$list[] = $rows;
			}
		}
		$dataTable = array(
			'draw' => $post['draw'],
			'data' => $list,
			'recordsTotal' => intval($data['countRows']),
			'recordsFiltered' => intval($data['countRows'])
		);
		return $dataTable;
	}
}