<?php
namespace Neuron\Attendance\Timetable;

use Neuron\Generic\Entity\Mapper;
use Neuron\Generic\Entity\Map;
use Neuron\Generic\Result;

class Object extends Mapper{
    protected $_storage;

    public function __construct(\Neuron\Timetable\Objects\Storage\Skeleton $storage,$data = array()){
        $this->_storage = $storage;

        parent::__construct(
            $data,
            array(
                new Map('timetable_object_id'),
                new Map('timetable_id'),
                new Map('ref_code'),
                new Map('ref_id'),
                new Map('start_date'),
                new Map('end_date'),
                new Map('last_update'),
                new Map('update_by')
            ),
            parent::CASE_INSENSITIVE
        );
    }

    public function load($id = null, $mode = Objects\Storage::LOADBY_ID,$data = array()){
        $result     = new Result;
        $res        = $this->_storage->load($id,$mode,$data);

        if ($res) {
            $result->code = 0;
            $result->info = 'ok';
            $result->data = $res;
        } else {
            $result->code = 401;
            $result->info = 'failed';
        }

        return $result;
    }
}