<?php 
namespace Neuron\Attendance\Timetable\Upload;

use Neuron\Generic\Entity\Map;
use Neuron\Generic\Result;

class Detail extends \Neuron\Generic\Entity\Mapper {
    protected $_storage;
    protected $_loaded = false;

    const ERROR_PREFIX = 'Attendance';
    const DUMMY_SESSOWNER = 10000;

	public function __construct(\Neuron\Attendance\Timetable\Upload\Detail\Storage\Skeleton $storage, $data= array()) {
			
        $this->_storage = $storage;

		parent::__construct(
	        $data, 
	        array(
                new Map('detail_id'),
                new Map('upload_file_shift_id'),
                new Map('employee_code'),
                new Map('name'),
                new Map('timetable_code'),
                new Map('date'),
                new Map('status'),
                new Map('schedule_start'),
                new Map('schedule_end'),
	        ), 
	        parent::CASE_INSENSITIVE
	    );
    }

    public function load($id, $mode = \Neuron\Attendance\Timetable\Upload\Detail\Storage::LOADBY_ID){
        /* load dari storage */
        if ($data = $this->_storage->load($id, $mode)) {

            /* load sukses, set data properti class dari hasil query */
            $this->push($data);

            /* set loaded */
            $this->_loaded = true;
            return true;

        } else {
            $this->_loaded = false;
        }
        return false;
    }

    public function save($update = false)
    {
        /* simpan via storage */
        if ($id = $this->_storage->save($this, $update)) {

            /* simpan sukses, ambil id yg tersimpan, return true */
            $this->detail_id = $id;
            return true;
        }
        return false;
    }

    public function create($update)
    {
        $result = new Result();
        if($this->save($update)){
            $result->info = 'Success save temp Attendance\Timetable detail';
            $result->data = $this->detail_id;
        }else{
            $result->code  = self::ERROR_PREFIX."311";
            $result->info = 'Failed save temp Attendance\Timetable detail';
            $result->data = null;
        }
        return $result;
    }

    public function remove($id, $mode = \Neuron\Attendance\Timetable\Upload\Detail\Storage::DELETEBY_ID)
    {
        $result = new Result();
        if($this->_storage->terminate($id, $mode)){
            $result->info = 'Success terminate tax config';
            $result->data = $id;
        }else{
            $result->code  = self::ERROR_PREFIX."312";
            $result->info = 'Failed terminate tax config';
            $result->data = null;
        }
        return $result;
    }
}