<?php 
namespace Neuron\Attendance\Timetable\Upload;

use Neuron\Attendance\Timetable\Upload;
use Neuron\Attendance\Timetable\Upload\Detail;
use Neuron\Generic\Result;


class Details extends \Neuron\Generic\Set {
    protected $_storage;

    public function __construct(Detail\Storage\Skeleton $storage) {

        $this->_storage = $storage;
    }

    public function load($id = null, $mode = Detail\Storage::LIST_ALL, $params = array()) {
        $result = new \Neuron\Generic\Result();

        /* clear list */
        $this->clear();

        $listStatus = [
            0=>'Inisialisasi', 
            1=>"On progress", 
            2=> "Success", 
            3=> "Error (Tidak Ada Shift)", 
            4=> "Error (Sudah ada absensi pada shift existing)",
            5=> "Error (TIdak ada Employee)"
        ];

        if ($rs = $this->_storage->loadList($id, $mode, $params)) {
        
            if ($rows = $rs->list) {
                $list = array();
                foreach ($rows as $row) {   
                    /* for issue oracle */
                    $row = array_change_key_case($row);
                    unset($row['b_rownum']);

                    /* for issue sqlserver */
                    unset($row['__zend_row_number']);
                                        
                    /* new component */
                    $detail = new Detail($this->_storage);
                    $detail->push($row);
                    $this->add($detail);
                    $row['employee_name'] = $row['name'];
                    $row['description'] = $listStatus[$row['status']];
                    $list[] = $row;
                }
                    
                $result->data = array(
                    'pager' => $rs->pager,
                    'list' => $list,
                    'countTotal' => $rs->countTotal,
                );
                
            } else {
                $result->code = 2;
                $result->info = 'users_load_none';
            }

        } else {
            $result->code = 1;
            $result->info = 'users_load_notfound';
        }
        return $result;
    }

    public function count($params = array())
    {
        $result = new Result();
        if($counter =  $this->_storage->count($params)){
            $result->info = 'Success load counter';
            $result->data = $counter;
        }else{
            $result->code  = 312;
            $result->info = 'Failed load counter';
            $result->data = 0;
        }
        return $result;
    }
}
?>