<?php 
namespace Neuron\Attendance\Timetable;

use Neuron\Attendance\Timetable\Upload;
use Neuron\Attendance\Timetable\Upload\Attendance\Timetable;


class Uploads extends \Neuron\Generic\Set {
    protected $_storage;

    public function __construct(Upload\Storage\Skeleton $storage) {

        $this->_storage = $storage;
    }

    public function load($id = null, $mode = Upload\Storage::LIST_ALL, $params = array()) {
        $result = new \Neuron\Generic\Result();

        /* clear list */
        $this->clear();

        if ($rs = $this->_storage->loadList($id, $mode, $params)) {
        
            if ($rows = $rs->list) {
                $list = array();
                foreach ($rows as $row) {   
                    /* for issue oracle */
                    $row = array_change_key_case($row);
                    unset($row['b_rownum']);

                    /* for issue sqlserver */
                    unset($row['__zend_row_number']);
                                        
                    /* new component */
                    $component = new Upload($this->_storage);

                    //load berhasil sama gagal dulu
                    $storage = \Neuron\Attendance\Timetable\Upload\Detail\Storage::factory($this->_storage->getAdapter(), $this->_storage->getConfig());
                    $details = new \Neuron\Attendance\Timetable\Upload\Details($storage);
                    $countFailed = $details->count(['filter_status'=> [3,4,5], 'upload_file_shift_id'=> $row['upload_file_shift_id']]);

                    $storage = \Neuron\Attendance\Timetable\Upload\Detail\Storage::factory($this->_storage->getAdapter(), $this->_storage->getConfig());
                    $details = new \Neuron\Attendance\Timetable\Upload\Details($storage);
                    $countSuccess = $details->count(['filter_status'=> 2, 'upload_file_shift_id'=> $row['upload_file_shift_id']]);

                    $row['success'] = $countSuccess->data;
                    $row['failed'] = $countFailed->data;

                    
                    $component->push($row);
                    $this->add($component);
                    $list[] = $row;
                }
                    
                $result->data = array(
                    'pager' => $rs->pager,
                    'list' => $list,
                    'countTotal' => $rs->countTotal,
                );
                
            } else {
                $result->code = 2;
                $result->info = 'uploads_load_none';
            }

        } else {
            $result->code = 1;
            $result->info = 'uploads_load_notfound';
        }
        return $result;
    }

}
?>