<?php
namespace Neuron\Attendance;


use Neuron\Generic\Result;

class Timetables extends \Neuron\Generic\Set{
	protected $_storage;

	public function __construct(Timetable\Storage\Skeleton $storage){
		$this->_storage = $storage;
	}

	public function load($id = null, $mode = Timetable\Storage::LIST_ALL ,$params = array()){
		$result = new Result();
		$list = array();
		$shift 		= new Shift(
			Shift\Storage::factory(
				$this->_storage->getAdapter(),
				$this->_storage->getConfig()
			)
		);

		if($rows = $this->_storage->loadList($id,$mode,$params)){
			$this->clear();
			if($rows->countTotal > 0){
				foreach ($rows->list as $row) {
					$row = array_change_key_case($row);
					$timetable = new Timetable($this->_storage);
					@$timetable->push($row);
					$this->add($timetable);
					$row['day_name'] 	= $shift->getDayName($row['day_no']);
					$list[] = $row;
				}
			}
		}

		if(count($list) > 0){
			$result->data = array(
				'list' => $list,
				'countTotal' => $rows->countTotal,
				'pager' => $rows->pager);
		}else{
			$result->code = 1;
			$result->info = 'Timetables load none';
		}
		return $result;
	}
}