<?php
namespace Neuron\Attendance\v2\Timetable;

use Neuron\Generic\Entity\Map;
use Neuron\Generic\Result;

class Obj extends \Neuron\Generic\Entity\Mapper {

    protected $_storage;

    public function __construct(Obj\Storage\Skeleton $storage,$data = array()) {

        /* simpan storage */
        $this->_storage = $storage;

        /* map properti ke tabel */
        parent::__construct(
            $data,
            array(
                new Map('timetable_object_id'),
                new Map('timetable_id'),
                new Map('ref_code'),
                new Map('ref_id'),
                new Map('start_date'),
                new Map('end_date'),
                new Map('last_update'),
                new Map('update_by'),
            ),
            parent::CASE_INSENSITIVE
        );
    }

    public function load($id, $mode = Calendar\Storage::LOADBY_ID) {

        /* query */
        if ($data = $this->_storage->load($date, $id, $mode)) {
            
            $this->push($data);

            /* berhasil */
            return $this->id;
        }

        /* default gagal */
        return false;
    }

    public function save($update = false) {

        /* simpan */
        if ($id = $this->_storage->save($this, $update)) {

            /* set id */
            $this->id = $id;
            return $id;
        }

        /* return hasil */
        return false;
    }
}
