<?php
namespace Neuron\Attendance\v2\Timetable\Obj;

use Zend\Db\Adapter\Adapter;
use Zend\Db\Adapter\Driver\Oci8\Oci8;

class Storage
{
    const LIST_ALL = 0;
    const LISTBY_REFID = 1;
    
    const LOADBY_ID = 0;
    const LOADBY_PAGE = 2;

    public static function factory(Adapter $adapter, $config = [])
    {
        /* Oracle? Buat storage Oci8, selain itu pakai MySQL */
        if ($adapter->getDriver() instanceof Oci8) {
            return new Storage\Oci8($adapter, $config);
        } else {
            $driverName = $adapter->getDriver()->getConnection()->getDriverName();
            if(strtolower($driverName) == 'pgsql'){
                return new Storage\Pgsql($adapter, $config);
            } else if(strtolower($driverName) == 'sqlsrv'){
                return new Storage\Sqlsrv($adapter, $config);
            } else {
                return new Storage\Mysql($adapter, $config);
            }
        }
        return new Storage\Mysql($adapter, $config);
    }
}
